#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 486
#define SYMBOL_COUNT 96
#define ALIAS_COUNT 0
#define TOKEN_COUNT 51
#define EXTERNAL_TOKEN_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 8

enum {
  anon_sym_fun = 1,
  anon_sym_var = 2,
  anon_sym_let = 3,
  anon_sym_COLON = 4,
  anon_sym_EQ = 5,
  anon_sym_when = 6,
  anon_sym_LPAREN = 7,
  anon_sym_RPAREN = 8,
  anon_sym_LBRACE = 9,
  anon_sym_RBRACE = 10,
  anon_sym_for = 11,
  anon_sym_in = 12,
  anon_sym_while = 13,
  anon_sym_return = 14,
  anon_sym_COMMA = 15,
  anon_sym_else = 16,
  anon_sym_LBRACK = 17,
  anon_sym_DOT_DOT_DOT = 18,
  anon_sym_DOT_DOT_LT = 19,
  anon_sym_RBRACK = 20,
  anon_sym_LT = 21,
  anon_sym_LT_EQ = 22,
  anon_sym_GT = 23,
  anon_sym_GT_EQ = 24,
  anon_sym_EQ_EQ = 25,
  anon_sym_BANG_EQ = 26,
  anon_sym_PLUS = 27,
  anon_sym_DASH = 28,
  anon_sym_STAR = 29,
  anon_sym_SLASH = 30,
  anon_sym_PERCENT = 31,
  anon_sym_as = 32,
  anon_sym_BANG = 33,
  anon_sym_bool = 34,
  anon_sym_string = 35,
  anon_sym_int8 = 36,
  anon_sym_int16 = 37,
  anon_sym_int32 = 38,
  anon_sym_int64 = 39,
  anon_sym_uint8 = 40,
  anon_sym_uint16 = 41,
  anon_sym_uint32 = 42,
  anon_sym_uint64 = 43,
  anon_sym_float32 = 44,
  anon_sym_float64 = 45,
  anon_sym_true = 46,
  anon_sym_false = 47,
  aux_sym_identifier_token1 = 48,
  aux_sym_number_token1 = 49,
  sym_eol = 50,
  sym_source_file = 51,
  sym__declaration = 52,
  sym_function_declaration = 53,
  sym_variable_declaration = 54,
  sym__statement = 55,
  sym_when_statement = 56,
  sym_for_statement = 57,
  sym_while_statement = 58,
  sym_block_statement = 59,
  sym_return_statement = 60,
  sym_else_result = 61,
  sym_clause_result = 62,
  sym_clause_list = 63,
  sym_expression_statement = 64,
  sym__expression = 65,
  sym_assignment = 66,
  sym_function_call = 67,
  sym_argument_list = 68,
  sym_range_literal = 69,
  sym_comparison_expression = 70,
  sym_addition_expression = 71,
  sym_multiplication_expression = 72,
  sym_cast_expression = 73,
  sym_unary_expression = 74,
  sym__type = 75,
  sym_primitive_type = 76,
  sym_list_type = 77,
  sym_map_type = 78,
  sym_primary = 79,
  sym_bool_literal = 80,
  sym_function_literal = 81,
  sym_parameter_list = 82,
  sym_parameter = 83,
  sym_type_list = 84,
  sym_list_literal = 85,
  sym_map_literal = 86,
  sym_parenthetical_expression = 87,
  sym_identifier = 88,
  sym_number = 89,
  aux_sym_source_file_repeat1 = 90,
  aux_sym_return_statement_repeat1 = 91,
  aux_sym_clause_list_repeat1 = 92,
  aux_sym_parameter_list_repeat1 = 93,
  aux_sym_type_list_repeat1 = 94,
  aux_sym_map_literal_repeat1 = 95,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_fun] = "fun",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_COLON] = ":",
  [anon_sym_EQ] = "=",
  [anon_sym_when] = "when",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_return] = "return",
  [anon_sym_COMMA] = ",",
  [anon_sym_else] = "else",
  [anon_sym_LBRACK] = "[",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_DOT_DOT_LT] = "..<",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_as] = "as",
  [anon_sym_BANG] = "!",
  [anon_sym_bool] = "bool",
  [anon_sym_string] = "string",
  [anon_sym_int8] = "int8",
  [anon_sym_int16] = "int16",
  [anon_sym_int32] = "int32",
  [anon_sym_int64] = "int64",
  [anon_sym_uint8] = "uint8",
  [anon_sym_uint16] = "uint16",
  [anon_sym_uint32] = "uint32",
  [anon_sym_uint64] = "uint64",
  [anon_sym_float32] = "float32",
  [anon_sym_float64] = "float64",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [aux_sym_identifier_token1] = "identifier_token1",
  [aux_sym_number_token1] = "number_token1",
  [sym_eol] = "eol",
  [sym_source_file] = "source_file",
  [sym__declaration] = "_declaration",
  [sym_function_declaration] = "function_declaration",
  [sym_variable_declaration] = "variable_declaration",
  [sym__statement] = "_statement",
  [sym_when_statement] = "when_statement",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_block_statement] = "block_statement",
  [sym_return_statement] = "return_statement",
  [sym_else_result] = "else_result",
  [sym_clause_result] = "clause_result",
  [sym_clause_list] = "clause_list",
  [sym_expression_statement] = "expression_statement",
  [sym__expression] = "_expression",
  [sym_assignment] = "assignment",
  [sym_function_call] = "function_call",
  [sym_argument_list] = "argument_list",
  [sym_range_literal] = "range_literal",
  [sym_comparison_expression] = "comparison_expression",
  [sym_addition_expression] = "addition_expression",
  [sym_multiplication_expression] = "multiplication_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_unary_expression] = "unary_expression",
  [sym__type] = "_type",
  [sym_primitive_type] = "primitive_type",
  [sym_list_type] = "list_type",
  [sym_map_type] = "map_type",
  [sym_primary] = "primary",
  [sym_bool_literal] = "bool_literal",
  [sym_function_literal] = "function_literal",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter] = "parameter",
  [sym_type_list] = "type_list",
  [sym_list_literal] = "list_literal",
  [sym_map_literal] = "map_literal",
  [sym_parenthetical_expression] = "parenthetical_expression",
  [sym_identifier] = "identifier",
  [sym_number] = "number",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_return_statement_repeat1] = "return_statement_repeat1",
  [aux_sym_clause_list_repeat1] = "clause_list_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_type_list_repeat1] = "type_list_repeat1",
  [aux_sym_map_literal_repeat1] = "map_literal_repeat1",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_fun] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_when] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int64] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint64] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float64] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_identifier_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_number_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_eol] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_when_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_block_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_result] = {
    .visible = true,
    .named = true,
  },
  [sym_clause_result] = {
    .visible = true,
    .named = true,
  },
  [sym_clause_list] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_function_call] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_range_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_comparison_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_addition_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_multiplication_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [sym_list_type] = {
    .visible = true,
    .named = true,
  },
  [sym_map_type] = {
    .visible = true,
    .named = true,
  },
  [sym_primary] = {
    .visible = true,
    .named = true,
  },
  [sym_bool_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_function_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type_list] = {
    .visible = true,
    .named = true,
  },
  [sym_list_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_map_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthetical_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_return_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_clause_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_map_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(3);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == ')')
        ADVANCE(5);
      if (lookahead == '*')
        ADVANCE(6);
      if (lookahead == '+')
        ADVANCE(7);
      if (lookahead == ',')
        ADVANCE(8);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == '.')
        ADVANCE(10);
      if (lookahead == '/')
        ADVANCE(11);
      if (lookahead == ':')
        ADVANCE(12);
      if (lookahead == '<')
        ADVANCE(13);
      if (lookahead == '=')
        ADVANCE(14);
      if (lookahead == '>')
        ADVANCE(15);
      if (lookahead == '[')
        ADVANCE(16);
      if (lookahead == ']')
        ADVANCE(17);
      if (lookahead == 'a')
        ADVANCE(18);
      if (lookahead == 'b')
        ADVANCE(19);
      if (lookahead == 'e')
        ADVANCE(20);
      if (lookahead == 'f')
        ADVANCE(21);
      if (lookahead == 'i')
        ADVANCE(22);
      if (lookahead == 'l')
        ADVANCE(23);
      if (lookahead == 'r')
        ADVANCE(24);
      if (lookahead == 's')
        ADVANCE(25);
      if (lookahead == 't')
        ADVANCE(26);
      if (lookahead == 'u')
        ADVANCE(27);
      if (lookahead == 'v')
        ADVANCE(28);
      if (lookahead == 'w')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '}')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(32);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=')
        ADVANCE(33);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 10:
      if (lookahead == '.')
        ADVANCE(34);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=')
        ADVANCE(35);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(36);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(37);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 18:
      if (lookahead == 's')
        ADVANCE(38);
      END_STATE();
    case 19:
      if (lookahead == 'o')
        ADVANCE(39);
      END_STATE();
    case 20:
      if (lookahead == 'l')
        ADVANCE(40);
      END_STATE();
    case 21:
      if (lookahead == 'a')
        ADVANCE(41);
      if (lookahead == 'l')
        ADVANCE(42);
      if (lookahead == 'o')
        ADVANCE(43);
      if (lookahead == 'u')
        ADVANCE(44);
      END_STATE();
    case 22:
      if (lookahead == 'n')
        ADVANCE(45);
      END_STATE();
    case 23:
      if (lookahead == 'e')
        ADVANCE(46);
      END_STATE();
    case 24:
      if (lookahead == 'e')
        ADVANCE(47);
      END_STATE();
    case 25:
      if (lookahead == 't')
        ADVANCE(48);
      END_STATE();
    case 26:
      if (lookahead == 'r')
        ADVANCE(49);
      END_STATE();
    case 27:
      if (lookahead == 'i')
        ADVANCE(50);
      END_STATE();
    case 28:
      if (lookahead == 'a')
        ADVANCE(51);
      END_STATE();
    case 29:
      if (lookahead == 'h')
        ADVANCE(52);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == '.')
        ADVANCE(53);
      if (lookahead == '_')
        ADVANCE(54);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(32);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 34:
      if (lookahead == '.')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(56);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 39:
      if (lookahead == 'o')
        ADVANCE(57);
      END_STATE();
    case 40:
      if (lookahead == 's')
        ADVANCE(58);
      END_STATE();
    case 41:
      if (lookahead == 'l')
        ADVANCE(59);
      END_STATE();
    case 42:
      if (lookahead == 'o')
        ADVANCE(60);
      END_STATE();
    case 43:
      if (lookahead == 'r')
        ADVANCE(61);
      END_STATE();
    case 44:
      if (lookahead == 'n')
        ADVANCE(62);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 46:
      if (lookahead == 't')
        ADVANCE(63);
      END_STATE();
    case 47:
      if (lookahead == 't')
        ADVANCE(64);
      END_STATE();
    case 48:
      if (lookahead == 'r')
        ADVANCE(65);
      END_STATE();
    case 49:
      if (lookahead == 'u')
        ADVANCE(66);
      END_STATE();
    case 50:
      if (lookahead == 'n')
        ADVANCE(67);
      END_STATE();
    case 51:
      if (lookahead == 'r')
        ADVANCE(68);
      END_STATE();
    case 52:
      if (lookahead == 'e')
        ADVANCE(69);
      if (lookahead == 'i')
        ADVANCE(70);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(71);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(32);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_LT);
      END_STATE();
    case 57:
      if (lookahead == 'l')
        ADVANCE(72);
      END_STATE();
    case 58:
      if (lookahead == 'e')
        ADVANCE(73);
      END_STATE();
    case 59:
      if (lookahead == 's')
        ADVANCE(74);
      END_STATE();
    case 60:
      if (lookahead == 'a')
        ADVANCE(75);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_fun);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 64:
      if (lookahead == 'u')
        ADVANCE(76);
      END_STATE();
    case 65:
      if (lookahead == 'i')
        ADVANCE(77);
      END_STATE();
    case 66:
      if (lookahead == 'e')
        ADVANCE(78);
      END_STATE();
    case 67:
      if (lookahead == 't')
        ADVANCE(79);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 69:
      if (lookahead == 'n')
        ADVANCE(80);
      END_STATE();
    case 70:
      if (lookahead == 'l')
        ADVANCE(81);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(71);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_bool);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 74:
      if (lookahead == 'e')
        ADVANCE(82);
      END_STATE();
    case 75:
      if (lookahead == 't')
        ADVANCE(83);
      END_STATE();
    case 76:
      if (lookahead == 'r')
        ADVANCE(84);
      END_STATE();
    case 77:
      if (lookahead == 'n')
        ADVANCE(85);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 79:
      if (lookahead == '1')
        ADVANCE(86);
      if (lookahead == '3')
        ADVANCE(87);
      if (lookahead == '6')
        ADVANCE(88);
      if (lookahead == '8')
        ADVANCE(89);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_when);
      END_STATE();
    case 81:
      if (lookahead == 'e')
        ADVANCE(90);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 83:
      if (lookahead == '3')
        ADVANCE(91);
      if (lookahead == '6')
        ADVANCE(92);
      END_STATE();
    case 84:
      if (lookahead == 'n')
        ADVANCE(93);
      END_STATE();
    case 85:
      if (lookahead == 'g')
        ADVANCE(94);
      END_STATE();
    case 86:
      if (lookahead == '6')
        ADVANCE(95);
      END_STATE();
    case 87:
      if (lookahead == '2')
        ADVANCE(96);
      END_STATE();
    case 88:
      if (lookahead == '4')
        ADVANCE(97);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_uint8);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 91:
      if (lookahead == '2')
        ADVANCE(98);
      END_STATE();
    case 92:
      if (lookahead == '4')
        ADVANCE(99);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_uint16);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_uint32);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_uint64);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_float32);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_float64);
      END_STATE();
    case 100:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(101);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == ':')
        ADVANCE(12);
      if (lookahead == '[')
        ADVANCE(16);
      if (lookahead == 'f')
        ADVANCE(102);
      if (lookahead == 'l')
        ADVANCE(103);
      if (lookahead == 'r')
        ADVANCE(104);
      if (lookahead == 't')
        ADVANCE(105);
      if (lookahead == 'v')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(107);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '}')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(100);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(32);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'a')
        ADVANCE(109);
      if (lookahead == 'o')
        ADVANCE(110);
      if (lookahead == 'u')
        ADVANCE(111);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'e')
        ADVANCE(112);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'e')
        ADVANCE(113);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'r')
        ADVANCE(114);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'a')
        ADVANCE(115);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'h')
        ADVANCE(116);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'l')
        ADVANCE(117);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'r')
        ADVANCE(118);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'n')
        ADVANCE(119);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 't')
        ADVANCE(120);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 't')
        ADVANCE(121);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'u')
        ADVANCE(122);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'r')
        ADVANCE(123);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'e')
        ADVANCE(124);
      if (lookahead == 'i')
        ADVANCE(125);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 's')
        ADVANCE(126);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_for);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_fun);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_let);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'u')
        ADVANCE(127);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'e')
        ADVANCE(128);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_var);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'n')
        ADVANCE(129);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'l')
        ADVANCE(130);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'e')
        ADVANCE(131);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'r')
        ADVANCE(132);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_true);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_when);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'e')
        ADVANCE(133);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_false);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'n')
        ADVANCE(134);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_while);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_return);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 135:
      if (lookahead == '\n')
        ADVANCE(136);
      if (lookahead == '!')
        ADVANCE(137);
      if (lookahead == '%')
        ADVANCE(3);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == '*')
        ADVANCE(6);
      if (lookahead == '+')
        ADVANCE(7);
      if (lookahead == ',')
        ADVANCE(8);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == '/')
        ADVANCE(11);
      if (lookahead == ':')
        ADVANCE(12);
      if (lookahead == '<')
        ADVANCE(13);
      if (lookahead == '=')
        ADVANCE(14);
      if (lookahead == '>')
        ADVANCE(15);
      if (lookahead == 'a')
        ADVANCE(18);
      if (lookahead == '}')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(135);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_eol);
      if (lookahead == '\n')
        ADVANCE(136);
      END_STATE();
    case 137:
      if (lookahead == '=')
        ADVANCE(33);
      END_STATE();
    case 138:
      if (lookahead == ')')
        ADVANCE(5);
      if (lookahead == ',')
        ADVANCE(8);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(138);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 139:
      if (lookahead == '!')
        ADVANCE(101);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == ',')
        ADVANCE(8);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == '[')
        ADVANCE(16);
      if (lookahead == ']')
        ADVANCE(17);
      if (lookahead == 'f')
        ADVANCE(140);
      if (lookahead == 't')
        ADVANCE(105);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(139);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(32);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'a')
        ADVANCE(109);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 141:
      if (lookahead == '!')
        ADVANCE(101);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == ')')
        ADVANCE(5);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == '[')
        ADVANCE(16);
      if (lookahead == 'f')
        ADVANCE(140);
      if (lookahead == 't')
        ADVANCE(105);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(141);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(32);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 142:
      if (lookahead == '!')
        ADVANCE(137);
      if (lookahead == '%')
        ADVANCE(3);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == ')')
        ADVANCE(5);
      if (lookahead == '*')
        ADVANCE(6);
      if (lookahead == '+')
        ADVANCE(7);
      if (lookahead == ',')
        ADVANCE(8);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == '.')
        ADVANCE(10);
      if (lookahead == '/')
        ADVANCE(11);
      if (lookahead == ':')
        ADVANCE(12);
      if (lookahead == '<')
        ADVANCE(13);
      if (lookahead == '=')
        ADVANCE(14);
      if (lookahead == '>')
        ADVANCE(15);
      if (lookahead == ']')
        ADVANCE(17);
      if (lookahead == 'a')
        ADVANCE(18);
      if (lookahead == 'i')
        ADVANCE(22);
      if (lookahead == '}')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(142);
      END_STATE();
    case 143:
      if (lookahead == '!')
        ADVANCE(101);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == ',')
        ADVANCE(8);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == '[')
        ADVANCE(16);
      if (lookahead == 'f')
        ADVANCE(140);
      if (lookahead == 't')
        ADVANCE(105);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '}')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(143);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(32);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 144:
      if (lookahead == '!')
        ADVANCE(137);
      if (lookahead == '%')
        ADVANCE(3);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == ')')
        ADVANCE(5);
      if (lookahead == '*')
        ADVANCE(6);
      if (lookahead == '+')
        ADVANCE(7);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == '/')
        ADVANCE(11);
      if (lookahead == ':')
        ADVANCE(12);
      if (lookahead == '<')
        ADVANCE(13);
      if (lookahead == '=')
        ADVANCE(14);
      if (lookahead == '>')
        ADVANCE(15);
      if (lookahead == 'a')
        ADVANCE(18);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(144);
      END_STATE();
    case 145:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(101);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == '[')
        ADVANCE(16);
      if (lookahead == 'e')
        ADVANCE(146);
      if (lookahead == 'f')
        ADVANCE(102);
      if (lookahead == 'l')
        ADVANCE(103);
      if (lookahead == 'r')
        ADVANCE(104);
      if (lookahead == 't')
        ADVANCE(105);
      if (lookahead == 'v')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(107);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '}')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(145);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(32);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'l')
        ADVANCE(147);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 's')
        ADVANCE(148);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'e')
        ADVANCE(149);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_else);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 150:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(136);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(3);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == '*')
        ADVANCE(6);
      if (lookahead == '+')
        ADVANCE(7);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == '/')
        ADVANCE(11);
      if (lookahead == ':')
        ADVANCE(12);
      if (lookahead == '<')
        ADVANCE(13);
      if (lookahead == '=')
        ADVANCE(151);
      if (lookahead == '>')
        ADVANCE(15);
      if (lookahead == '[')
        ADVANCE(16);
      if (lookahead == 'a')
        ADVANCE(152);
      if (lookahead == 'f')
        ADVANCE(102);
      if (lookahead == 'l')
        ADVANCE(103);
      if (lookahead == 'r')
        ADVANCE(104);
      if (lookahead == 't')
        ADVANCE(105);
      if (lookahead == 'v')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(107);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '}')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(150);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(32);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 151:
      if (lookahead == '=')
        ADVANCE(36);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 's')
        ADVANCE(153);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_as);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 154:
      if (lookahead == '\n')
        ADVANCE(136);
      if (lookahead == '!')
        ADVANCE(137);
      if (lookahead == '%')
        ADVANCE(3);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == '*')
        ADVANCE(6);
      if (lookahead == '+')
        ADVANCE(7);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == '/')
        ADVANCE(11);
      if (lookahead == ':')
        ADVANCE(12);
      if (lookahead == '<')
        ADVANCE(13);
      if (lookahead == '=')
        ADVANCE(14);
      if (lookahead == '>')
        ADVANCE(15);
      if (lookahead == 'a')
        ADVANCE(18);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(154);
      END_STATE();
    case 155:
      if (lookahead == '\n')
        ADVANCE(136);
      if (lookahead == '!')
        ADVANCE(137);
      if (lookahead == '%')
        ADVANCE(3);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == '*')
        ADVANCE(6);
      if (lookahead == '+')
        ADVANCE(7);
      if (lookahead == ',')
        ADVANCE(8);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == '/')
        ADVANCE(11);
      if (lookahead == '<')
        ADVANCE(13);
      if (lookahead == '=')
        ADVANCE(14);
      if (lookahead == '>')
        ADVANCE(15);
      if (lookahead == 'a')
        ADVANCE(18);
      if (lookahead == '}')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(155);
      END_STATE();
    case 156:
      if (lookahead == '!')
        ADVANCE(137);
      if (lookahead == '%')
        ADVANCE(3);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == '*')
        ADVANCE(6);
      if (lookahead == '+')
        ADVANCE(7);
      if (lookahead == ',')
        ADVANCE(8);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == '.')
        ADVANCE(10);
      if (lookahead == '/')
        ADVANCE(11);
      if (lookahead == '<')
        ADVANCE(13);
      if (lookahead == '=')
        ADVANCE(14);
      if (lookahead == '>')
        ADVANCE(15);
      if (lookahead == ']')
        ADVANCE(17);
      if (lookahead == 'a')
        ADVANCE(18);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(156);
      END_STATE();
    case 157:
      if (lookahead == '!')
        ADVANCE(137);
      if (lookahead == '%')
        ADVANCE(3);
      if (lookahead == '*')
        ADVANCE(6);
      if (lookahead == '+')
        ADVANCE(7);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == '/')
        ADVANCE(11);
      if (lookahead == ':')
        ADVANCE(12);
      if (lookahead == '<')
        ADVANCE(13);
      if (lookahead == '=')
        ADVANCE(151);
      if (lookahead == '>')
        ADVANCE(15);
      if (lookahead == 'a')
        ADVANCE(18);
      if (lookahead == 'l')
        ADVANCE(23);
      if (lookahead == 'v')
        ADVANCE(28);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(157);
      END_STATE();
    case 158:
      if (lookahead == '[')
        ADVANCE(16);
      if (lookahead == 'b')
        ADVANCE(19);
      if (lookahead == 'f')
        ADVANCE(159);
      if (lookahead == 'i')
        ADVANCE(160);
      if (lookahead == 's')
        ADVANCE(25);
      if (lookahead == 'u')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(158);
      END_STATE();
    case 159:
      if (lookahead == 'l')
        ADVANCE(42);
      END_STATE();
    case 160:
      if (lookahead == 'n')
        ADVANCE(161);
      END_STATE();
    case 161:
      if (lookahead == 't')
        ADVANCE(162);
      END_STATE();
    case 162:
      if (lookahead == '1')
        ADVANCE(163);
      if (lookahead == '3')
        ADVANCE(164);
      if (lookahead == '6')
        ADVANCE(165);
      if (lookahead == '8')
        ADVANCE(166);
      END_STATE();
    case 163:
      if (lookahead == '6')
        ADVANCE(167);
      END_STATE();
    case 164:
      if (lookahead == '2')
        ADVANCE(168);
      END_STATE();
    case 165:
      if (lookahead == '4')
        ADVANCE(169);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_int8);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_int16);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_int32);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_int64);
      END_STATE();
    case 170:
      if (lookahead == '!')
        ADVANCE(101);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == '[')
        ADVANCE(16);
      if (lookahead == 'e')
        ADVANCE(146);
      if (lookahead == 'f')
        ADVANCE(140);
      if (lookahead == 't')
        ADVANCE(105);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '}')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(170);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(32);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 171:
      if (lookahead == '!')
        ADVANCE(101);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == '[')
        ADVANCE(16);
      if (lookahead == 'f')
        ADVANCE(172);
      if (lookahead == 'r')
        ADVANCE(104);
      if (lookahead == 't')
        ADVANCE(105);
      if (lookahead == 'w')
        ADVANCE(107);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(171);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(32);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'a')
        ADVANCE(109);
      if (lookahead == 'o')
        ADVANCE(110);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 173:
      if (lookahead == '!')
        ADVANCE(137);
      if (lookahead == '%')
        ADVANCE(3);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == '*')
        ADVANCE(6);
      if (lookahead == '+')
        ADVANCE(7);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == '/')
        ADVANCE(11);
      if (lookahead == ':')
        ADVANCE(12);
      if (lookahead == '<')
        ADVANCE(13);
      if (lookahead == '=')
        ADVANCE(14);
      if (lookahead == '>')
        ADVANCE(15);
      if (lookahead == 'a')
        ADVANCE(18);
      if (lookahead == 'i')
        ADVANCE(22);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(173);
      END_STATE();
    case 174:
      if (lookahead == '!')
        ADVANCE(137);
      if (lookahead == '%')
        ADVANCE(3);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == ')')
        ADVANCE(5);
      if (lookahead == '*')
        ADVANCE(6);
      if (lookahead == '+')
        ADVANCE(7);
      if (lookahead == ',')
        ADVANCE(8);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == '/')
        ADVANCE(11);
      if (lookahead == '<')
        ADVANCE(13);
      if (lookahead == '=')
        ADVANCE(14);
      if (lookahead == '>')
        ADVANCE(15);
      if (lookahead == 'a')
        ADVANCE(18);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(174);
      END_STATE();
    case 175:
      if (lookahead == '!')
        ADVANCE(137);
      if (lookahead == '%')
        ADVANCE(3);
      if (lookahead == ')')
        ADVANCE(5);
      if (lookahead == '*')
        ADVANCE(6);
      if (lookahead == '+')
        ADVANCE(7);
      if (lookahead == ',')
        ADVANCE(8);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == '.')
        ADVANCE(10);
      if (lookahead == '/')
        ADVANCE(11);
      if (lookahead == ':')
        ADVANCE(12);
      if (lookahead == '<')
        ADVANCE(13);
      if (lookahead == '=')
        ADVANCE(14);
      if (lookahead == '>')
        ADVANCE(15);
      if (lookahead == ']')
        ADVANCE(17);
      if (lookahead == 'a')
        ADVANCE(18);
      if (lookahead == 'i')
        ADVANCE(22);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '}')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(175);
      END_STATE();
    case 176:
      if (lookahead == '!')
        ADVANCE(137);
      if (lookahead == '%')
        ADVANCE(3);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == '*')
        ADVANCE(6);
      if (lookahead == '+')
        ADVANCE(7);
      if (lookahead == ',')
        ADVANCE(8);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == '/')
        ADVANCE(11);
      if (lookahead == '<')
        ADVANCE(13);
      if (lookahead == '=')
        ADVANCE(14);
      if (lookahead == '>')
        ADVANCE(15);
      if (lookahead == 'a')
        ADVANCE(18);
      if (lookahead == '}')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(176);
      END_STATE();
    case 177:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(136);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(3);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == '*')
        ADVANCE(6);
      if (lookahead == '+')
        ADVANCE(7);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == '/')
        ADVANCE(11);
      if (lookahead == '<')
        ADVANCE(13);
      if (lookahead == '=')
        ADVANCE(151);
      if (lookahead == '>')
        ADVANCE(15);
      if (lookahead == '[')
        ADVANCE(16);
      if (lookahead == 'a')
        ADVANCE(152);
      if (lookahead == 'e')
        ADVANCE(146);
      if (lookahead == 'f')
        ADVANCE(102);
      if (lookahead == 'l')
        ADVANCE(103);
      if (lookahead == 'r')
        ADVANCE(104);
      if (lookahead == 't')
        ADVANCE(105);
      if (lookahead == 'v')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(107);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '}')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(177);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(32);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 178:
      if (lookahead == '!')
        ADVANCE(137);
      if (lookahead == '%')
        ADVANCE(3);
      if (lookahead == ')')
        ADVANCE(5);
      if (lookahead == '*')
        ADVANCE(6);
      if (lookahead == '+')
        ADVANCE(7);
      if (lookahead == ',')
        ADVANCE(8);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == '.')
        ADVANCE(10);
      if (lookahead == '/')
        ADVANCE(11);
      if (lookahead == ':')
        ADVANCE(12);
      if (lookahead == '<')
        ADVANCE(13);
      if (lookahead == '=')
        ADVANCE(151);
      if (lookahead == '>')
        ADVANCE(15);
      if (lookahead == ']')
        ADVANCE(17);
      if (lookahead == 'a')
        ADVANCE(18);
      if (lookahead == 'e')
        ADVANCE(20);
      if (lookahead == 'i')
        ADVANCE(22);
      if (lookahead == '}')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(178);
      END_STATE();
    case 179:
      if (lookahead == '\n')
        ADVANCE(136);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(3);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == '*')
        ADVANCE(6);
      if (lookahead == '+')
        ADVANCE(7);
      if (lookahead == ',')
        ADVANCE(8);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == '/')
        ADVANCE(11);
      if (lookahead == '<')
        ADVANCE(13);
      if (lookahead == '=')
        ADVANCE(151);
      if (lookahead == '>')
        ADVANCE(15);
      if (lookahead == '[')
        ADVANCE(16);
      if (lookahead == 'a')
        ADVANCE(152);
      if (lookahead == 'e')
        ADVANCE(146);
      if (lookahead == 'f')
        ADVANCE(140);
      if (lookahead == 't')
        ADVANCE(105);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '}')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(179);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(32);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(108);
      END_STATE();
    case 180:
      if (lookahead == '\n')
        ADVANCE(136);
      if (lookahead == '!')
        ADVANCE(137);
      if (lookahead == '%')
        ADVANCE(3);
      if (lookahead == '*')
        ADVANCE(6);
      if (lookahead == '+')
        ADVANCE(7);
      if (lookahead == '-')
        ADVANCE(9);
      if (lookahead == '/')
        ADVANCE(11);
      if (lookahead == '<')
        ADVANCE(13);
      if (lookahead == '=')
        ADVANCE(151);
      if (lookahead == '>')
        ADVANCE(15);
      if (lookahead == 'a')
        ADVANCE(18);
      if (lookahead == 'e')
        ADVANCE(20);
      if (lookahead == '}')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(180);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 100},
  [2] = {.lex_state = 135},
  [3] = {.lex_state = 138},
  [4] = {.lex_state = 139},
  [5] = {.lex_state = 139},
  [6] = {.lex_state = 100},
  [7] = {.lex_state = 139},
  [8] = {.lex_state = 138},
  [9] = {.lex_state = 139},
  [10] = {.lex_state = 135},
  [11] = {.lex_state = 100},
  [12] = {.lex_state = 135},
  [13] = {.lex_state = 100},
  [14] = {.lex_state = 141},
  [15] = {.lex_state = 135},
  [16] = {.lex_state = 135},
  [17] = {.lex_state = 100},
  [18] = {.lex_state = 0},
  [19] = {.lex_state = 135},
  [20] = {.lex_state = 135},
  [21] = {.lex_state = 142},
  [22] = {.lex_state = 100},
  [23] = {.lex_state = 142},
  [24] = {.lex_state = 139},
  [25] = {.lex_state = 139},
  [26] = {.lex_state = 142},
  [27] = {.lex_state = 141},
  [28] = {.lex_state = 143},
  [29] = {.lex_state = 142},
  [30] = {.lex_state = 144},
  [31] = {.lex_state = 144},
  [32] = {.lex_state = 145},
  [33] = {.lex_state = 139},
  [34] = {.lex_state = 143},
  [35] = {.lex_state = 135},
  [36] = {.lex_state = 150},
  [37] = {.lex_state = 139},
  [38] = {.lex_state = 100},
  [39] = {.lex_state = 100},
  [40] = {.lex_state = 154},
  [41] = {.lex_state = 100},
  [42] = {.lex_state = 154},
  [43] = {.lex_state = 155},
  [44] = {.lex_state = 155},
  [45] = {.lex_state = 154},
  [46] = {.lex_state = 135},
  [47] = {.lex_state = 141},
  [48] = {.lex_state = 143},
  [49] = {.lex_state = 156},
  [50] = {.lex_state = 156},
  [51] = {.lex_state = 157},
  [52] = {.lex_state = 139},
  [53] = {.lex_state = 100},
  [54] = {.lex_state = 144},
  [55] = {.lex_state = 138},
  [56] = {.lex_state = 138},
  [57] = {.lex_state = 144},
  [58] = {.lex_state = 100},
  [59] = {.lex_state = 100},
  [60] = {.lex_state = 139},
  [61] = {.lex_state = 139},
  [62] = {.lex_state = 139},
  [63] = {.lex_state = 158},
  [64] = {.lex_state = 100},
  [65] = {.lex_state = 139},
  [66] = {.lex_state = 141},
  [67] = {.lex_state = 138},
  [68] = {.lex_state = 100},
  [69] = {.lex_state = 142},
  [70] = {.lex_state = 156},
  [71] = {.lex_state = 139},
  [72] = {.lex_state = 142},
  [73] = {.lex_state = 100},
  [74] = {.lex_state = 144},
  [75] = {.lex_state = 138},
  [76] = {.lex_state = 142},
  [77] = {.lex_state = 170},
  [78] = {.lex_state = 144},
  [79] = {.lex_state = 145},
  [80] = {.lex_state = 139},
  [81] = {.lex_state = 139},
  [82] = {.lex_state = 171},
  [83] = {.lex_state = 139},
  [84] = {.lex_state = 158},
  [85] = {.lex_state = 139},
  [86] = {.lex_state = 141},
  [87] = {.lex_state = 100},
  [88] = {.lex_state = 100},
  [89] = {.lex_state = 156},
  [90] = {.lex_state = 156},
  [91] = {.lex_state = 135},
  [92] = {.lex_state = 144},
  [93] = {.lex_state = 144},
  [94] = {.lex_state = 145},
  [95] = {.lex_state = 157},
  [96] = {.lex_state = 139},
  [97] = {.lex_state = 139},
  [98] = {.lex_state = 139},
  [99] = {.lex_state = 139},
  [100] = {.lex_state = 139},
  [101] = {.lex_state = 100},
  [102] = {.lex_state = 100},
  [103] = {.lex_state = 139},
  [104] = {.lex_state = 139},
  [105] = {.lex_state = 139},
  [106] = {.lex_state = 139},
  [107] = {.lex_state = 139},
  [108] = {.lex_state = 100},
  [109] = {.lex_state = 155},
  [110] = {.lex_state = 139},
  [111] = {.lex_state = 139},
  [112] = {.lex_state = 158},
  [113] = {.lex_state = 144},
  [114] = {.lex_state = 144},
  [115] = {.lex_state = 139},
  [116] = {.lex_state = 139},
  [117] = {.lex_state = 139},
  [118] = {.lex_state = 139},
  [119] = {.lex_state = 139},
  [120] = {.lex_state = 135},
  [121] = {.lex_state = 139},
  [122] = {.lex_state = 139},
  [123] = {.lex_state = 138},
  [124] = {.lex_state = 173},
  [125] = {.lex_state = 144},
  [126] = {.lex_state = 144},
  [127] = {.lex_state = 100},
  [128] = {.lex_state = 158},
  [129] = {.lex_state = 135},
  [130] = {.lex_state = 139},
  [131] = {.lex_state = 139},
  [132] = {.lex_state = 135},
  [133] = {.lex_state = 139},
  [134] = {.lex_state = 100},
  [135] = {.lex_state = 138},
  [136] = {.lex_state = 138},
  [137] = {.lex_state = 139},
  [138] = {.lex_state = 158},
  [139] = {.lex_state = 135},
  [140] = {.lex_state = 135},
  [141] = {.lex_state = 135},
  [142] = {.lex_state = 135},
  [143] = {.lex_state = 158},
  [144] = {.lex_state = 158},
  [145] = {.lex_state = 135},
  [146] = {.lex_state = 135},
  [147] = {.lex_state = 135},
  [148] = {.lex_state = 174},
  [149] = {.lex_state = 174},
  [150] = {.lex_state = 138},
  [151] = {.lex_state = 100},
  [152] = {.lex_state = 138},
  [153] = {.lex_state = 100},
  [154] = {.lex_state = 139},
  [155] = {.lex_state = 139},
  [156] = {.lex_state = 142},
  [157] = {.lex_state = 139},
  [158] = {.lex_state = 156},
  [159] = {.lex_state = 100},
  [160] = {.lex_state = 158},
  [161] = {.lex_state = 142},
  [162] = {.lex_state = 157},
  [163] = {.lex_state = 100},
  [164] = {.lex_state = 170},
  [165] = {.lex_state = 144},
  [166] = {.lex_state = 171},
  [167] = {.lex_state = 100},
  [168] = {.lex_state = 100},
  [169] = {.lex_state = 100},
  [170] = {.lex_state = 144},
  [171] = {.lex_state = 142},
  [172] = {.lex_state = 139},
  [173] = {.lex_state = 100},
  [174] = {.lex_state = 100},
  [175] = {.lex_state = 100},
  [176] = {.lex_state = 139},
  [177] = {.lex_state = 145},
  [178] = {.lex_state = 135},
  [179] = {.lex_state = 144},
  [180] = {.lex_state = 175},
  [181] = {.lex_state = 158},
  [182] = {.lex_state = 158},
  [183] = {.lex_state = 142},
  [184] = {.lex_state = 144},
  [185] = {.lex_state = 142},
  [186] = {.lex_state = 138},
  [187] = {.lex_state = 171},
  [188] = {.lex_state = 139},
  [189] = {.lex_state = 139},
  [190] = {.lex_state = 139},
  [191] = {.lex_state = 139},
  [192] = {.lex_state = 171},
  [193] = {.lex_state = 100},
  [194] = {.lex_state = 173},
  [195] = {.lex_state = 144},
  [196] = {.lex_state = 154},
  [197] = {.lex_state = 176},
  [198] = {.lex_state = 176},
  [199] = {.lex_state = 154},
  [200] = {.lex_state = 154},
  [201] = {.lex_state = 155},
  [202] = {.lex_state = 155},
  [203] = {.lex_state = 155},
  [204] = {.lex_state = 100},
  [205] = {.lex_state = 155},
  [206] = {.lex_state = 155},
  [207] = {.lex_state = 135},
  [208] = {.lex_state = 135},
  [209] = {.lex_state = 142},
  [210] = {.lex_state = 139},
  [211] = {.lex_state = 156},
  [212] = {.lex_state = 135},
  [213] = {.lex_state = 156},
  [214] = {.lex_state = 156},
  [215] = {.lex_state = 156},
  [216] = {.lex_state = 156},
  [217] = {.lex_state = 139},
  [218] = {.lex_state = 139},
  [219] = {.lex_state = 156},
  [220] = {.lex_state = 173},
  [221] = {.lex_state = 139},
  [222] = {.lex_state = 171},
  [223] = {.lex_state = 135},
  [224] = {.lex_state = 100},
  [225] = {.lex_state = 100},
  [226] = {.lex_state = 138},
  [227] = {.lex_state = 144},
  [228] = {.lex_state = 144},
  [229] = {.lex_state = 158},
  [230] = {.lex_state = 135},
  [231] = {.lex_state = 138},
  [232] = {.lex_state = 138},
  [233] = {.lex_state = 144},
  [234] = {.lex_state = 138},
  [235] = {.lex_state = 139},
  [236] = {.lex_state = 100},
  [237] = {.lex_state = 139},
  [238] = {.lex_state = 139},
  [239] = {.lex_state = 139},
  [240] = {.lex_state = 139},
  [241] = {.lex_state = 138},
  [242] = {.lex_state = 139},
  [243] = {.lex_state = 135},
  [244] = {.lex_state = 100},
  [245] = {.lex_state = 158},
  [246] = {.lex_state = 100},
  [247] = {.lex_state = 100},
  [248] = {.lex_state = 142},
  [249] = {.lex_state = 156},
  [250] = {.lex_state = 139},
  [251] = {.lex_state = 142},
  [252] = {.lex_state = 100},
  [253] = {.lex_state = 100},
  [254] = {.lex_state = 139},
  [255] = {.lex_state = 158},
  [256] = {.lex_state = 142},
  [257] = {.lex_state = 171},
  [258] = {.lex_state = 139},
  [259] = {.lex_state = 100},
  [260] = {.lex_state = 100},
  [261] = {.lex_state = 100},
  [262] = {.lex_state = 139},
  [263] = {.lex_state = 170},
  [264] = {.lex_state = 155},
  [265] = {.lex_state = 155},
  [266] = {.lex_state = 171},
  [267] = {.lex_state = 100},
  [268] = {.lex_state = 141},
  [269] = {.lex_state = 143},
  [270] = {.lex_state = 145},
  [271] = {.lex_state = 157},
  [272] = {.lex_state = 139},
  [273] = {.lex_state = 177},
  [274] = {.lex_state = 100},
  [275] = {.lex_state = 155},
  [276] = {.lex_state = 145},
  [277] = {.lex_state = 139},
  [278] = {.lex_state = 100},
  [279] = {.lex_state = 142},
  [280] = {.lex_state = 100},
  [281] = {.lex_state = 156},
  [282] = {.lex_state = 156},
  [283] = {.lex_state = 156},
  [284] = {.lex_state = 139},
  [285] = {.lex_state = 100},
  [286] = {.lex_state = 100},
  [287] = {.lex_state = 171},
  [288] = {.lex_state = 139},
  [289] = {.lex_state = 171},
  [290] = {.lex_state = 139},
  [291] = {.lex_state = 139},
  [292] = {.lex_state = 139},
  [293] = {.lex_state = 135},
  [294] = {.lex_state = 139},
  [295] = {.lex_state = 143},
  [296] = {.lex_state = 139},
  [297] = {.lex_state = 139},
  [298] = {.lex_state = 176},
  [299] = {.lex_state = 139},
  [300] = {.lex_state = 139},
  [301] = {.lex_state = 135},
  [302] = {.lex_state = 139},
  [303] = {.lex_state = 139},
  [304] = {.lex_state = 135},
  [305] = {.lex_state = 139},
  [306] = {.lex_state = 139},
  [307] = {.lex_state = 158},
  [308] = {.lex_state = 144},
  [309] = {.lex_state = 100},
  [310] = {.lex_state = 135},
  [311] = {.lex_state = 135},
  [312] = {.lex_state = 158},
  [313] = {.lex_state = 138},
  [314] = {.lex_state = 100},
  [315] = {.lex_state = 135},
  [316] = {.lex_state = 158},
  [317] = {.lex_state = 174},
  [318] = {.lex_state = 174},
  [319] = {.lex_state = 174},
  [320] = {.lex_state = 138},
  [321] = {.lex_state = 174},
  [322] = {.lex_state = 100},
  [323] = {.lex_state = 100},
  [324] = {.lex_state = 158},
  [325] = {.lex_state = 100},
  [326] = {.lex_state = 142},
  [327] = {.lex_state = 142},
  [328] = {.lex_state = 178},
  [329] = {.lex_state = 142},
  [330] = {.lex_state = 145},
  [331] = {.lex_state = 100},
  [332] = {.lex_state = 135},
  [333] = {.lex_state = 141},
  [334] = {.lex_state = 143},
  [335] = {.lex_state = 170},
  [336] = {.lex_state = 157},
  [337] = {.lex_state = 139},
  [338] = {.lex_state = 179},
  [339] = {.lex_state = 100},
  [340] = {.lex_state = 155},
  [341] = {.lex_state = 139},
  [342] = {.lex_state = 142},
  [343] = {.lex_state = 139},
  [344] = {.lex_state = 139},
  [345] = {.lex_state = 170},
  [346] = {.lex_state = 143},
  [347] = {.lex_state = 139},
  [348] = {.lex_state = 139},
  [349] = {.lex_state = 100},
  [350] = {.lex_state = 100},
  [351] = {.lex_state = 100},
  [352] = {.lex_state = 144},
  [353] = {.lex_state = 145},
  [354] = {.lex_state = 145},
  [355] = {.lex_state = 173},
  [356] = {.lex_state = 144},
  [357] = {.lex_state = 145},
  [358] = {.lex_state = 145},
  [359] = {.lex_state = 155},
  [360] = {.lex_state = 175},
  [361] = {.lex_state = 158},
  [362] = {.lex_state = 157},
  [363] = {.lex_state = 139},
  [364] = {.lex_state = 144},
  [365] = {.lex_state = 176},
  [366] = {.lex_state = 144},
  [367] = {.lex_state = 176},
  [368] = {.lex_state = 135},
  [369] = {.lex_state = 143},
  [370] = {.lex_state = 176},
  [371] = {.lex_state = 135},
  [372] = {.lex_state = 156},
  [373] = {.lex_state = 156},
  [374] = {.lex_state = 156},
  [375] = {.lex_state = 173},
  [376] = {.lex_state = 173},
  [377] = {.lex_state = 173},
  [378] = {.lex_state = 171},
  [379] = {.lex_state = 138},
  [380] = {.lex_state = 138},
  [381] = {.lex_state = 135},
  [382] = {.lex_state = 100},
  [383] = {.lex_state = 100},
  [384] = {.lex_state = 100},
  [385] = {.lex_state = 100},
  [386] = {.lex_state = 100},
  [387] = {.lex_state = 142},
  [388] = {.lex_state = 144},
  [389] = {.lex_state = 145},
  [390] = {.lex_state = 170},
  [391] = {.lex_state = 173},
  [392] = {.lex_state = 144},
  [393] = {.lex_state = 170},
  [394] = {.lex_state = 170},
  [395] = {.lex_state = 155},
  [396] = {.lex_state = 155},
  [397] = {.lex_state = 155},
  [398] = {.lex_state = 142},
  [399] = {.lex_state = 155},
  [400] = {.lex_state = 144},
  [401] = {.lex_state = 145},
  [402] = {.lex_state = 157},
  [403] = {.lex_state = 139},
  [404] = {.lex_state = 180},
  [405] = {.lex_state = 157},
  [406] = {.lex_state = 145},
  [407] = {.lex_state = 100},
  [408] = {.lex_state = 171},
  [409] = {.lex_state = 139},
  [410] = {.lex_state = 171},
  [411] = {.lex_state = 145},
  [412] = {.lex_state = 100},
  [413] = {.lex_state = 173},
  [414] = {.lex_state = 144},
  [415] = {.lex_state = 171},
  [416] = {.lex_state = 139},
  [417] = {.lex_state = 139},
  [418] = {.lex_state = 139},
  [419] = {.lex_state = 139},
  [420] = {.lex_state = 139},
  [421] = {.lex_state = 139},
  [422] = {.lex_state = 100},
  [423] = {.lex_state = 135},
  [424] = {.lex_state = 100},
  [425] = {.lex_state = 100},
  [426] = {.lex_state = 157},
  [427] = {.lex_state = 170},
  [428] = {.lex_state = 100},
  [429] = {.lex_state = 171},
  [430] = {.lex_state = 139},
  [431] = {.lex_state = 171},
  [432] = {.lex_state = 170},
  [433] = {.lex_state = 171},
  [434] = {.lex_state = 173},
  [435] = {.lex_state = 144},
  [436] = {.lex_state = 139},
  [437] = {.lex_state = 145},
  [438] = {.lex_state = 145},
  [439] = {.lex_state = 144},
  [440] = {.lex_state = 145},
  [441] = {.lex_state = 175},
  [442] = {.lex_state = 171},
  [443] = {.lex_state = 139},
  [444] = {.lex_state = 171},
  [445] = {.lex_state = 176},
  [446] = {.lex_state = 173},
  [447] = {.lex_state = 173},
  [448] = {.lex_state = 173},
  [449] = {.lex_state = 173},
  [450] = {.lex_state = 139},
  [451] = {.lex_state = 170},
  [452] = {.lex_state = 170},
  [453] = {.lex_state = 144},
  [454] = {.lex_state = 170},
  [455] = {.lex_state = 139},
  [456] = {.lex_state = 100},
  [457] = {.lex_state = 100},
  [458] = {.lex_state = 100},
  [459] = {.lex_state = 139},
  [460] = {.lex_state = 171},
  [461] = {.lex_state = 145},
  [462] = {.lex_state = 171},
  [463] = {.lex_state = 144},
  [464] = {.lex_state = 145},
  [465] = {.lex_state = 171},
  [466] = {.lex_state = 157},
  [467] = {.lex_state = 139},
  [468] = {.lex_state = 144},
  [469] = {.lex_state = 145},
  [470] = {.lex_state = 100},
  [471] = {.lex_state = 145},
  [472] = {.lex_state = 171},
  [473] = {.lex_state = 170},
  [474] = {.lex_state = 100},
  [475] = {.lex_state = 170},
  [476] = {.lex_state = 173},
  [477] = {.lex_state = 144},
  [478] = {.lex_state = 171},
  [479] = {.lex_state = 145},
  [480] = {.lex_state = 170},
  [481] = {.lex_state = 171},
  [482] = {.lex_state = 139},
  [483] = {.lex_state = 171},
  [484] = {.lex_state = 144},
  [485] = {.lex_state = 171},
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_uint32] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_uint64] = ACTIONS(1),
    [anon_sym_float64] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_fun] = ACTIONS(1),
    [anon_sym_when] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_float32] = ACTIONS(1),
    [anon_sym_uint16] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_uint8] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [aux_sym_number_token1] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_DOT_DOT_LT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
  },
  [1] = {
    [sym_variable_declaration] = STATE(15),
    [sym__statement] = STATE(17),
    [sym_return_statement] = STATE(17),
    [sym_assignment] = STATE(19),
    [sym_function_call] = STATE(19),
    [sym_multiplication_expression] = STATE(19),
    [sym_cast_expression] = STATE(19),
    [sym_primary] = STATE(19),
    [sym_list_literal] = STATE(16),
    [aux_sym_source_file_repeat1] = STATE(17),
    [sym_source_file] = STATE(18),
    [sym_when_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_range_literal] = STATE(19),
    [sym_unary_expression] = STATE(19),
    [sym_bool_literal] = STATE(16),
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym__declaration] = STATE(17),
    [sym_function_declaration] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_block_statement] = STATE(17),
    [sym_expression_statement] = STATE(17),
    [sym__expression] = STATE(19),
    [sym_comparison_expression] = STATE(19),
    [sym_addition_expression] = STATE(19),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_fun] = ACTIONS(5),
    [anon_sym_when] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_true] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(17),
    [anon_sym_LBRACK] = ACTIONS(19),
    [aux_sym_number_token1] = ACTIONS(21),
    [anon_sym_for] = ACTIONS(23),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
  },
  [2] = {
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(31),
    [anon_sym_PLUS] = ACTIONS(31),
    [anon_sym_as] = ACTIONS(31),
    [anon_sym_STAR] = ACTIONS(31),
    [sym_eol] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(31),
    [anon_sym_BANG_EQ] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(31),
    [anon_sym_LT_EQ] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(31),
    [anon_sym_EQ_EQ] = ACTIONS(31),
    [anon_sym_SLASH] = ACTIONS(31),
    [anon_sym_GT_EQ] = ACTIONS(31),
  },
  [3] = {
    [sym_identifier] = STATE(22),
    [aux_sym_identifier_token1] = ACTIONS(35),
  },
  [4] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(30),
    [sym_function_call] = STATE(30),
    [sym_multiplication_expression] = STATE(30),
    [sym_cast_expression] = STATE(30),
    [sym_primary] = STATE(30),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(30),
    [sym_comparison_expression] = STATE(30),
    [sym_addition_expression] = STATE(30),
    [sym_identifier] = STATE(31),
    [sym_number] = STATE(29),
    [sym_clause_result] = STATE(32),
    [sym_range_literal] = STATE(30),
    [sym_unary_expression] = STATE(30),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_true] = ACTIONS(37),
  },
  [5] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_identifier] = STATE(16),
    [sym_number] = STATE(16),
    [sym_primary] = STATE(35),
    [sym_list_literal] = STATE(16),
    [sym_bool_literal] = STATE(16),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(29),
    [aux_sym_number_token1] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_true] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(53),
  },
  [6] = {
    [sym_function_literal] = STATE(16),
    [sym_variable_declaration] = STATE(15),
    [sym__statement] = STATE(41),
    [sym_return_statement] = STATE(41),
    [sym_map_literal] = STATE(16),
    [sym_assignment] = STATE(40),
    [sym_function_call] = STATE(40),
    [sym_multiplication_expression] = STATE(40),
    [sym_cast_expression] = STATE(40),
    [sym_parenthetical_expression] = STATE(16),
    [sym_primary] = STATE(40),
    [sym__declaration] = STATE(41),
    [sym_function_declaration] = STATE(41),
    [sym_while_statement] = STATE(41),
    [sym_block_statement] = STATE(41),
    [sym_expression_statement] = STATE(41),
    [sym__expression] = STATE(40),
    [sym_comparison_expression] = STATE(40),
    [sym_addition_expression] = STATE(40),
    [sym_list_literal] = STATE(16),
    [aux_sym_source_file_repeat1] = STATE(41),
    [sym_when_statement] = STATE(41),
    [sym_for_statement] = STATE(41),
    [sym_identifier] = STATE(42),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(40),
    [sym_unary_expression] = STATE(40),
    [sym_bool_literal] = STATE(16),
    [anon_sym_RBRACE] = ACTIONS(55),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_fun] = ACTIONS(5),
    [anon_sym_when] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_true] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [aux_sym_number_token1] = ACTIONS(21),
    [anon_sym_for] = ACTIONS(59),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_var] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
  },
  [7] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_assignment] = STATE(43),
    [sym_function_call] = STATE(43),
    [sym_multiplication_expression] = STATE(43),
    [sym_cast_expression] = STATE(43),
    [sym_primary] = STATE(43),
    [sym_list_literal] = STATE(16),
    [sym__expression] = STATE(43),
    [sym_comparison_expression] = STATE(43),
    [sym_addition_expression] = STATE(43),
    [sym_identifier] = STATE(44),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(43),
    [sym_unary_expression] = STATE(43),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(9),
    [aux_sym_number_token1] = ACTIONS(21),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(3),
  },
  [8] = {
    [sym_identifier] = STATE(45),
    [aux_sym_identifier_token1] = ACTIONS(63),
  },
  [9] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(49),
    [sym_function_call] = STATE(49),
    [sym_multiplication_expression] = STATE(49),
    [sym_cast_expression] = STATE(49),
    [sym_primary] = STATE(49),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(49),
    [sym_comparison_expression] = STATE(49),
    [sym_addition_expression] = STATE(49),
    [sym_identifier] = STATE(50),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(49),
    [sym_unary_expression] = STATE(49),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [10] = {
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_RBRACE] = ACTIONS(71),
    [anon_sym_COMMA] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_as] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [sym_eol] = ACTIONS(73),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_BANG_EQ] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_LT_EQ] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(71),
  },
  [11] = {
    [anon_sym_LPAREN] = ACTIONS(75),
  },
  [12] = {
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_RBRACE] = ACTIONS(77),
    [anon_sym_COMMA] = ACTIONS(77),
    [anon_sym_COLON] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_as] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(77),
    [sym_eol] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_EQ] = ACTIONS(77),
    [anon_sym_BANG_EQ] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(77),
    [anon_sym_LPAREN] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_EQ_EQ] = ACTIONS(77),
    [anon_sym_SLASH] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(77),
  },
  [13] = {
    [anon_sym_LPAREN] = ACTIONS(81),
  },
  [14] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(54),
    [sym_function_call] = STATE(54),
    [sym_multiplication_expression] = STATE(54),
    [sym_cast_expression] = STATE(54),
    [sym_primary] = STATE(54),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(54),
    [sym_comparison_expression] = STATE(54),
    [sym_addition_expression] = STATE(54),
    [sym_parameter_list] = STATE(55),
    [sym_parameter] = STATE(56),
    [sym_identifier] = STATE(57),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(54),
    [sym_unary_expression] = STATE(54),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(83),
  },
  [15] = {
    [sym_eol] = ACTIONS(85),
  },
  [16] = {
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_RBRACE] = ACTIONS(87),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_as] = ACTIONS(87),
    [anon_sym_STAR] = ACTIONS(87),
    [sym_eol] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(87),
    [anon_sym_BANG_EQ] = ACTIONS(87),
    [anon_sym_PERCENT] = ACTIONS(87),
    [anon_sym_LT_EQ] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_GT_EQ] = ACTIONS(87),
  },
  [17] = {
    [sym_function_literal] = STATE(16),
    [sym_variable_declaration] = STATE(15),
    [sym__statement] = STATE(59),
    [sym_return_statement] = STATE(59),
    [sym_map_literal] = STATE(16),
    [sym_assignment] = STATE(19),
    [sym_function_call] = STATE(19),
    [sym_multiplication_expression] = STATE(19),
    [sym_cast_expression] = STATE(19),
    [sym_parenthetical_expression] = STATE(16),
    [sym_primary] = STATE(19),
    [sym__declaration] = STATE(59),
    [sym_function_declaration] = STATE(59),
    [sym_while_statement] = STATE(59),
    [sym_block_statement] = STATE(59),
    [sym_expression_statement] = STATE(59),
    [sym__expression] = STATE(19),
    [sym_comparison_expression] = STATE(19),
    [sym_addition_expression] = STATE(19),
    [sym_list_literal] = STATE(16),
    [aux_sym_source_file_repeat1] = STATE(59),
    [sym_when_statement] = STATE(59),
    [sym_for_statement] = STATE(59),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(19),
    [sym_unary_expression] = STATE(19),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_fun] = ACTIONS(5),
    [anon_sym_when] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_true] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(19),
    [aux_sym_number_token1] = ACTIONS(21),
    [anon_sym_for] = ACTIONS(23),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
  },
  [18] = {
    [ts_builtin_sym_end] = ACTIONS(93),
  },
  [19] = {
    [anon_sym_LT] = ACTIONS(95),
    [anon_sym_BANG_EQ] = ACTIONS(95),
    [anon_sym_PERCENT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(95),
    [anon_sym_PLUS] = ACTIONS(99),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(97),
    [sym_eol] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(95),
  },
  [20] = {
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_as] = ACTIONS(87),
    [anon_sym_STAR] = ACTIONS(87),
    [sym_eol] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(87),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_BANG_EQ] = ACTIONS(87),
    [anon_sym_PERCENT] = ACTIONS(87),
    [anon_sym_LT_EQ] = ACTIONS(87),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_GT_EQ] = ACTIONS(87),
  },
  [21] = {
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_RBRACE] = ACTIONS(79),
    [anon_sym_COMMA] = ACTIONS(79),
    [anon_sym_COLON] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(79),
    [anon_sym_as] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_in] = ACTIONS(79),
    [anon_sym_RPAREN] = ACTIONS(79),
    [anon_sym_EQ] = ACTIONS(77),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_PERCENT] = ACTIONS(79),
    [anon_sym_RBRACK] = ACTIONS(79),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(79),
    [anon_sym_DOT_DOT_LT] = ACTIONS(79),
    [anon_sym_GT_EQ] = ACTIONS(79),
  },
  [22] = {
    [sym_function_literal] = STATE(68),
    [anon_sym_LPAREN] = ACTIONS(109),
  },
  [23] = {
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(33),
    [anon_sym_COMMA] = ACTIONS(33),
    [anon_sym_COLON] = ACTIONS(33),
    [anon_sym_PLUS] = ACTIONS(33),
    [anon_sym_as] = ACTIONS(33),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(31),
    [anon_sym_in] = ACTIONS(33),
    [anon_sym_RPAREN] = ACTIONS(33),
    [anon_sym_BANG_EQ] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(33),
    [anon_sym_EQ_EQ] = ACTIONS(33),
    [anon_sym_SLASH] = ACTIONS(33),
    [anon_sym_DOT_DOT_LT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(33),
  },
  [24] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(70),
    [sym_function_call] = STATE(70),
    [sym_multiplication_expression] = STATE(70),
    [sym_cast_expression] = STATE(70),
    [sym_primary] = STATE(70),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(70),
    [sym_comparison_expression] = STATE(70),
    [sym_addition_expression] = STATE(70),
    [sym_identifier] = STATE(50),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(70),
    [sym_unary_expression] = STATE(70),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [25] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_identifier] = STATE(29),
    [sym_number] = STATE(29),
    [sym_primary] = STATE(72),
    [sym_list_literal] = STATE(29),
    [sym_bool_literal] = STATE(29),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(67),
    [aux_sym_number_token1] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(113),
    [anon_sym_true] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(69),
  },
  [26] = {
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_RBRACE] = ACTIONS(73),
    [anon_sym_COMMA] = ACTIONS(73),
    [anon_sym_COLON] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(73),
    [anon_sym_as] = ACTIONS(73),
    [anon_sym_STAR] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(73),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_in] = ACTIONS(73),
    [anon_sym_RPAREN] = ACTIONS(73),
    [anon_sym_BANG_EQ] = ACTIONS(73),
    [anon_sym_PERCENT] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(73),
    [anon_sym_LT_EQ] = ACTIONS(73),
    [anon_sym_DASH] = ACTIONS(73),
    [anon_sym_EQ_EQ] = ACTIONS(73),
    [anon_sym_SLASH] = ACTIONS(73),
    [anon_sym_DOT_DOT_LT] = ACTIONS(73),
    [anon_sym_GT_EQ] = ACTIONS(73),
  },
  [27] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(74),
    [sym_function_call] = STATE(74),
    [sym_multiplication_expression] = STATE(74),
    [sym_cast_expression] = STATE(74),
    [sym_primary] = STATE(74),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(74),
    [sym_comparison_expression] = STATE(74),
    [sym_addition_expression] = STATE(74),
    [sym_parameter_list] = STATE(75),
    [sym_parameter] = STATE(56),
    [sym_identifier] = STATE(57),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(74),
    [sym_unary_expression] = STATE(74),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(115),
  },
  [28] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [aux_sym_clause_list_repeat1] = STATE(77),
    [sym_assignment] = STATE(78),
    [sym_function_call] = STATE(78),
    [sym_multiplication_expression] = STATE(78),
    [sym_cast_expression] = STATE(78),
    [sym_primary] = STATE(78),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(78),
    [sym_comparison_expression] = STATE(78),
    [sym_addition_expression] = STATE(78),
    [sym_identifier] = STATE(31),
    [sym_number] = STATE(29),
    [sym_clause_result] = STATE(77),
    [sym_clause_list] = STATE(79),
    [sym_range_literal] = STATE(78),
    [sym_unary_expression] = STATE(78),
    [sym_bool_literal] = STATE(29),
    [anon_sym_RBRACE] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [29] = {
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_RBRACE] = ACTIONS(89),
    [anon_sym_COMMA] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_as] = ACTIONS(89),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(87),
    [anon_sym_in] = ACTIONS(89),
    [anon_sym_RPAREN] = ACTIONS(89),
    [anon_sym_BANG_EQ] = ACTIONS(89),
    [anon_sym_PERCENT] = ACTIONS(89),
    [anon_sym_RBRACK] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(89),
    [anon_sym_EQ_EQ] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(89),
    [anon_sym_DOT_DOT_LT] = ACTIONS(89),
    [anon_sym_GT_EQ] = ACTIONS(89),
  },
  [30] = {
    [anon_sym_LT] = ACTIONS(119),
    [anon_sym_BANG_EQ] = ACTIONS(121),
    [anon_sym_PERCENT] = ACTIONS(123),
    [anon_sym_COLON] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(121),
    [anon_sym_PLUS] = ACTIONS(127),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_GT] = ACTIONS(119),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_EQ_EQ] = ACTIONS(121),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_GT_EQ] = ACTIONS(121),
  },
  [31] = {
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_as] = ACTIONS(89),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(87),
    [anon_sym_EQ] = ACTIONS(131),
    [anon_sym_BANG_EQ] = ACTIONS(89),
    [anon_sym_PERCENT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(89),
    [anon_sym_EQ_EQ] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(89),
    [anon_sym_GT_EQ] = ACTIONS(89),
  },
  [32] = {
    [sym_else_result] = STATE(88),
    [anon_sym_false] = ACTIONS(135),
    [anon_sym_fun] = ACTIONS(135),
    [anon_sym_when] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(137),
    [anon_sym_true] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_let] = ACTIONS(135),
    [ts_builtin_sym_end] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(137),
    [aux_sym_number_token1] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(135),
    [aux_sym_identifier_token1] = ACTIONS(135),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_var] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(139),
  },
  [33] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(89),
    [sym_function_call] = STATE(89),
    [sym_multiplication_expression] = STATE(89),
    [sym_cast_expression] = STATE(89),
    [sym_primary] = STATE(89),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(89),
    [sym_comparison_expression] = STATE(89),
    [sym_addition_expression] = STATE(89),
    [sym_identifier] = STATE(90),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(89),
    [sym_unary_expression] = STATE(89),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [34] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(92),
    [sym_function_call] = STATE(92),
    [sym_multiplication_expression] = STATE(92),
    [sym_cast_expression] = STATE(92),
    [sym_primary] = STATE(92),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(92),
    [sym_comparison_expression] = STATE(92),
    [sym_addition_expression] = STATE(92),
    [sym_identifier] = STATE(31),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(92),
    [sym_unary_expression] = STATE(92),
    [sym_bool_literal] = STATE(29),
    [anon_sym_RBRACE] = ACTIONS(141),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [35] = {
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_RBRACE] = ACTIONS(143),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_COLON] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_as] = ACTIONS(143),
    [anon_sym_STAR] = ACTIONS(143),
    [sym_eol] = ACTIONS(145),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_PERCENT] = ACTIONS(143),
    [anon_sym_LT_EQ] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_EQ_EQ] = ACTIONS(143),
    [anon_sym_SLASH] = ACTIONS(143),
    [anon_sym_GT_EQ] = ACTIONS(143),
  },
  [36] = {
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_false] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(149),
    [sym_eol] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(149),
    [anon_sym_return] = ACTIONS(149),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(147),
    [anon_sym_PERCENT] = ACTIONS(147),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_LT_EQ] = ACTIONS(147),
    [aux_sym_identifier_token1] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(147),
    [anon_sym_fun] = ACTIONS(149),
    [anon_sym_when] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(147),
    [anon_sym_as] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(147),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_true] = ACTIONS(149),
    [ts_builtin_sym_end] = ACTIONS(153),
    [aux_sym_number_token1] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(149),
    [anon_sym_var] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(149),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(147),
    [anon_sym_SLASH] = ACTIONS(147),
    [anon_sym_GT_EQ] = ACTIONS(147),
  },
  [37] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(93),
    [sym_function_call] = STATE(93),
    [sym_multiplication_expression] = STATE(93),
    [sym_cast_expression] = STATE(93),
    [sym_primary] = STATE(93),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(93),
    [sym_comparison_expression] = STATE(93),
    [sym_addition_expression] = STATE(93),
    [sym_identifier] = STATE(31),
    [sym_number] = STATE(29),
    [sym_clause_result] = STATE(94),
    [sym_range_literal] = STATE(93),
    [sym_unary_expression] = STATE(93),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_true] = ACTIONS(37),
  },
  [38] = {
    [anon_sym_LPAREN] = ACTIONS(155),
  },
  [39] = {
    [anon_sym_LPAREN] = ACTIONS(157),
  },
  [40] = {
    [anon_sym_LT] = ACTIONS(159),
    [anon_sym_BANG_EQ] = ACTIONS(159),
    [anon_sym_PERCENT] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(159),
    [anon_sym_PLUS] = ACTIONS(165),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(161),
    [sym_eol] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(159),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(159),
    [anon_sym_SLASH] = ACTIONS(161),
    [anon_sym_GT_EQ] = ACTIONS(159),
  },
  [41] = {
    [sym_function_literal] = STATE(16),
    [sym_variable_declaration] = STATE(15),
    [sym__statement] = STATE(102),
    [sym_return_statement] = STATE(102),
    [sym_map_literal] = STATE(16),
    [sym_assignment] = STATE(19),
    [sym_function_call] = STATE(19),
    [sym_multiplication_expression] = STATE(19),
    [sym_cast_expression] = STATE(19),
    [sym_parenthetical_expression] = STATE(16),
    [sym_primary] = STATE(19),
    [sym__declaration] = STATE(102),
    [sym_function_declaration] = STATE(102),
    [sym_while_statement] = STATE(102),
    [sym_block_statement] = STATE(102),
    [sym_expression_statement] = STATE(102),
    [sym__expression] = STATE(19),
    [sym_comparison_expression] = STATE(19),
    [sym_addition_expression] = STATE(19),
    [sym_list_literal] = STATE(16),
    [aux_sym_source_file_repeat1] = STATE(102),
    [sym_when_statement] = STATE(102),
    [sym_for_statement] = STATE(102),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(19),
    [sym_unary_expression] = STATE(19),
    [sym_bool_literal] = STATE(16),
    [anon_sym_RBRACE] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_fun] = ACTIONS(5),
    [anon_sym_when] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_true] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [aux_sym_number_token1] = ACTIONS(21),
    [anon_sym_for] = ACTIONS(59),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_var] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
  },
  [42] = {
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_as] = ACTIONS(87),
    [anon_sym_STAR] = ACTIONS(87),
    [sym_eol] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(87),
    [anon_sym_EQ] = ACTIONS(169),
    [anon_sym_BANG_EQ] = ACTIONS(87),
    [anon_sym_PERCENT] = ACTIONS(87),
    [anon_sym_LT_EQ] = ACTIONS(87),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_GT_EQ] = ACTIONS(87),
  },
  [43] = {
    [aux_sym_return_statement_repeat1] = STATE(109),
    [anon_sym_LT] = ACTIONS(171),
    [anon_sym_BANG_EQ] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(173),
    [anon_sym_PERCENT] = ACTIONS(175),
    [anon_sym_LT_EQ] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(177),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(175),
    [sym_eol] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(171),
    [anon_sym_DASH] = ACTIONS(177),
    [anon_sym_EQ_EQ] = ACTIONS(171),
    [anon_sym_SLASH] = ACTIONS(175),
    [anon_sym_GT_EQ] = ACTIONS(171),
  },
  [44] = {
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_as] = ACTIONS(87),
    [anon_sym_STAR] = ACTIONS(87),
    [sym_eol] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(87),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(87),
    [anon_sym_PERCENT] = ACTIONS(87),
    [anon_sym_LT_EQ] = ACTIONS(87),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_GT_EQ] = ACTIONS(87),
  },
  [45] = {
    [anon_sym_EQ] = ACTIONS(183),
    [sym_eol] = ACTIONS(185),
    [anon_sym_COLON] = ACTIONS(187),
  },
  [46] = {
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_RBRACE] = ACTIONS(189),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(189),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_as] = ACTIONS(189),
    [anon_sym_STAR] = ACTIONS(189),
    [sym_eol] = ACTIONS(191),
    [anon_sym_GT] = ACTIONS(189),
    [anon_sym_BANG_EQ] = ACTIONS(189),
    [anon_sym_PERCENT] = ACTIONS(189),
    [anon_sym_LT_EQ] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_EQ_EQ] = ACTIONS(189),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(189),
  },
  [47] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(113),
    [sym_function_call] = STATE(113),
    [sym_multiplication_expression] = STATE(113),
    [sym_cast_expression] = STATE(113),
    [sym_primary] = STATE(113),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(113),
    [sym_comparison_expression] = STATE(113),
    [sym_addition_expression] = STATE(113),
    [sym_parameter_list] = STATE(75),
    [sym_parameter] = STATE(56),
    [sym_identifier] = STATE(57),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(113),
    [sym_unary_expression] = STATE(113),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(115),
  },
  [48] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(114),
    [sym_function_call] = STATE(114),
    [sym_multiplication_expression] = STATE(114),
    [sym_cast_expression] = STATE(114),
    [sym_primary] = STATE(114),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(114),
    [sym_comparison_expression] = STATE(114),
    [sym_addition_expression] = STATE(114),
    [sym_identifier] = STATE(31),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(114),
    [sym_unary_expression] = STATE(114),
    [sym_bool_literal] = STATE(29),
    [anon_sym_RBRACE] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [49] = {
    [aux_sym_return_statement_repeat1] = STATE(121),
    [anon_sym_LT] = ACTIONS(193),
    [anon_sym_COMMA] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(197),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(199),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(193),
    [anon_sym_BANG_EQ] = ACTIONS(203),
    [anon_sym_PERCENT] = ACTIONS(199),
    [anon_sym_RBRACK] = ACTIONS(205),
    [anon_sym_LT_EQ] = ACTIONS(203),
    [anon_sym_DASH] = ACTIONS(197),
    [anon_sym_EQ_EQ] = ACTIONS(203),
    [anon_sym_SLASH] = ACTIONS(199),
    [anon_sym_DOT_DOT_LT] = ACTIONS(201),
    [anon_sym_GT_EQ] = ACTIONS(203),
  },
  [50] = {
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_COMMA] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_as] = ACTIONS(89),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(87),
    [anon_sym_EQ] = ACTIONS(207),
    [anon_sym_BANG_EQ] = ACTIONS(89),
    [anon_sym_PERCENT] = ACTIONS(89),
    [anon_sym_RBRACK] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(89),
    [anon_sym_EQ_EQ] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(89),
    [anon_sym_DOT_DOT_LT] = ACTIONS(89),
    [anon_sym_GT_EQ] = ACTIONS(89),
  },
  [51] = {
    [sym_variable_declaration] = STATE(124),
    [anon_sym_var] = ACTIONS(209),
    [anon_sym_let] = ACTIONS(209),
  },
  [52] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(125),
    [sym_function_call] = STATE(125),
    [sym_multiplication_expression] = STATE(125),
    [sym_cast_expression] = STATE(125),
    [sym_primary] = STATE(125),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(125),
    [sym_comparison_expression] = STATE(125),
    [sym_addition_expression] = STATE(125),
    [sym_identifier] = STATE(126),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(125),
    [sym_unary_expression] = STATE(125),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [53] = {
    [sym_block_statement] = STATE(129),
    [anon_sym_LBRACE] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(213),
  },
  [54] = {
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(217),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(221),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(221),
    [anon_sym_EQ_EQ] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(223),
  },
  [55] = {
    [anon_sym_RPAREN] = ACTIONS(225),
  },
  [56] = {
    [aux_sym_parameter_list_repeat1] = STATE(136),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_RPAREN] = ACTIONS(229),
  },
  [57] = {
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_as] = ACTIONS(89),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(87),
    [anon_sym_RPAREN] = ACTIONS(89),
    [anon_sym_EQ] = ACTIONS(233),
    [anon_sym_BANG_EQ] = ACTIONS(89),
    [anon_sym_PERCENT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(89),
    [anon_sym_EQ_EQ] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(89),
    [anon_sym_GT_EQ] = ACTIONS(89),
  },
  [58] = {
    [anon_sym_RBRACE] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(237),
    [anon_sym_fun] = ACTIONS(237),
    [anon_sym_when] = ACTIONS(237),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(237),
    [anon_sym_return] = ACTIONS(237),
    [anon_sym_let] = ACTIONS(237),
    [ts_builtin_sym_end] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [aux_sym_number_token1] = ACTIONS(235),
    [anon_sym_for] = ACTIONS(237),
    [aux_sym_identifier_token1] = ACTIONS(237),
    [anon_sym_while] = ACTIONS(237),
    [anon_sym_var] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
  },
  [59] = {
    [sym_function_literal] = STATE(16),
    [sym_variable_declaration] = STATE(15),
    [sym__statement] = STATE(59),
    [sym_return_statement] = STATE(59),
    [sym_map_literal] = STATE(16),
    [sym_assignment] = STATE(19),
    [sym_function_call] = STATE(19),
    [sym_multiplication_expression] = STATE(19),
    [sym_cast_expression] = STATE(19),
    [sym_parenthetical_expression] = STATE(16),
    [sym_primary] = STATE(19),
    [sym__declaration] = STATE(59),
    [sym_function_declaration] = STATE(59),
    [sym_while_statement] = STATE(59),
    [sym_block_statement] = STATE(59),
    [sym_expression_statement] = STATE(59),
    [sym__expression] = STATE(19),
    [sym_comparison_expression] = STATE(19),
    [sym_addition_expression] = STATE(19),
    [sym_list_literal] = STATE(16),
    [aux_sym_source_file_repeat1] = STATE(59),
    [sym_when_statement] = STATE(59),
    [sym_for_statement] = STATE(59),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(19),
    [sym_unary_expression] = STATE(19),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(242),
    [anon_sym_when] = ACTIONS(245),
    [anon_sym_BANG] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(239),
    [anon_sym_return] = ACTIONS(254),
    [anon_sym_let] = ACTIONS(257),
    [ts_builtin_sym_end] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [aux_sym_number_token1] = ACTIONS(265),
    [anon_sym_for] = ACTIONS(268),
    [aux_sym_identifier_token1] = ACTIONS(271),
    [anon_sym_while] = ACTIONS(274),
    [anon_sym_var] = ACTIONS(257),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(248),
  },
  [60] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_assignment] = STATE(139),
    [sym_function_call] = STATE(139),
    [sym_multiplication_expression] = STATE(139),
    [sym_cast_expression] = STATE(139),
    [sym_primary] = STATE(139),
    [sym_list_literal] = STATE(16),
    [sym__expression] = STATE(139),
    [sym_comparison_expression] = STATE(139),
    [sym_addition_expression] = STATE(139),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(139),
    [sym_unary_expression] = STATE(139),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(9),
    [aux_sym_number_token1] = ACTIONS(21),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(3),
  },
  [61] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_assignment] = STATE(140),
    [sym_function_call] = STATE(140),
    [sym_multiplication_expression] = STATE(140),
    [sym_cast_expression] = STATE(140),
    [sym_primary] = STATE(140),
    [sym_list_literal] = STATE(16),
    [sym__expression] = STATE(140),
    [sym_comparison_expression] = STATE(140),
    [sym_addition_expression] = STATE(140),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(140),
    [sym_unary_expression] = STATE(140),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(9),
    [aux_sym_number_token1] = ACTIONS(21),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(3),
  },
  [62] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_assignment] = STATE(141),
    [sym_function_call] = STATE(141),
    [sym_multiplication_expression] = STATE(141),
    [sym_cast_expression] = STATE(141),
    [sym_primary] = STATE(141),
    [sym_list_literal] = STATE(16),
    [sym__expression] = STATE(141),
    [sym_comparison_expression] = STATE(141),
    [sym_addition_expression] = STATE(141),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(141),
    [sym_unary_expression] = STATE(141),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(9),
    [aux_sym_number_token1] = ACTIONS(21),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(3),
  },
  [63] = {
    [sym_map_type] = STATE(145),
    [sym_primitive_type] = STATE(145),
    [sym_list_type] = STATE(145),
    [sym__type] = STATE(145),
    [anon_sym_int16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_int8] = ACTIONS(280),
    [anon_sym_LBRACK] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_float64] = ACTIONS(280),
    [anon_sym_bool] = ACTIONS(280),
    [anon_sym_int64] = ACTIONS(280),
    [anon_sym_float32] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(284),
    [anon_sym_string] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
  },
  [64] = {
    [anon_sym_RBRACE] = ACTIONS(286),
    [anon_sym_false] = ACTIONS(288),
    [anon_sym_fun] = ACTIONS(288),
    [anon_sym_when] = ACTIONS(288),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(286),
    [anon_sym_true] = ACTIONS(288),
    [anon_sym_return] = ACTIONS(288),
    [anon_sym_let] = ACTIONS(288),
    [ts_builtin_sym_end] = ACTIONS(286),
    [anon_sym_LBRACK] = ACTIONS(286),
    [aux_sym_number_token1] = ACTIONS(286),
    [anon_sym_for] = ACTIONS(288),
    [aux_sym_identifier_token1] = ACTIONS(288),
    [anon_sym_while] = ACTIONS(288),
    [anon_sym_var] = ACTIONS(288),
    [anon_sym_LPAREN] = ACTIONS(286),
    [anon_sym_DASH] = ACTIONS(286),
  },
  [65] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_assignment] = STATE(146),
    [sym_function_call] = STATE(146),
    [sym_multiplication_expression] = STATE(146),
    [sym_cast_expression] = STATE(146),
    [sym_primary] = STATE(146),
    [sym_list_literal] = STATE(16),
    [sym__expression] = STATE(146),
    [sym_comparison_expression] = STATE(146),
    [sym_addition_expression] = STATE(146),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(146),
    [sym_unary_expression] = STATE(146),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(9),
    [aux_sym_number_token1] = ACTIONS(21),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(3),
  },
  [66] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(148),
    [sym_function_call] = STATE(148),
    [sym_multiplication_expression] = STATE(148),
    [sym_cast_expression] = STATE(148),
    [sym_primary] = STATE(148),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(148),
    [sym_comparison_expression] = STATE(148),
    [sym_addition_expression] = STATE(148),
    [sym_identifier] = STATE(149),
    [sym_number] = STATE(29),
    [sym_argument_list] = STATE(150),
    [sym_range_literal] = STATE(148),
    [sym_unary_expression] = STATE(148),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(290),
  },
  [67] = {
    [sym_parameter_list] = STATE(152),
    [sym_parameter] = STATE(56),
    [sym_identifier] = STATE(153),
    [aux_sym_identifier_token1] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(292),
  },
  [68] = {
    [anon_sym_RBRACE] = ACTIONS(294),
    [anon_sym_false] = ACTIONS(296),
    [anon_sym_fun] = ACTIONS(296),
    [anon_sym_when] = ACTIONS(296),
    [anon_sym_BANG] = ACTIONS(294),
    [anon_sym_LBRACE] = ACTIONS(294),
    [anon_sym_true] = ACTIONS(296),
    [anon_sym_return] = ACTIONS(296),
    [anon_sym_let] = ACTIONS(296),
    [ts_builtin_sym_end] = ACTIONS(294),
    [anon_sym_LBRACK] = ACTIONS(294),
    [aux_sym_number_token1] = ACTIONS(294),
    [anon_sym_for] = ACTIONS(296),
    [aux_sym_identifier_token1] = ACTIONS(296),
    [anon_sym_while] = ACTIONS(296),
    [anon_sym_var] = ACTIONS(296),
    [anon_sym_LPAREN] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
  },
  [69] = {
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_RBRACE] = ACTIONS(191),
    [anon_sym_COMMA] = ACTIONS(191),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_PLUS] = ACTIONS(191),
    [anon_sym_as] = ACTIONS(191),
    [anon_sym_STAR] = ACTIONS(191),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(191),
    [anon_sym_GT] = ACTIONS(189),
    [anon_sym_in] = ACTIONS(191),
    [anon_sym_RPAREN] = ACTIONS(191),
    [anon_sym_BANG_EQ] = ACTIONS(191),
    [anon_sym_PERCENT] = ACTIONS(191),
    [anon_sym_RBRACK] = ACTIONS(191),
    [anon_sym_LT_EQ] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(191),
    [anon_sym_EQ_EQ] = ACTIONS(191),
    [anon_sym_SLASH] = ACTIONS(191),
    [anon_sym_DOT_DOT_LT] = ACTIONS(191),
    [anon_sym_GT_EQ] = ACTIONS(191),
  },
  [70] = {
    [aux_sym_return_statement_repeat1] = STATE(157),
    [anon_sym_LT] = ACTIONS(193),
    [anon_sym_COMMA] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(197),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(199),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_GT] = ACTIONS(193),
    [anon_sym_BANG_EQ] = ACTIONS(203),
    [anon_sym_PERCENT] = ACTIONS(199),
    [anon_sym_RBRACK] = ACTIONS(302),
    [anon_sym_LT_EQ] = ACTIONS(203),
    [anon_sym_DASH] = ACTIONS(197),
    [anon_sym_EQ_EQ] = ACTIONS(203),
    [anon_sym_SLASH] = ACTIONS(199),
    [anon_sym_DOT_DOT_LT] = ACTIONS(300),
    [anon_sym_GT_EQ] = ACTIONS(203),
  },
  [71] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(158),
    [sym_function_call] = STATE(158),
    [sym_multiplication_expression] = STATE(158),
    [sym_cast_expression] = STATE(158),
    [sym_primary] = STATE(158),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(158),
    [sym_comparison_expression] = STATE(158),
    [sym_addition_expression] = STATE(158),
    [sym_identifier] = STATE(90),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(158),
    [sym_unary_expression] = STATE(158),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [72] = {
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_RBRACE] = ACTIONS(145),
    [anon_sym_COMMA] = ACTIONS(145),
    [anon_sym_COLON] = ACTIONS(145),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_as] = ACTIONS(145),
    [anon_sym_STAR] = ACTIONS(145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(145),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_in] = ACTIONS(145),
    [anon_sym_RPAREN] = ACTIONS(145),
    [anon_sym_BANG_EQ] = ACTIONS(145),
    [anon_sym_PERCENT] = ACTIONS(145),
    [anon_sym_RBRACK] = ACTIONS(145),
    [anon_sym_LT_EQ] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_EQ_EQ] = ACTIONS(145),
    [anon_sym_SLASH] = ACTIONS(145),
    [anon_sym_DOT_DOT_LT] = ACTIONS(145),
    [anon_sym_GT_EQ] = ACTIONS(145),
  },
  [73] = {
    [sym_block_statement] = STATE(161),
    [anon_sym_LBRACE] = ACTIONS(304),
    [anon_sym_COLON] = ACTIONS(306),
  },
  [74] = {
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(217),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(221),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(221),
    [anon_sym_EQ_EQ] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(308),
  },
  [75] = {
    [anon_sym_RPAREN] = ACTIONS(310),
  },
  [76] = {
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_RBRACE] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(151),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_as] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_in] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_PERCENT] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_DOT_DOT_LT] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(151),
  },
  [77] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [aux_sym_clause_list_repeat1] = STATE(164),
    [sym_assignment] = STATE(165),
    [sym_function_call] = STATE(165),
    [sym_multiplication_expression] = STATE(165),
    [sym_cast_expression] = STATE(165),
    [sym_primary] = STATE(165),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(165),
    [sym_comparison_expression] = STATE(165),
    [sym_addition_expression] = STATE(165),
    [sym_identifier] = STATE(31),
    [sym_number] = STATE(29),
    [sym_clause_result] = STATE(164),
    [sym_range_literal] = STATE(165),
    [sym_unary_expression] = STATE(165),
    [sym_bool_literal] = STATE(29),
    [anon_sym_RBRACE] = ACTIONS(312),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_else] = ACTIONS(314),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [78] = {
    [anon_sym_LT] = ACTIONS(119),
    [anon_sym_BANG_EQ] = ACTIONS(121),
    [anon_sym_PERCENT] = ACTIONS(123),
    [anon_sym_COLON] = ACTIONS(316),
    [anon_sym_LT_EQ] = ACTIONS(121),
    [anon_sym_PLUS] = ACTIONS(127),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_GT] = ACTIONS(119),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_EQ_EQ] = ACTIONS(121),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_GT_EQ] = ACTIONS(121),
  },
  [79] = {
    [sym_else_result] = STATE(169),
    [anon_sym_RBRACE] = ACTIONS(318),
    [anon_sym_else] = ACTIONS(320),
  },
  [80] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(170),
    [sym_function_call] = STATE(170),
    [sym_multiplication_expression] = STATE(170),
    [sym_cast_expression] = STATE(170),
    [sym_primary] = STATE(170),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(170),
    [sym_comparison_expression] = STATE(170),
    [sym_addition_expression] = STATE(170),
    [sym_identifier] = STATE(31),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(170),
    [sym_unary_expression] = STATE(170),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [81] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(171),
    [sym_function_call] = STATE(171),
    [sym_multiplication_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym_primary] = STATE(171),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(171),
    [sym_comparison_expression] = STATE(171),
    [sym_addition_expression] = STATE(171),
    [sym_identifier] = STATE(31),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(171),
    [sym_unary_expression] = STATE(171),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [82] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(177),
    [sym__statement] = STATE(177),
    [sym_assignment] = STATE(178),
    [sym_function_call] = STATE(178),
    [sym_multiplication_expression] = STATE(178),
    [sym_cast_expression] = STATE(178),
    [sym_primary] = STATE(178),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(177),
    [sym_block_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym__expression] = STATE(178),
    [sym_comparison_expression] = STATE(178),
    [sym_addition_expression] = STATE(178),
    [sym_when_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(178),
    [sym_unary_expression] = STATE(178),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(322),
    [anon_sym_for] = ACTIONS(324),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(326),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(328),
    [anon_sym_return] = ACTIONS(330),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [83] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(179),
    [sym_function_call] = STATE(179),
    [sym_multiplication_expression] = STATE(179),
    [sym_cast_expression] = STATE(179),
    [sym_primary] = STATE(179),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(179),
    [sym_comparison_expression] = STATE(179),
    [sym_addition_expression] = STATE(179),
    [sym_identifier] = STATE(31),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(179),
    [sym_unary_expression] = STATE(179),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [84] = {
    [sym_map_type] = STATE(183),
    [sym_primitive_type] = STATE(183),
    [sym_list_type] = STATE(183),
    [sym__type] = STATE(183),
    [anon_sym_int16] = ACTIONS(332),
    [anon_sym_uint32] = ACTIONS(332),
    [anon_sym_int8] = ACTIONS(332),
    [anon_sym_LBRACK] = ACTIONS(334),
    [anon_sym_int32] = ACTIONS(332),
    [anon_sym_uint64] = ACTIONS(332),
    [anon_sym_float64] = ACTIONS(332),
    [anon_sym_bool] = ACTIONS(332),
    [anon_sym_int64] = ACTIONS(332),
    [anon_sym_float32] = ACTIONS(332),
    [anon_sym_uint16] = ACTIONS(332),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_string] = ACTIONS(332),
    [anon_sym_uint8] = ACTIONS(332),
  },
  [85] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(184),
    [sym_function_call] = STATE(184),
    [sym_multiplication_expression] = STATE(184),
    [sym_cast_expression] = STATE(184),
    [sym_primary] = STATE(184),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(184),
    [sym_comparison_expression] = STATE(184),
    [sym_addition_expression] = STATE(184),
    [sym_identifier] = STATE(31),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(184),
    [sym_unary_expression] = STATE(184),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [86] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(148),
    [sym_function_call] = STATE(148),
    [sym_multiplication_expression] = STATE(148),
    [sym_cast_expression] = STATE(148),
    [sym_primary] = STATE(148),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(148),
    [sym_comparison_expression] = STATE(148),
    [sym_addition_expression] = STATE(148),
    [sym_identifier] = STATE(149),
    [sym_number] = STATE(29),
    [sym_argument_list] = STATE(186),
    [sym_range_literal] = STATE(148),
    [sym_unary_expression] = STATE(148),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(338),
  },
  [87] = {
    [anon_sym_COLON] = ACTIONS(340),
  },
  [88] = {
    [anon_sym_RBRACE] = ACTIONS(342),
    [anon_sym_false] = ACTIONS(344),
    [anon_sym_fun] = ACTIONS(344),
    [anon_sym_when] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(342),
    [anon_sym_LBRACE] = ACTIONS(342),
    [anon_sym_true] = ACTIONS(344),
    [anon_sym_return] = ACTIONS(344),
    [anon_sym_let] = ACTIONS(344),
    [ts_builtin_sym_end] = ACTIONS(342),
    [anon_sym_LBRACK] = ACTIONS(342),
    [aux_sym_number_token1] = ACTIONS(342),
    [anon_sym_for] = ACTIONS(344),
    [aux_sym_identifier_token1] = ACTIONS(344),
    [anon_sym_while] = ACTIONS(344),
    [anon_sym_var] = ACTIONS(344),
    [anon_sym_LPAREN] = ACTIONS(342),
    [anon_sym_DASH] = ACTIONS(342),
  },
  [89] = {
    [aux_sym_return_statement_repeat1] = STATE(121),
    [anon_sym_LT] = ACTIONS(346),
    [anon_sym_BANG_EQ] = ACTIONS(348),
    [anon_sym_COMMA] = ACTIONS(195),
    [anon_sym_PERCENT] = ACTIONS(350),
    [anon_sym_RBRACK] = ACTIONS(205),
    [anon_sym_LT_EQ] = ACTIONS(348),
    [anon_sym_PLUS] = ACTIONS(352),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(350),
    [anon_sym_GT] = ACTIONS(346),
    [anon_sym_DASH] = ACTIONS(352),
    [anon_sym_EQ_EQ] = ACTIONS(348),
    [anon_sym_SLASH] = ACTIONS(350),
    [anon_sym_GT_EQ] = ACTIONS(348),
  },
  [90] = {
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_COMMA] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_as] = ACTIONS(89),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(87),
    [anon_sym_EQ] = ACTIONS(354),
    [anon_sym_BANG_EQ] = ACTIONS(89),
    [anon_sym_PERCENT] = ACTIONS(89),
    [anon_sym_RBRACK] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(89),
    [anon_sym_EQ_EQ] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(89),
    [anon_sym_GT_EQ] = ACTIONS(89),
  },
  [91] = {
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_RBRACE] = ACTIONS(147),
    [anon_sym_COMMA] = ACTIONS(147),
    [anon_sym_COLON] = ACTIONS(147),
    [anon_sym_PLUS] = ACTIONS(147),
    [anon_sym_as] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(147),
    [sym_eol] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_BANG_EQ] = ACTIONS(147),
    [anon_sym_PERCENT] = ACTIONS(147),
    [anon_sym_LT_EQ] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(147),
    [anon_sym_EQ_EQ] = ACTIONS(147),
    [anon_sym_SLASH] = ACTIONS(147),
    [anon_sym_GT_EQ] = ACTIONS(147),
  },
  [92] = {
    [anon_sym_LT] = ACTIONS(119),
    [anon_sym_BANG_EQ] = ACTIONS(121),
    [anon_sym_PERCENT] = ACTIONS(123),
    [anon_sym_COLON] = ACTIONS(356),
    [anon_sym_LT_EQ] = ACTIONS(121),
    [anon_sym_PLUS] = ACTIONS(127),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_GT] = ACTIONS(119),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_EQ_EQ] = ACTIONS(121),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_GT_EQ] = ACTIONS(121),
  },
  [93] = {
    [anon_sym_LT] = ACTIONS(119),
    [anon_sym_BANG_EQ] = ACTIONS(121),
    [anon_sym_PERCENT] = ACTIONS(123),
    [anon_sym_COLON] = ACTIONS(358),
    [anon_sym_LT_EQ] = ACTIONS(121),
    [anon_sym_PLUS] = ACTIONS(127),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_GT] = ACTIONS(119),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_EQ_EQ] = ACTIONS(121),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_GT_EQ] = ACTIONS(121),
  },
  [94] = {
    [sym_else_result] = STATE(88),
    [anon_sym_RBRACE] = ACTIONS(137),
    [anon_sym_false] = ACTIONS(135),
    [anon_sym_fun] = ACTIONS(135),
    [anon_sym_when] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(137),
    [anon_sym_true] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_let] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(137),
    [aux_sym_number_token1] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(135),
    [aux_sym_identifier_token1] = ACTIONS(135),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_var] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(360),
  },
  [95] = {
    [sym_variable_declaration] = STATE(194),
    [anon_sym_var] = ACTIONS(209),
    [anon_sym_let] = ACTIONS(209),
  },
  [96] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(195),
    [sym_function_call] = STATE(195),
    [sym_multiplication_expression] = STATE(195),
    [sym_cast_expression] = STATE(195),
    [sym_primary] = STATE(195),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(195),
    [sym_comparison_expression] = STATE(195),
    [sym_addition_expression] = STATE(195),
    [sym_identifier] = STATE(126),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(195),
    [sym_unary_expression] = STATE(195),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [97] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_assignment] = STATE(196),
    [sym_function_call] = STATE(196),
    [sym_multiplication_expression] = STATE(196),
    [sym_cast_expression] = STATE(196),
    [sym_primary] = STATE(196),
    [sym_list_literal] = STATE(16),
    [sym__expression] = STATE(196),
    [sym_comparison_expression] = STATE(196),
    [sym_addition_expression] = STATE(196),
    [sym_identifier] = STATE(42),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(196),
    [sym_unary_expression] = STATE(196),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(9),
    [aux_sym_number_token1] = ACTIONS(21),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(3),
  },
  [98] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_assignment] = STATE(140),
    [sym_function_call] = STATE(140),
    [sym_multiplication_expression] = STATE(140),
    [sym_cast_expression] = STATE(140),
    [sym_primary] = STATE(140),
    [sym_list_literal] = STATE(16),
    [sym__expression] = STATE(140),
    [sym_comparison_expression] = STATE(140),
    [sym_addition_expression] = STATE(140),
    [sym_identifier] = STATE(42),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(140),
    [sym_unary_expression] = STATE(140),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(9),
    [aux_sym_number_token1] = ACTIONS(21),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(3),
  },
  [99] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(197),
    [sym_function_call] = STATE(197),
    [sym_multiplication_expression] = STATE(197),
    [sym_cast_expression] = STATE(197),
    [sym_primary] = STATE(197),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(197),
    [sym_comparison_expression] = STATE(197),
    [sym_addition_expression] = STATE(197),
    [sym_identifier] = STATE(198),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(197),
    [sym_unary_expression] = STATE(197),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [100] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_assignment] = STATE(199),
    [sym_function_call] = STATE(199),
    [sym_multiplication_expression] = STATE(199),
    [sym_cast_expression] = STATE(199),
    [sym_primary] = STATE(199),
    [sym_list_literal] = STATE(16),
    [sym__expression] = STATE(199),
    [sym_comparison_expression] = STATE(199),
    [sym_addition_expression] = STATE(199),
    [sym_identifier] = STATE(42),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(199),
    [sym_unary_expression] = STATE(199),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(9),
    [aux_sym_number_token1] = ACTIONS(21),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(3),
  },
  [101] = {
    [anon_sym_RBRACE] = ACTIONS(362),
    [anon_sym_false] = ACTIONS(364),
    [anon_sym_fun] = ACTIONS(364),
    [anon_sym_when] = ACTIONS(364),
    [anon_sym_BANG] = ACTIONS(362),
    [anon_sym_LBRACE] = ACTIONS(362),
    [anon_sym_true] = ACTIONS(364),
    [anon_sym_return] = ACTIONS(364),
    [anon_sym_let] = ACTIONS(364),
    [ts_builtin_sym_end] = ACTIONS(362),
    [anon_sym_LBRACK] = ACTIONS(362),
    [aux_sym_number_token1] = ACTIONS(362),
    [anon_sym_for] = ACTIONS(364),
    [aux_sym_identifier_token1] = ACTIONS(364),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_var] = ACTIONS(364),
    [anon_sym_LPAREN] = ACTIONS(362),
    [anon_sym_DASH] = ACTIONS(362),
  },
  [102] = {
    [sym_function_literal] = STATE(16),
    [sym_variable_declaration] = STATE(15),
    [sym__statement] = STATE(102),
    [sym_return_statement] = STATE(102),
    [sym_map_literal] = STATE(16),
    [sym_assignment] = STATE(19),
    [sym_function_call] = STATE(19),
    [sym_multiplication_expression] = STATE(19),
    [sym_cast_expression] = STATE(19),
    [sym_parenthetical_expression] = STATE(16),
    [sym_primary] = STATE(19),
    [sym__declaration] = STATE(102),
    [sym_function_declaration] = STATE(102),
    [sym_while_statement] = STATE(102),
    [sym_block_statement] = STATE(102),
    [sym_expression_statement] = STATE(102),
    [sym__expression] = STATE(19),
    [sym_comparison_expression] = STATE(19),
    [sym_addition_expression] = STATE(19),
    [sym_list_literal] = STATE(16),
    [aux_sym_source_file_repeat1] = STATE(102),
    [sym_when_statement] = STATE(102),
    [sym_for_statement] = STATE(102),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(19),
    [sym_unary_expression] = STATE(19),
    [sym_bool_literal] = STATE(16),
    [anon_sym_RBRACE] = ACTIONS(260),
    [anon_sym_false] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(242),
    [anon_sym_when] = ACTIONS(366),
    [anon_sym_BANG] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(239),
    [anon_sym_return] = ACTIONS(254),
    [anon_sym_let] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(262),
    [aux_sym_number_token1] = ACTIONS(265),
    [anon_sym_for] = ACTIONS(369),
    [aux_sym_identifier_token1] = ACTIONS(271),
    [anon_sym_while] = ACTIONS(372),
    [anon_sym_var] = ACTIONS(257),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(248),
  },
  [103] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_assignment] = STATE(200),
    [sym_function_call] = STATE(200),
    [sym_multiplication_expression] = STATE(200),
    [sym_cast_expression] = STATE(200),
    [sym_primary] = STATE(200),
    [sym_list_literal] = STATE(16),
    [sym__expression] = STATE(200),
    [sym_comparison_expression] = STATE(200),
    [sym_addition_expression] = STATE(200),
    [sym_identifier] = STATE(42),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(200),
    [sym_unary_expression] = STATE(200),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(9),
    [aux_sym_number_token1] = ACTIONS(21),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(3),
  },
  [104] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_assignment] = STATE(201),
    [sym_function_call] = STATE(201),
    [sym_multiplication_expression] = STATE(201),
    [sym_cast_expression] = STATE(201),
    [sym_primary] = STATE(201),
    [sym_list_literal] = STATE(16),
    [sym__expression] = STATE(201),
    [sym_comparison_expression] = STATE(201),
    [sym_addition_expression] = STATE(201),
    [sym_identifier] = STATE(44),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(201),
    [sym_unary_expression] = STATE(201),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(9),
    [aux_sym_number_token1] = ACTIONS(21),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(3),
  },
  [105] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_assignment] = STATE(202),
    [sym_function_call] = STATE(202),
    [sym_multiplication_expression] = STATE(202),
    [sym_cast_expression] = STATE(202),
    [sym_primary] = STATE(202),
    [sym_list_literal] = STATE(16),
    [sym__expression] = STATE(202),
    [sym_comparison_expression] = STATE(202),
    [sym_addition_expression] = STATE(202),
    [sym_identifier] = STATE(44),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(202),
    [sym_unary_expression] = STATE(202),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(9),
    [aux_sym_number_token1] = ACTIONS(21),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(3),
  },
  [106] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_assignment] = STATE(140),
    [sym_function_call] = STATE(140),
    [sym_multiplication_expression] = STATE(140),
    [sym_cast_expression] = STATE(140),
    [sym_primary] = STATE(140),
    [sym_list_literal] = STATE(16),
    [sym__expression] = STATE(140),
    [sym_comparison_expression] = STATE(140),
    [sym_addition_expression] = STATE(140),
    [sym_identifier] = STATE(44),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(140),
    [sym_unary_expression] = STATE(140),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(9),
    [aux_sym_number_token1] = ACTIONS(21),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(3),
  },
  [107] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_assignment] = STATE(203),
    [sym_function_call] = STATE(203),
    [sym_multiplication_expression] = STATE(203),
    [sym_cast_expression] = STATE(203),
    [sym_primary] = STATE(203),
    [sym_list_literal] = STATE(16),
    [sym__expression] = STATE(203),
    [sym_comparison_expression] = STATE(203),
    [sym_addition_expression] = STATE(203),
    [sym_identifier] = STATE(44),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(203),
    [sym_unary_expression] = STATE(203),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(9),
    [aux_sym_number_token1] = ACTIONS(21),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(3),
  },
  [108] = {
    [anon_sym_RBRACE] = ACTIONS(375),
    [anon_sym_false] = ACTIONS(377),
    [anon_sym_fun] = ACTIONS(377),
    [anon_sym_when] = ACTIONS(377),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(375),
    [anon_sym_true] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(377),
    [anon_sym_let] = ACTIONS(377),
    [ts_builtin_sym_end] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(375),
    [aux_sym_number_token1] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(377),
    [aux_sym_identifier_token1] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_var] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_DASH] = ACTIONS(375),
  },
  [109] = {
    [aux_sym_return_statement_repeat1] = STATE(205),
    [sym_eol] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(173),
  },
  [110] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_assignment] = STATE(206),
    [sym_function_call] = STATE(206),
    [sym_multiplication_expression] = STATE(206),
    [sym_cast_expression] = STATE(206),
    [sym_primary] = STATE(206),
    [sym_list_literal] = STATE(16),
    [sym__expression] = STATE(206),
    [sym_comparison_expression] = STATE(206),
    [sym_addition_expression] = STATE(206),
    [sym_identifier] = STATE(44),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(206),
    [sym_unary_expression] = STATE(206),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(9),
    [aux_sym_number_token1] = ACTIONS(21),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(3),
  },
  [111] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_assignment] = STATE(207),
    [sym_function_call] = STATE(207),
    [sym_multiplication_expression] = STATE(207),
    [sym_cast_expression] = STATE(207),
    [sym_primary] = STATE(207),
    [sym_list_literal] = STATE(16),
    [sym__expression] = STATE(207),
    [sym_comparison_expression] = STATE(207),
    [sym_addition_expression] = STATE(207),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(207),
    [sym_unary_expression] = STATE(207),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(9),
    [aux_sym_number_token1] = ACTIONS(21),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(3),
  },
  [112] = {
    [sym_map_type] = STATE(208),
    [sym_primitive_type] = STATE(208),
    [sym_list_type] = STATE(208),
    [sym__type] = STATE(208),
    [anon_sym_int16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_int8] = ACTIONS(280),
    [anon_sym_LBRACK] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_float64] = ACTIONS(280),
    [anon_sym_bool] = ACTIONS(280),
    [anon_sym_int64] = ACTIONS(280),
    [anon_sym_float32] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(284),
    [anon_sym_string] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
  },
  [113] = {
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(217),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(221),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(221),
    [anon_sym_EQ_EQ] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(381),
  },
  [114] = {
    [anon_sym_LT] = ACTIONS(119),
    [anon_sym_BANG_EQ] = ACTIONS(121),
    [anon_sym_PERCENT] = ACTIONS(123),
    [anon_sym_COLON] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(121),
    [anon_sym_PLUS] = ACTIONS(127),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_GT] = ACTIONS(119),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_EQ_EQ] = ACTIONS(121),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_GT_EQ] = ACTIONS(121),
  },
  [115] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(211),
    [sym_function_call] = STATE(211),
    [sym_multiplication_expression] = STATE(211),
    [sym_cast_expression] = STATE(211),
    [sym_primary] = STATE(211),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(211),
    [sym_comparison_expression] = STATE(211),
    [sym_addition_expression] = STATE(211),
    [sym_identifier] = STATE(50),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(211),
    [sym_unary_expression] = STATE(211),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [116] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(213),
    [sym_function_call] = STATE(213),
    [sym_multiplication_expression] = STATE(213),
    [sym_cast_expression] = STATE(213),
    [sym_primary] = STATE(213),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(213),
    [sym_comparison_expression] = STATE(213),
    [sym_addition_expression] = STATE(213),
    [sym_identifier] = STATE(90),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(213),
    [sym_unary_expression] = STATE(213),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(385),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [117] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(214),
    [sym_function_call] = STATE(214),
    [sym_multiplication_expression] = STATE(214),
    [sym_cast_expression] = STATE(214),
    [sym_primary] = STATE(214),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(214),
    [sym_comparison_expression] = STATE(214),
    [sym_addition_expression] = STATE(214),
    [sym_identifier] = STATE(50),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(214),
    [sym_unary_expression] = STATE(214),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [118] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(171),
    [sym_function_call] = STATE(171),
    [sym_multiplication_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym_primary] = STATE(171),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(171),
    [sym_comparison_expression] = STATE(171),
    [sym_addition_expression] = STATE(171),
    [sym_identifier] = STATE(50),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(171),
    [sym_unary_expression] = STATE(171),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [119] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(215),
    [sym_function_call] = STATE(215),
    [sym_multiplication_expression] = STATE(215),
    [sym_cast_expression] = STATE(215),
    [sym_primary] = STATE(215),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(215),
    [sym_comparison_expression] = STATE(215),
    [sym_addition_expression] = STATE(215),
    [sym_identifier] = STATE(216),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(215),
    [sym_unary_expression] = STATE(215),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [120] = {
    [anon_sym_LT] = ACTIONS(387),
    [anon_sym_RBRACE] = ACTIONS(387),
    [anon_sym_COMMA] = ACTIONS(387),
    [anon_sym_COLON] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_as] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(387),
    [sym_eol] = ACTIONS(389),
    [anon_sym_GT] = ACTIONS(387),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_PERCENT] = ACTIONS(387),
    [anon_sym_LT_EQ] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(387),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_SLASH] = ACTIONS(387),
    [anon_sym_GT_EQ] = ACTIONS(387),
  },
  [121] = {
    [aux_sym_return_statement_repeat1] = STATE(218),
    [anon_sym_COMMA] = ACTIONS(391),
    [anon_sym_RBRACK] = ACTIONS(385),
  },
  [122] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(219),
    [sym_function_call] = STATE(219),
    [sym_multiplication_expression] = STATE(219),
    [sym_cast_expression] = STATE(219),
    [sym_primary] = STATE(219),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(219),
    [sym_comparison_expression] = STATE(219),
    [sym_addition_expression] = STATE(219),
    [sym_identifier] = STATE(50),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(219),
    [sym_unary_expression] = STATE(219),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [123] = {
    [sym_identifier] = STATE(220),
    [aux_sym_identifier_token1] = ACTIONS(35),
  },
  [124] = {
    [anon_sym_in] = ACTIONS(393),
  },
  [125] = {
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(217),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(221),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(221),
    [anon_sym_EQ_EQ] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(395),
  },
  [126] = {
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_as] = ACTIONS(89),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(87),
    [anon_sym_RPAREN] = ACTIONS(89),
    [anon_sym_EQ] = ACTIONS(233),
    [anon_sym_BANG_EQ] = ACTIONS(89),
    [anon_sym_PERCENT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(89),
    [anon_sym_EQ_EQ] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(89),
    [anon_sym_GT_EQ] = ACTIONS(89),
  },
  [127] = {
    [sym_function_literal] = STATE(16),
    [sym_variable_declaration] = STATE(15),
    [sym__statement] = STATE(224),
    [sym_return_statement] = STATE(224),
    [sym_map_literal] = STATE(16),
    [sym_assignment] = STATE(19),
    [sym_function_call] = STATE(19),
    [sym_multiplication_expression] = STATE(19),
    [sym_cast_expression] = STATE(19),
    [sym_parenthetical_expression] = STATE(16),
    [sym_primary] = STATE(19),
    [sym__declaration] = STATE(224),
    [sym_function_declaration] = STATE(224),
    [sym_while_statement] = STATE(224),
    [sym_block_statement] = STATE(224),
    [sym_expression_statement] = STATE(224),
    [sym__expression] = STATE(19),
    [sym_comparison_expression] = STATE(19),
    [sym_addition_expression] = STATE(19),
    [sym_list_literal] = STATE(16),
    [aux_sym_source_file_repeat1] = STATE(224),
    [sym_when_statement] = STATE(224),
    [sym_for_statement] = STATE(224),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(19),
    [sym_unary_expression] = STATE(19),
    [sym_bool_literal] = STATE(16),
    [anon_sym_RBRACE] = ACTIONS(397),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_fun] = ACTIONS(5),
    [anon_sym_when] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_true] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [aux_sym_number_token1] = ACTIONS(21),
    [anon_sym_for] = ACTIONS(59),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_var] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
  },
  [128] = {
    [sym_map_type] = STATE(226),
    [sym_primitive_type] = STATE(226),
    [sym_list_type] = STATE(226),
    [sym_type_list] = STATE(225),
    [sym__type] = STATE(226),
    [anon_sym_int16] = ACTIONS(332),
    [anon_sym_uint32] = ACTIONS(332),
    [anon_sym_int8] = ACTIONS(332),
    [anon_sym_LBRACK] = ACTIONS(334),
    [anon_sym_int32] = ACTIONS(332),
    [anon_sym_uint64] = ACTIONS(332),
    [anon_sym_float64] = ACTIONS(332),
    [anon_sym_bool] = ACTIONS(332),
    [anon_sym_int64] = ACTIONS(332),
    [anon_sym_float32] = ACTIONS(332),
    [anon_sym_uint16] = ACTIONS(332),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_string] = ACTIONS(332),
    [anon_sym_uint8] = ACTIONS(332),
  },
  [129] = {
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_RBRACE] = ACTIONS(399),
    [anon_sym_COMMA] = ACTIONS(399),
    [anon_sym_COLON] = ACTIONS(399),
    [anon_sym_PLUS] = ACTIONS(399),
    [anon_sym_as] = ACTIONS(399),
    [anon_sym_STAR] = ACTIONS(399),
    [sym_eol] = ACTIONS(401),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_BANG_EQ] = ACTIONS(399),
    [anon_sym_PERCENT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(399),
    [anon_sym_EQ_EQ] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(399),
  },
  [130] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(227),
    [sym_function_call] = STATE(227),
    [sym_multiplication_expression] = STATE(227),
    [sym_cast_expression] = STATE(227),
    [sym_primary] = STATE(227),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(227),
    [sym_comparison_expression] = STATE(227),
    [sym_addition_expression] = STATE(227),
    [sym_identifier] = STATE(126),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(227),
    [sym_unary_expression] = STATE(227),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [131] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(171),
    [sym_function_call] = STATE(171),
    [sym_multiplication_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym_primary] = STATE(171),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(171),
    [sym_comparison_expression] = STATE(171),
    [sym_addition_expression] = STATE(171),
    [sym_identifier] = STATE(126),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(171),
    [sym_unary_expression] = STATE(171),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [132] = {
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_RBRACE] = ACTIONS(403),
    [anon_sym_COMMA] = ACTIONS(403),
    [anon_sym_COLON] = ACTIONS(403),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_as] = ACTIONS(403),
    [anon_sym_STAR] = ACTIONS(403),
    [sym_eol] = ACTIONS(405),
    [anon_sym_GT] = ACTIONS(403),
    [anon_sym_BANG_EQ] = ACTIONS(403),
    [anon_sym_PERCENT] = ACTIONS(403),
    [anon_sym_LT_EQ] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_EQ_EQ] = ACTIONS(403),
    [anon_sym_SLASH] = ACTIONS(403),
    [anon_sym_GT_EQ] = ACTIONS(403),
  },
  [133] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(228),
    [sym_function_call] = STATE(228),
    [sym_multiplication_expression] = STATE(228),
    [sym_cast_expression] = STATE(228),
    [sym_primary] = STATE(228),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(228),
    [sym_comparison_expression] = STATE(228),
    [sym_addition_expression] = STATE(228),
    [sym_identifier] = STATE(126),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(228),
    [sym_unary_expression] = STATE(228),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [134] = {
    [sym_block_statement] = STATE(230),
    [anon_sym_LBRACE] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(407),
  },
  [135] = {
    [sym_parameter] = STATE(231),
    [sym_identifier] = STATE(153),
    [aux_sym_identifier_token1] = ACTIONS(35),
  },
  [136] = {
    [aux_sym_parameter_list_repeat1] = STATE(232),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_RPAREN] = ACTIONS(409),
  },
  [137] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(233),
    [sym_function_call] = STATE(233),
    [sym_multiplication_expression] = STATE(233),
    [sym_cast_expression] = STATE(233),
    [sym_primary] = STATE(233),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(233),
    [sym_comparison_expression] = STATE(233),
    [sym_addition_expression] = STATE(233),
    [sym_identifier] = STATE(126),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(233),
    [sym_unary_expression] = STATE(233),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [138] = {
    [sym_map_type] = STATE(234),
    [sym_primitive_type] = STATE(234),
    [sym_list_type] = STATE(234),
    [sym__type] = STATE(234),
    [anon_sym_int16] = ACTIONS(332),
    [anon_sym_uint32] = ACTIONS(332),
    [anon_sym_int8] = ACTIONS(332),
    [anon_sym_LBRACK] = ACTIONS(334),
    [anon_sym_int32] = ACTIONS(332),
    [anon_sym_uint64] = ACTIONS(332),
    [anon_sym_float64] = ACTIONS(332),
    [anon_sym_bool] = ACTIONS(332),
    [anon_sym_int64] = ACTIONS(332),
    [anon_sym_float32] = ACTIONS(332),
    [anon_sym_uint16] = ACTIONS(332),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_string] = ACTIONS(332),
    [anon_sym_uint8] = ACTIONS(332),
  },
  [139] = {
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(99),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(97),
    [sym_eol] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(411),
  },
  [140] = {
    [anon_sym_LT] = ACTIONS(415),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_COLON] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(415),
    [sym_eol] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(415),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(415),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_GT_EQ] = ACTIONS(415),
  },
  [141] = {
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(97),
    [sym_eol] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_DASH] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(419),
  },
  [142] = {
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_COLON] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_as] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(423),
    [sym_eol] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_DASH] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(423),
  },
  [143] = {
    [sym_map_type] = STATE(235),
    [sym_primitive_type] = STATE(235),
    [sym_list_type] = STATE(235),
    [sym__type] = STATE(235),
    [anon_sym_int16] = ACTIONS(332),
    [anon_sym_uint32] = ACTIONS(332),
    [anon_sym_int8] = ACTIONS(332),
    [anon_sym_LBRACK] = ACTIONS(334),
    [anon_sym_int32] = ACTIONS(332),
    [anon_sym_uint64] = ACTIONS(332),
    [anon_sym_float64] = ACTIONS(332),
    [anon_sym_bool] = ACTIONS(332),
    [anon_sym_int64] = ACTIONS(332),
    [anon_sym_float32] = ACTIONS(332),
    [anon_sym_uint16] = ACTIONS(332),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_string] = ACTIONS(332),
    [anon_sym_uint8] = ACTIONS(332),
  },
  [144] = {
    [sym_map_type] = STATE(236),
    [sym_primitive_type] = STATE(236),
    [sym_list_type] = STATE(236),
    [sym__type] = STATE(236),
    [anon_sym_int16] = ACTIONS(332),
    [anon_sym_uint32] = ACTIONS(332),
    [anon_sym_int8] = ACTIONS(332),
    [anon_sym_LBRACK] = ACTIONS(334),
    [anon_sym_int32] = ACTIONS(332),
    [anon_sym_uint64] = ACTIONS(332),
    [anon_sym_float64] = ACTIONS(332),
    [anon_sym_bool] = ACTIONS(332),
    [anon_sym_int64] = ACTIONS(332),
    [anon_sym_float32] = ACTIONS(332),
    [anon_sym_uint16] = ACTIONS(332),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_string] = ACTIONS(332),
    [anon_sym_uint8] = ACTIONS(332),
  },
  [145] = {
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_RBRACE] = ACTIONS(427),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_COLON] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_as] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(427),
    [sym_eol] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(427),
  },
  [146] = {
    [anon_sym_LT] = ACTIONS(95),
    [anon_sym_BANG_EQ] = ACTIONS(95),
    [anon_sym_PERCENT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(95),
    [anon_sym_PLUS] = ACTIONS(99),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(97),
    [sym_eol] = ACTIONS(431),
    [anon_sym_GT] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(95),
  },
  [147] = {
    [anon_sym_LT] = ACTIONS(433),
    [anon_sym_RBRACE] = ACTIONS(433),
    [anon_sym_COMMA] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(433),
    [anon_sym_PLUS] = ACTIONS(433),
    [anon_sym_as] = ACTIONS(433),
    [anon_sym_STAR] = ACTIONS(433),
    [sym_eol] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(433),
    [anon_sym_BANG_EQ] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(433),
    [anon_sym_LT_EQ] = ACTIONS(433),
    [anon_sym_DASH] = ACTIONS(433),
    [anon_sym_EQ_EQ] = ACTIONS(433),
    [anon_sym_SLASH] = ACTIONS(433),
    [anon_sym_GT_EQ] = ACTIONS(433),
  },
  [148] = {
    [aux_sym_return_statement_repeat1] = STATE(241),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_BANG_EQ] = ACTIONS(439),
    [anon_sym_COMMA] = ACTIONS(441),
    [anon_sym_PERCENT] = ACTIONS(443),
    [anon_sym_GT_EQ] = ACTIONS(439),
    [anon_sym_LT_EQ] = ACTIONS(439),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_GT] = ACTIONS(437),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_EQ_EQ] = ACTIONS(439),
    [anon_sym_SLASH] = ACTIONS(443),
    [anon_sym_RPAREN] = ACTIONS(447),
  },
  [149] = {
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_COMMA] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_as] = ACTIONS(89),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(87),
    [anon_sym_RPAREN] = ACTIONS(89),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(89),
    [anon_sym_PERCENT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(89),
    [anon_sym_EQ_EQ] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(89),
    [anon_sym_GT_EQ] = ACTIONS(89),
  },
  [150] = {
    [anon_sym_RPAREN] = ACTIONS(451),
  },
  [151] = {
    [sym_block_statement] = STATE(246),
    [anon_sym_LBRACE] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(455),
  },
  [152] = {
    [anon_sym_RPAREN] = ACTIONS(457),
  },
  [153] = {
    [anon_sym_COLON] = ACTIONS(231),
  },
  [154] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(213),
    [sym_function_call] = STATE(213),
    [sym_multiplication_expression] = STATE(213),
    [sym_cast_expression] = STATE(213),
    [sym_primary] = STATE(213),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(213),
    [sym_comparison_expression] = STATE(213),
    [sym_addition_expression] = STATE(213),
    [sym_identifier] = STATE(90),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(213),
    [sym_unary_expression] = STATE(213),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [155] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(249),
    [sym_function_call] = STATE(249),
    [sym_multiplication_expression] = STATE(249),
    [sym_cast_expression] = STATE(249),
    [sym_primary] = STATE(249),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(249),
    [sym_comparison_expression] = STATE(249),
    [sym_addition_expression] = STATE(249),
    [sym_identifier] = STATE(216),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(249),
    [sym_unary_expression] = STATE(249),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [156] = {
    [anon_sym_LT] = ACTIONS(387),
    [anon_sym_RBRACE] = ACTIONS(389),
    [anon_sym_COMMA] = ACTIONS(389),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_as] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(389),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(389),
    [anon_sym_GT] = ACTIONS(387),
    [anon_sym_in] = ACTIONS(389),
    [anon_sym_RPAREN] = ACTIONS(389),
    [anon_sym_BANG_EQ] = ACTIONS(389),
    [anon_sym_PERCENT] = ACTIONS(389),
    [anon_sym_RBRACK] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_EQ_EQ] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(389),
    [anon_sym_DOT_DOT_LT] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(389),
  },
  [157] = {
    [aux_sym_return_statement_repeat1] = STATE(218),
    [anon_sym_COMMA] = ACTIONS(461),
    [anon_sym_RBRACK] = ACTIONS(459),
  },
  [158] = {
    [aux_sym_return_statement_repeat1] = STATE(157),
    [anon_sym_LT] = ACTIONS(346),
    [anon_sym_BANG_EQ] = ACTIONS(348),
    [anon_sym_COMMA] = ACTIONS(298),
    [anon_sym_PERCENT] = ACTIONS(350),
    [anon_sym_RBRACK] = ACTIONS(302),
    [anon_sym_LT_EQ] = ACTIONS(348),
    [anon_sym_PLUS] = ACTIONS(352),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(350),
    [anon_sym_GT] = ACTIONS(346),
    [anon_sym_DASH] = ACTIONS(352),
    [anon_sym_EQ_EQ] = ACTIONS(348),
    [anon_sym_SLASH] = ACTIONS(350),
    [anon_sym_GT_EQ] = ACTIONS(348),
  },
  [159] = {
    [sym_function_literal] = STATE(16),
    [sym_variable_declaration] = STATE(15),
    [sym__statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_map_literal] = STATE(16),
    [sym_assignment] = STATE(19),
    [sym_function_call] = STATE(19),
    [sym_multiplication_expression] = STATE(19),
    [sym_cast_expression] = STATE(19),
    [sym_parenthetical_expression] = STATE(16),
    [sym_primary] = STATE(19),
    [sym__declaration] = STATE(252),
    [sym_function_declaration] = STATE(252),
    [sym_while_statement] = STATE(252),
    [sym_block_statement] = STATE(252),
    [sym_expression_statement] = STATE(252),
    [sym__expression] = STATE(19),
    [sym_comparison_expression] = STATE(19),
    [sym_addition_expression] = STATE(19),
    [sym_list_literal] = STATE(16),
    [aux_sym_source_file_repeat1] = STATE(252),
    [sym_when_statement] = STATE(252),
    [sym_for_statement] = STATE(252),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(19),
    [sym_unary_expression] = STATE(19),
    [sym_bool_literal] = STATE(16),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_fun] = ACTIONS(5),
    [anon_sym_when] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_true] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [aux_sym_number_token1] = ACTIONS(21),
    [anon_sym_for] = ACTIONS(59),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_var] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
  },
  [160] = {
    [sym_map_type] = STATE(226),
    [sym_primitive_type] = STATE(226),
    [sym_list_type] = STATE(226),
    [sym_type_list] = STATE(253),
    [sym__type] = STATE(226),
    [anon_sym_int16] = ACTIONS(332),
    [anon_sym_uint32] = ACTIONS(332),
    [anon_sym_int8] = ACTIONS(332),
    [anon_sym_LBRACK] = ACTIONS(334),
    [anon_sym_int32] = ACTIONS(332),
    [anon_sym_uint64] = ACTIONS(332),
    [anon_sym_float64] = ACTIONS(332),
    [anon_sym_bool] = ACTIONS(332),
    [anon_sym_int64] = ACTIONS(332),
    [anon_sym_float32] = ACTIONS(332),
    [anon_sym_uint16] = ACTIONS(332),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_string] = ACTIONS(332),
    [anon_sym_uint8] = ACTIONS(332),
  },
  [161] = {
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_RBRACE] = ACTIONS(401),
    [anon_sym_COMMA] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(401),
    [anon_sym_as] = ACTIONS(401),
    [anon_sym_STAR] = ACTIONS(401),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(401),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_in] = ACTIONS(401),
    [anon_sym_RPAREN] = ACTIONS(401),
    [anon_sym_BANG_EQ] = ACTIONS(401),
    [anon_sym_PERCENT] = ACTIONS(401),
    [anon_sym_RBRACK] = ACTIONS(401),
    [anon_sym_LT_EQ] = ACTIONS(401),
    [anon_sym_DASH] = ACTIONS(401),
    [anon_sym_EQ_EQ] = ACTIONS(401),
    [anon_sym_SLASH] = ACTIONS(401),
    [anon_sym_DOT_DOT_LT] = ACTIONS(401),
    [anon_sym_GT_EQ] = ACTIONS(401),
  },
  [162] = {
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_BANG_EQ] = ACTIONS(405),
    [anon_sym_PERCENT] = ACTIONS(405),
    [anon_sym_COLON] = ACTIONS(405),
    [anon_sym_LT_EQ] = ACTIONS(405),
    [anon_sym_PLUS] = ACTIONS(405),
    [anon_sym_as] = ACTIONS(405),
    [anon_sym_STAR] = ACTIONS(405),
    [anon_sym_GT] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(405),
    [anon_sym_EQ_EQ] = ACTIONS(405),
    [anon_sym_SLASH] = ACTIONS(405),
    [anon_sym_LBRACE] = ACTIONS(465),
    [anon_sym_GT_EQ] = ACTIONS(405),
  },
  [163] = {
    [sym_block_statement] = STATE(256),
    [anon_sym_LBRACE] = ACTIONS(304),
    [anon_sym_COLON] = ACTIONS(467),
  },
  [164] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [aux_sym_clause_list_repeat1] = STATE(164),
    [sym_assignment] = STATE(165),
    [sym_function_call] = STATE(165),
    [sym_multiplication_expression] = STATE(165),
    [sym_cast_expression] = STATE(165),
    [sym_primary] = STATE(165),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(165),
    [sym_comparison_expression] = STATE(165),
    [sym_addition_expression] = STATE(165),
    [sym_identifier] = STATE(31),
    [sym_number] = STATE(29),
    [sym_clause_result] = STATE(164),
    [sym_range_literal] = STATE(165),
    [sym_unary_expression] = STATE(165),
    [sym_bool_literal] = STATE(29),
    [anon_sym_RBRACE] = ACTIONS(469),
    [anon_sym_false] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(474),
    [anon_sym_BANG] = ACTIONS(477),
    [aux_sym_number_token1] = ACTIONS(480),
    [anon_sym_else] = ACTIONS(483),
    [aux_sym_identifier_token1] = ACTIONS(485),
    [anon_sym_LPAREN] = ACTIONS(488),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_LBRACE] = ACTIONS(491),
    [anon_sym_true] = ACTIONS(471),
  },
  [165] = {
    [anon_sym_LT] = ACTIONS(119),
    [anon_sym_BANG_EQ] = ACTIONS(121),
    [anon_sym_PERCENT] = ACTIONS(123),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_LT_EQ] = ACTIONS(121),
    [anon_sym_PLUS] = ACTIONS(127),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_GT] = ACTIONS(119),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_EQ_EQ] = ACTIONS(121),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_GT_EQ] = ACTIONS(121),
  },
  [166] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(263),
    [sym__statement] = STATE(263),
    [sym_assignment] = STATE(264),
    [sym_function_call] = STATE(264),
    [sym_multiplication_expression] = STATE(264),
    [sym_cast_expression] = STATE(264),
    [sym_primary] = STATE(264),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(263),
    [sym_block_statement] = STATE(263),
    [sym_expression_statement] = STATE(263),
    [sym__expression] = STATE(264),
    [sym_comparison_expression] = STATE(264),
    [sym_addition_expression] = STATE(264),
    [sym_when_statement] = STATE(263),
    [sym_for_statement] = STATE(263),
    [sym_identifier] = STATE(265),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(264),
    [sym_unary_expression] = STATE(264),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(496),
    [anon_sym_for] = ACTIONS(498),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(500),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(502),
    [anon_sym_return] = ACTIONS(504),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [167] = {
    [anon_sym_RBRACE] = ACTIONS(506),
    [anon_sym_false] = ACTIONS(508),
    [anon_sym_fun] = ACTIONS(508),
    [anon_sym_when] = ACTIONS(508),
    [anon_sym_BANG] = ACTIONS(506),
    [anon_sym_LBRACE] = ACTIONS(506),
    [anon_sym_true] = ACTIONS(508),
    [anon_sym_return] = ACTIONS(508),
    [anon_sym_let] = ACTIONS(508),
    [ts_builtin_sym_end] = ACTIONS(506),
    [anon_sym_LBRACK] = ACTIONS(506),
    [aux_sym_number_token1] = ACTIONS(506),
    [anon_sym_for] = ACTIONS(508),
    [aux_sym_identifier_token1] = ACTIONS(508),
    [anon_sym_while] = ACTIONS(508),
    [anon_sym_var] = ACTIONS(508),
    [anon_sym_LPAREN] = ACTIONS(506),
    [anon_sym_DASH] = ACTIONS(506),
  },
  [168] = {
    [anon_sym_COLON] = ACTIONS(510),
  },
  [169] = {
    [anon_sym_RBRACE] = ACTIONS(512),
  },
  [170] = {
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_BANG_EQ] = ACTIONS(413),
    [anon_sym_PERCENT] = ACTIONS(123),
    [anon_sym_COLON] = ACTIONS(413),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_PLUS] = ACTIONS(127),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_GT_EQ] = ACTIONS(413),
  },
  [171] = {
    [anon_sym_LT] = ACTIONS(415),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_COLON] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(415),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_RBRACK] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_DOT_DOT_LT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(417),
  },
  [172] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(30),
    [sym_function_call] = STATE(30),
    [sym_multiplication_expression] = STATE(30),
    [sym_cast_expression] = STATE(30),
    [sym_primary] = STATE(30),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(30),
    [sym_comparison_expression] = STATE(30),
    [sym_addition_expression] = STATE(30),
    [sym_identifier] = STATE(31),
    [sym_number] = STATE(29),
    [sym_clause_result] = STATE(270),
    [sym_range_literal] = STATE(30),
    [sym_unary_expression] = STATE(30),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(514),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(516),
    [anon_sym_true] = ACTIONS(37),
  },
  [173] = {
    [anon_sym_LPAREN] = ACTIONS(518),
  },
  [174] = {
    [anon_sym_LPAREN] = ACTIONS(520),
  },
  [175] = {
    [sym_function_literal] = STATE(16),
    [sym_variable_declaration] = STATE(15),
    [sym__statement] = STATE(274),
    [sym_return_statement] = STATE(274),
    [sym_map_literal] = STATE(16),
    [sym_assignment] = STATE(40),
    [sym_function_call] = STATE(40),
    [sym_multiplication_expression] = STATE(40),
    [sym_cast_expression] = STATE(40),
    [sym_parenthetical_expression] = STATE(16),
    [sym_primary] = STATE(40),
    [sym__declaration] = STATE(274),
    [sym_function_declaration] = STATE(274),
    [sym_while_statement] = STATE(274),
    [sym_block_statement] = STATE(274),
    [sym_expression_statement] = STATE(274),
    [sym__expression] = STATE(40),
    [sym_comparison_expression] = STATE(40),
    [sym_addition_expression] = STATE(40),
    [sym_list_literal] = STATE(16),
    [aux_sym_source_file_repeat1] = STATE(274),
    [sym_when_statement] = STATE(274),
    [sym_for_statement] = STATE(274),
    [sym_identifier] = STATE(42),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(40),
    [sym_unary_expression] = STATE(40),
    [sym_bool_literal] = STATE(16),
    [anon_sym_RBRACE] = ACTIONS(522),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_fun] = ACTIONS(5),
    [anon_sym_when] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_true] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [aux_sym_number_token1] = ACTIONS(21),
    [anon_sym_for] = ACTIONS(59),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_var] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
  },
  [176] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_assignment] = STATE(275),
    [sym_function_call] = STATE(275),
    [sym_multiplication_expression] = STATE(275),
    [sym_cast_expression] = STATE(275),
    [sym_primary] = STATE(275),
    [sym_list_literal] = STATE(16),
    [sym__expression] = STATE(275),
    [sym_comparison_expression] = STATE(275),
    [sym_addition_expression] = STATE(275),
    [sym_identifier] = STATE(44),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(275),
    [sym_unary_expression] = STATE(275),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(9),
    [aux_sym_number_token1] = ACTIONS(21),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(3),
  },
  [177] = {
    [anon_sym_RBRACE] = ACTIONS(524),
    [anon_sym_false] = ACTIONS(526),
    [anon_sym_BANG] = ACTIONS(524),
    [anon_sym_fun] = ACTIONS(526),
    [anon_sym_when] = ACTIONS(526),
    [anon_sym_LBRACE] = ACTIONS(524),
    [anon_sym_true] = ACTIONS(526),
    [anon_sym_return] = ACTIONS(526),
    [anon_sym_let] = ACTIONS(526),
    [ts_builtin_sym_end] = ACTIONS(524),
    [anon_sym_LBRACK] = ACTIONS(524),
    [aux_sym_number_token1] = ACTIONS(524),
    [anon_sym_for] = ACTIONS(526),
    [anon_sym_else] = ACTIONS(526),
    [anon_sym_while] = ACTIONS(526),
    [anon_sym_var] = ACTIONS(526),
    [anon_sym_LPAREN] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [aux_sym_identifier_token1] = ACTIONS(526),
  },
  [178] = {
    [anon_sym_LT] = ACTIONS(95),
    [anon_sym_BANG_EQ] = ACTIONS(95),
    [anon_sym_PERCENT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(95),
    [anon_sym_PLUS] = ACTIONS(99),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(97),
    [sym_eol] = ACTIONS(528),
    [anon_sym_GT] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(95),
  },
  [179] = {
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(123),
    [anon_sym_COLON] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_DASH] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_GT_EQ] = ACTIONS(421),
  },
  [180] = {
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_RBRACE] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_COLON] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_as] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_RPAREN] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_RBRACK] = ACTIONS(425),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_DOT_DOT_LT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(425),
  },
  [181] = {
    [sym_map_type] = STATE(277),
    [sym_primitive_type] = STATE(277),
    [sym_list_type] = STATE(277),
    [sym__type] = STATE(277),
    [anon_sym_int16] = ACTIONS(332),
    [anon_sym_uint32] = ACTIONS(332),
    [anon_sym_int8] = ACTIONS(332),
    [anon_sym_LBRACK] = ACTIONS(334),
    [anon_sym_int32] = ACTIONS(332),
    [anon_sym_uint64] = ACTIONS(332),
    [anon_sym_float64] = ACTIONS(332),
    [anon_sym_bool] = ACTIONS(332),
    [anon_sym_int64] = ACTIONS(332),
    [anon_sym_float32] = ACTIONS(332),
    [anon_sym_uint16] = ACTIONS(332),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_string] = ACTIONS(332),
    [anon_sym_uint8] = ACTIONS(332),
  },
  [182] = {
    [sym_map_type] = STATE(278),
    [sym_primitive_type] = STATE(278),
    [sym_list_type] = STATE(278),
    [sym__type] = STATE(278),
    [anon_sym_int16] = ACTIONS(332),
    [anon_sym_uint32] = ACTIONS(332),
    [anon_sym_int8] = ACTIONS(332),
    [anon_sym_LBRACK] = ACTIONS(334),
    [anon_sym_int32] = ACTIONS(332),
    [anon_sym_uint64] = ACTIONS(332),
    [anon_sym_float64] = ACTIONS(332),
    [anon_sym_bool] = ACTIONS(332),
    [anon_sym_int64] = ACTIONS(332),
    [anon_sym_float32] = ACTIONS(332),
    [anon_sym_uint16] = ACTIONS(332),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_string] = ACTIONS(332),
    [anon_sym_uint8] = ACTIONS(332),
  },
  [183] = {
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_RBRACE] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(429),
    [anon_sym_COLON] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(429),
    [anon_sym_as] = ACTIONS(429),
    [anon_sym_STAR] = ACTIONS(429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(427),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(429),
    [anon_sym_PERCENT] = ACTIONS(429),
    [anon_sym_RBRACK] = ACTIONS(429),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_DASH] = ACTIONS(429),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_SLASH] = ACTIONS(429),
    [anon_sym_DOT_DOT_LT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(429),
  },
  [184] = {
    [anon_sym_LT] = ACTIONS(119),
    [anon_sym_BANG_EQ] = ACTIONS(121),
    [anon_sym_PERCENT] = ACTIONS(123),
    [anon_sym_COLON] = ACTIONS(431),
    [anon_sym_LT_EQ] = ACTIONS(121),
    [anon_sym_PLUS] = ACTIONS(127),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_GT] = ACTIONS(119),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_EQ_EQ] = ACTIONS(121),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_GT_EQ] = ACTIONS(121),
  },
  [185] = {
    [anon_sym_LT] = ACTIONS(433),
    [anon_sym_RBRACE] = ACTIONS(435),
    [anon_sym_COMMA] = ACTIONS(435),
    [anon_sym_COLON] = ACTIONS(435),
    [anon_sym_PLUS] = ACTIONS(435),
    [anon_sym_as] = ACTIONS(435),
    [anon_sym_STAR] = ACTIONS(435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(433),
    [anon_sym_in] = ACTIONS(435),
    [anon_sym_RPAREN] = ACTIONS(435),
    [anon_sym_BANG_EQ] = ACTIONS(435),
    [anon_sym_PERCENT] = ACTIONS(435),
    [anon_sym_RBRACK] = ACTIONS(435),
    [anon_sym_LT_EQ] = ACTIONS(435),
    [anon_sym_DASH] = ACTIONS(435),
    [anon_sym_EQ_EQ] = ACTIONS(435),
    [anon_sym_SLASH] = ACTIONS(435),
    [anon_sym_DOT_DOT_LT] = ACTIONS(435),
    [anon_sym_GT_EQ] = ACTIONS(435),
  },
  [186] = {
    [anon_sym_RPAREN] = ACTIONS(530),
  },
  [187] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(280),
    [sym__statement] = STATE(280),
    [sym_assignment] = STATE(19),
    [sym_function_call] = STATE(19),
    [sym_multiplication_expression] = STATE(19),
    [sym_cast_expression] = STATE(19),
    [sym_primary] = STATE(19),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(280),
    [sym_block_statement] = STATE(280),
    [sym_expression_statement] = STATE(280),
    [sym__expression] = STATE(19),
    [sym_comparison_expression] = STATE(19),
    [sym_addition_expression] = STATE(19),
    [sym_when_statement] = STATE(280),
    [sym_for_statement] = STATE(280),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(19),
    [sym_unary_expression] = STATE(19),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(23),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [188] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(281),
    [sym_function_call] = STATE(281),
    [sym_multiplication_expression] = STATE(281),
    [sym_cast_expression] = STATE(281),
    [sym_primary] = STATE(281),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(281),
    [sym_comparison_expression] = STATE(281),
    [sym_addition_expression] = STATE(281),
    [sym_identifier] = STATE(90),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(281),
    [sym_unary_expression] = STATE(281),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [189] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(171),
    [sym_function_call] = STATE(171),
    [sym_multiplication_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym_primary] = STATE(171),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(171),
    [sym_comparison_expression] = STATE(171),
    [sym_addition_expression] = STATE(171),
    [sym_identifier] = STATE(90),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(171),
    [sym_unary_expression] = STATE(171),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [190] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(282),
    [sym_function_call] = STATE(282),
    [sym_multiplication_expression] = STATE(282),
    [sym_cast_expression] = STATE(282),
    [sym_primary] = STATE(282),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(282),
    [sym_comparison_expression] = STATE(282),
    [sym_addition_expression] = STATE(282),
    [sym_identifier] = STATE(90),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(282),
    [sym_unary_expression] = STATE(282),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [191] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(283),
    [sym_function_call] = STATE(283),
    [sym_multiplication_expression] = STATE(283),
    [sym_cast_expression] = STATE(283),
    [sym_primary] = STATE(283),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(283),
    [sym_comparison_expression] = STATE(283),
    [sym_addition_expression] = STATE(283),
    [sym_identifier] = STATE(90),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(283),
    [sym_unary_expression] = STATE(283),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [192] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(177),
    [sym__statement] = STATE(177),
    [sym_assignment] = STATE(178),
    [sym_function_call] = STATE(178),
    [sym_multiplication_expression] = STATE(178),
    [sym_cast_expression] = STATE(178),
    [sym_primary] = STATE(178),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(177),
    [sym_block_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym__expression] = STATE(178),
    [sym_comparison_expression] = STATE(178),
    [sym_addition_expression] = STATE(178),
    [sym_when_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(178),
    [sym_unary_expression] = STATE(178),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(536),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(328),
    [anon_sym_return] = ACTIONS(330),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [193] = {
    [anon_sym_COLON] = ACTIONS(538),
  },
  [194] = {
    [anon_sym_in] = ACTIONS(540),
  },
  [195] = {
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(217),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(221),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(221),
    [anon_sym_EQ_EQ] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(542),
  },
  [196] = {
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(165),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(161),
    [sym_eol] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(161),
    [anon_sym_GT_EQ] = ACTIONS(411),
  },
  [197] = {
    [aux_sym_map_literal_repeat1] = STATE(295),
    [anon_sym_LT] = ACTIONS(544),
    [anon_sym_BANG_EQ] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(548),
    [anon_sym_PERCENT] = ACTIONS(550),
    [anon_sym_RBRACE] = ACTIONS(552),
    [anon_sym_LT_EQ] = ACTIONS(546),
    [anon_sym_PLUS] = ACTIONS(554),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(550),
    [anon_sym_GT] = ACTIONS(544),
    [anon_sym_DASH] = ACTIONS(554),
    [anon_sym_EQ_EQ] = ACTIONS(546),
    [anon_sym_SLASH] = ACTIONS(550),
    [anon_sym_GT_EQ] = ACTIONS(546),
  },
  [198] = {
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_RBRACE] = ACTIONS(89),
    [anon_sym_COMMA] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_as] = ACTIONS(89),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(87),
    [anon_sym_EQ] = ACTIONS(556),
    [anon_sym_BANG_EQ] = ACTIONS(89),
    [anon_sym_PERCENT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(89),
    [anon_sym_EQ_EQ] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(89),
    [anon_sym_GT_EQ] = ACTIONS(89),
  },
  [199] = {
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(161),
    [sym_eol] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_DASH] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(161),
    [anon_sym_GT_EQ] = ACTIONS(419),
  },
  [200] = {
    [anon_sym_LT] = ACTIONS(159),
    [anon_sym_BANG_EQ] = ACTIONS(159),
    [anon_sym_PERCENT] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(558),
    [anon_sym_LT_EQ] = ACTIONS(159),
    [anon_sym_PLUS] = ACTIONS(165),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(161),
    [sym_eol] = ACTIONS(431),
    [anon_sym_GT] = ACTIONS(159),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(159),
    [anon_sym_SLASH] = ACTIONS(161),
    [anon_sym_GT_EQ] = ACTIONS(159),
  },
  [201] = {
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(175),
    [anon_sym_LT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(177),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(175),
    [sym_eol] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(177),
    [anon_sym_EQ_EQ] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(175),
    [anon_sym_GT_EQ] = ACTIONS(411),
  },
  [202] = {
    [anon_sym_LT] = ACTIONS(171),
    [anon_sym_BANG_EQ] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(560),
    [anon_sym_PERCENT] = ACTIONS(175),
    [anon_sym_LT_EQ] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(177),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(175),
    [sym_eol] = ACTIONS(562),
    [anon_sym_GT] = ACTIONS(171),
    [anon_sym_DASH] = ACTIONS(177),
    [anon_sym_EQ_EQ] = ACTIONS(171),
    [anon_sym_SLASH] = ACTIONS(175),
    [anon_sym_GT_EQ] = ACTIONS(171),
  },
  [203] = {
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(175),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(175),
    [sym_eol] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_DASH] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(175),
    [anon_sym_GT_EQ] = ACTIONS(419),
  },
  [204] = {
    [anon_sym_RBRACE] = ACTIONS(564),
    [anon_sym_false] = ACTIONS(566),
    [anon_sym_fun] = ACTIONS(566),
    [anon_sym_when] = ACTIONS(566),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LBRACE] = ACTIONS(564),
    [anon_sym_true] = ACTIONS(566),
    [anon_sym_return] = ACTIONS(566),
    [anon_sym_let] = ACTIONS(566),
    [ts_builtin_sym_end] = ACTIONS(564),
    [anon_sym_LBRACK] = ACTIONS(564),
    [aux_sym_number_token1] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [aux_sym_identifier_token1] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(566),
    [anon_sym_var] = ACTIONS(566),
    [anon_sym_LPAREN] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(564),
  },
  [205] = {
    [aux_sym_return_statement_repeat1] = STATE(205),
    [sym_eol] = ACTIONS(562),
    [anon_sym_COMMA] = ACTIONS(568),
  },
  [206] = {
    [anon_sym_LT] = ACTIONS(171),
    [anon_sym_BANG_EQ] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(558),
    [anon_sym_PERCENT] = ACTIONS(175),
    [anon_sym_LT_EQ] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(177),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(175),
    [sym_eol] = ACTIONS(431),
    [anon_sym_GT] = ACTIONS(171),
    [anon_sym_DASH] = ACTIONS(177),
    [anon_sym_EQ_EQ] = ACTIONS(171),
    [anon_sym_SLASH] = ACTIONS(175),
    [anon_sym_GT_EQ] = ACTIONS(171),
  },
  [207] = {
    [anon_sym_LT] = ACTIONS(95),
    [anon_sym_BANG_EQ] = ACTIONS(95),
    [anon_sym_PERCENT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(95),
    [anon_sym_PLUS] = ACTIONS(99),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(97),
    [sym_eol] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(95),
  },
  [208] = {
    [anon_sym_EQ] = ACTIONS(573),
    [sym_eol] = ACTIONS(571),
  },
  [209] = {
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_RBRACE] = ACTIONS(405),
    [anon_sym_COMMA] = ACTIONS(405),
    [anon_sym_COLON] = ACTIONS(405),
    [anon_sym_PLUS] = ACTIONS(405),
    [anon_sym_as] = ACTIONS(405),
    [anon_sym_STAR] = ACTIONS(405),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(405),
    [anon_sym_GT] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_RPAREN] = ACTIONS(405),
    [anon_sym_BANG_EQ] = ACTIONS(405),
    [anon_sym_PERCENT] = ACTIONS(405),
    [anon_sym_RBRACK] = ACTIONS(405),
    [anon_sym_LT_EQ] = ACTIONS(405),
    [anon_sym_DASH] = ACTIONS(405),
    [anon_sym_EQ_EQ] = ACTIONS(405),
    [anon_sym_SLASH] = ACTIONS(405),
    [anon_sym_DOT_DOT_LT] = ACTIONS(405),
    [anon_sym_GT_EQ] = ACTIONS(405),
  },
  [210] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(298),
    [sym_function_call] = STATE(298),
    [sym_multiplication_expression] = STATE(298),
    [sym_cast_expression] = STATE(298),
    [sym_primary] = STATE(298),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(298),
    [sym_comparison_expression] = STATE(298),
    [sym_addition_expression] = STATE(298),
    [sym_identifier] = STATE(198),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(298),
    [sym_unary_expression] = STATE(298),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [211] = {
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_COMMA] = ACTIONS(413),
    [anon_sym_PLUS] = ACTIONS(197),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(199),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_BANG_EQ] = ACTIONS(413),
    [anon_sym_PERCENT] = ACTIONS(199),
    [anon_sym_RBRACK] = ACTIONS(413),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(197),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_SLASH] = ACTIONS(199),
    [anon_sym_DOT_DOT_LT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(413),
  },
  [212] = {
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_RBRACE] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_COLON] = ACTIONS(575),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_STAR] = ACTIONS(575),
    [sym_eol] = ACTIONS(577),
    [anon_sym_GT] = ACTIONS(575),
    [anon_sym_BANG_EQ] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(575),
    [anon_sym_LT_EQ] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(575),
    [anon_sym_GT_EQ] = ACTIONS(575),
  },
  [213] = {
    [anon_sym_LT] = ACTIONS(346),
    [anon_sym_BANG_EQ] = ACTIONS(348),
    [anon_sym_COMMA] = ACTIONS(562),
    [anon_sym_RBRACK] = ACTIONS(562),
    [anon_sym_PERCENT] = ACTIONS(350),
    [anon_sym_LT_EQ] = ACTIONS(348),
    [anon_sym_PLUS] = ACTIONS(352),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(350),
    [anon_sym_GT] = ACTIONS(346),
    [anon_sym_DASH] = ACTIONS(352),
    [anon_sym_EQ_EQ] = ACTIONS(348),
    [anon_sym_SLASH] = ACTIONS(350),
    [anon_sym_GT_EQ] = ACTIONS(348),
  },
  [214] = {
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(199),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(199),
    [anon_sym_RBRACK] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_DASH] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(199),
    [anon_sym_DOT_DOT_LT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(421),
  },
  [215] = {
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_BANG_EQ] = ACTIONS(581),
    [anon_sym_PERCENT] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(585),
    [anon_sym_LT_EQ] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(583),
    [anon_sym_GT] = ACTIONS(579),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_EQ_EQ] = ACTIONS(581),
    [anon_sym_SLASH] = ACTIONS(583),
    [anon_sym_GT_EQ] = ACTIONS(581),
  },
  [216] = {
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_as] = ACTIONS(89),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(87),
    [anon_sym_EQ] = ACTIONS(589),
    [anon_sym_BANG_EQ] = ACTIONS(89),
    [anon_sym_PERCENT] = ACTIONS(89),
    [anon_sym_RBRACK] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(89),
    [anon_sym_EQ_EQ] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(89),
    [anon_sym_GT_EQ] = ACTIONS(89),
  },
  [217] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(213),
    [sym_function_call] = STATE(213),
    [sym_multiplication_expression] = STATE(213),
    [sym_cast_expression] = STATE(213),
    [sym_primary] = STATE(213),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(213),
    [sym_comparison_expression] = STATE(213),
    [sym_addition_expression] = STATE(213),
    [sym_identifier] = STATE(90),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(213),
    [sym_unary_expression] = STATE(213),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(591),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [218] = {
    [aux_sym_return_statement_repeat1] = STATE(218),
    [anon_sym_COMMA] = ACTIONS(593),
    [anon_sym_RBRACK] = ACTIONS(562),
  },
  [219] = {
    [anon_sym_LT] = ACTIONS(193),
    [anon_sym_COMMA] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(197),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(199),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(431),
    [anon_sym_GT] = ACTIONS(193),
    [anon_sym_BANG_EQ] = ACTIONS(203),
    [anon_sym_PERCENT] = ACTIONS(199),
    [anon_sym_RBRACK] = ACTIONS(431),
    [anon_sym_LT_EQ] = ACTIONS(203),
    [anon_sym_DASH] = ACTIONS(197),
    [anon_sym_EQ_EQ] = ACTIONS(203),
    [anon_sym_SLASH] = ACTIONS(199),
    [anon_sym_DOT_DOT_LT] = ACTIONS(431),
    [anon_sym_GT_EQ] = ACTIONS(203),
  },
  [220] = {
    [anon_sym_EQ] = ACTIONS(596),
    [anon_sym_COLON] = ACTIONS(598),
    [anon_sym_in] = ACTIONS(185),
  },
  [221] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(308),
    [sym_function_call] = STATE(308),
    [sym_multiplication_expression] = STATE(308),
    [sym_cast_expression] = STATE(308),
    [sym_primary] = STATE(308),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(308),
    [sym_comparison_expression] = STATE(308),
    [sym_addition_expression] = STATE(308),
    [sym_identifier] = STATE(126),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(308),
    [sym_unary_expression] = STATE(308),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [222] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(309),
    [sym__statement] = STATE(309),
    [sym_assignment] = STATE(19),
    [sym_function_call] = STATE(19),
    [sym_multiplication_expression] = STATE(19),
    [sym_cast_expression] = STATE(19),
    [sym_primary] = STATE(19),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(309),
    [sym_block_statement] = STATE(309),
    [sym_expression_statement] = STATE(309),
    [sym__expression] = STATE(19),
    [sym_comparison_expression] = STATE(19),
    [sym_addition_expression] = STATE(19),
    [sym_when_statement] = STATE(309),
    [sym_for_statement] = STATE(309),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(19),
    [sym_unary_expression] = STATE(19),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(23),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [223] = {
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(149),
    [anon_sym_as] = ACTIONS(149),
    [anon_sym_STAR] = ACTIONS(149),
    [sym_eol] = ACTIONS(153),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(149),
    [anon_sym_PERCENT] = ACTIONS(149),
    [anon_sym_LT_EQ] = ACTIONS(149),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(149),
    [anon_sym_SLASH] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(149),
  },
  [224] = {
    [sym_function_literal] = STATE(16),
    [sym_variable_declaration] = STATE(15),
    [sym__statement] = STATE(102),
    [sym_return_statement] = STATE(102),
    [sym_map_literal] = STATE(16),
    [sym_assignment] = STATE(19),
    [sym_function_call] = STATE(19),
    [sym_multiplication_expression] = STATE(19),
    [sym_cast_expression] = STATE(19),
    [sym_parenthetical_expression] = STATE(16),
    [sym_primary] = STATE(19),
    [sym__declaration] = STATE(102),
    [sym_function_declaration] = STATE(102),
    [sym_while_statement] = STATE(102),
    [sym_block_statement] = STATE(102),
    [sym_expression_statement] = STATE(102),
    [sym__expression] = STATE(19),
    [sym_comparison_expression] = STATE(19),
    [sym_addition_expression] = STATE(19),
    [sym_list_literal] = STATE(16),
    [aux_sym_source_file_repeat1] = STATE(102),
    [sym_when_statement] = STATE(102),
    [sym_for_statement] = STATE(102),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(19),
    [sym_unary_expression] = STATE(19),
    [sym_bool_literal] = STATE(16),
    [anon_sym_RBRACE] = ACTIONS(600),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_fun] = ACTIONS(5),
    [anon_sym_when] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_true] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [aux_sym_number_token1] = ACTIONS(21),
    [anon_sym_for] = ACTIONS(59),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_var] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
  },
  [225] = {
    [sym_block_statement] = STATE(311),
    [anon_sym_LBRACE] = ACTIONS(211),
  },
  [226] = {
    [aux_sym_type_list_repeat1] = STATE(313),
    [anon_sym_LBRACE] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(604),
  },
  [227] = {
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_BANG_EQ] = ACTIONS(413),
    [anon_sym_RPAREN] = ACTIONS(413),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_PLUS] = ACTIONS(221),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(221),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_SLASH] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(413),
  },
  [228] = {
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_RPAREN] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_DASH] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(421),
  },
  [229] = {
    [sym_map_type] = STATE(226),
    [sym_primitive_type] = STATE(226),
    [sym_list_type] = STATE(226),
    [sym_type_list] = STATE(314),
    [sym__type] = STATE(226),
    [anon_sym_int16] = ACTIONS(332),
    [anon_sym_uint32] = ACTIONS(332),
    [anon_sym_int8] = ACTIONS(332),
    [anon_sym_LBRACK] = ACTIONS(334),
    [anon_sym_int32] = ACTIONS(332),
    [anon_sym_uint64] = ACTIONS(332),
    [anon_sym_float64] = ACTIONS(332),
    [anon_sym_bool] = ACTIONS(332),
    [anon_sym_int64] = ACTIONS(332),
    [anon_sym_float32] = ACTIONS(332),
    [anon_sym_uint16] = ACTIONS(332),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_string] = ACTIONS(332),
    [anon_sym_uint8] = ACTIONS(332),
  },
  [230] = {
    [anon_sym_LT] = ACTIONS(606),
    [anon_sym_RBRACE] = ACTIONS(606),
    [anon_sym_COMMA] = ACTIONS(606),
    [anon_sym_COLON] = ACTIONS(606),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_as] = ACTIONS(606),
    [anon_sym_STAR] = ACTIONS(606),
    [sym_eol] = ACTIONS(608),
    [anon_sym_GT] = ACTIONS(606),
    [anon_sym_BANG_EQ] = ACTIONS(606),
    [anon_sym_PERCENT] = ACTIONS(606),
    [anon_sym_LT_EQ] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_EQ_EQ] = ACTIONS(606),
    [anon_sym_SLASH] = ACTIONS(606),
    [anon_sym_GT_EQ] = ACTIONS(606),
  },
  [231] = {
    [anon_sym_COMMA] = ACTIONS(610),
    [anon_sym_RPAREN] = ACTIONS(610),
  },
  [232] = {
    [aux_sym_parameter_list_repeat1] = STATE(232),
    [anon_sym_COMMA] = ACTIONS(612),
    [anon_sym_RPAREN] = ACTIONS(610),
  },
  [233] = {
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(217),
    [anon_sym_RPAREN] = ACTIONS(431),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(221),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(221),
    [anon_sym_EQ_EQ] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
  },
  [234] = {
    [anon_sym_COMMA] = ACTIONS(615),
    [anon_sym_RPAREN] = ACTIONS(615),
  },
  [235] = {
    [anon_sym_RBRACK] = ACTIONS(617),
  },
  [236] = {
    [anon_sym_COLON] = ACTIONS(619),
  },
  [237] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(317),
    [sym_function_call] = STATE(317),
    [sym_multiplication_expression] = STATE(317),
    [sym_cast_expression] = STATE(317),
    [sym_primary] = STATE(317),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(317),
    [sym_comparison_expression] = STATE(317),
    [sym_addition_expression] = STATE(317),
    [sym_identifier] = STATE(149),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(317),
    [sym_unary_expression] = STATE(317),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [238] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(318),
    [sym_function_call] = STATE(318),
    [sym_multiplication_expression] = STATE(318),
    [sym_cast_expression] = STATE(318),
    [sym_primary] = STATE(318),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(318),
    [sym_comparison_expression] = STATE(318),
    [sym_addition_expression] = STATE(318),
    [sym_identifier] = STATE(149),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(318),
    [sym_unary_expression] = STATE(318),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [239] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(171),
    [sym_function_call] = STATE(171),
    [sym_multiplication_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym_primary] = STATE(171),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(171),
    [sym_comparison_expression] = STATE(171),
    [sym_addition_expression] = STATE(171),
    [sym_identifier] = STATE(149),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(171),
    [sym_unary_expression] = STATE(171),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [240] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(319),
    [sym_function_call] = STATE(319),
    [sym_multiplication_expression] = STATE(319),
    [sym_cast_expression] = STATE(319),
    [sym_primary] = STATE(319),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(319),
    [sym_comparison_expression] = STATE(319),
    [sym_addition_expression] = STATE(319),
    [sym_identifier] = STATE(149),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [241] = {
    [aux_sym_return_statement_repeat1] = STATE(320),
    [anon_sym_COMMA] = ACTIONS(441),
    [anon_sym_RPAREN] = ACTIONS(621),
  },
  [242] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(321),
    [sym_function_call] = STATE(321),
    [sym_multiplication_expression] = STATE(321),
    [sym_cast_expression] = STATE(321),
    [sym_primary] = STATE(321),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(321),
    [sym_comparison_expression] = STATE(321),
    [sym_addition_expression] = STATE(321),
    [sym_identifier] = STATE(149),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(321),
    [sym_unary_expression] = STATE(321),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [243] = {
    [anon_sym_LT] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(623),
    [anon_sym_COMMA] = ACTIONS(623),
    [anon_sym_COLON] = ACTIONS(623),
    [anon_sym_PLUS] = ACTIONS(623),
    [anon_sym_as] = ACTIONS(623),
    [anon_sym_STAR] = ACTIONS(623),
    [sym_eol] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(623),
    [anon_sym_EQ_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(623),
    [anon_sym_GT_EQ] = ACTIONS(623),
  },
  [244] = {
    [sym_function_literal] = STATE(16),
    [sym_variable_declaration] = STATE(15),
    [sym__statement] = STATE(41),
    [sym_return_statement] = STATE(41),
    [sym_map_literal] = STATE(16),
    [sym_assignment] = STATE(19),
    [sym_function_call] = STATE(19),
    [sym_multiplication_expression] = STATE(19),
    [sym_cast_expression] = STATE(19),
    [sym_parenthetical_expression] = STATE(16),
    [sym_primary] = STATE(19),
    [sym__declaration] = STATE(41),
    [sym_function_declaration] = STATE(41),
    [sym_while_statement] = STATE(41),
    [sym_block_statement] = STATE(41),
    [sym_expression_statement] = STATE(41),
    [sym__expression] = STATE(19),
    [sym_comparison_expression] = STATE(19),
    [sym_addition_expression] = STATE(19),
    [sym_list_literal] = STATE(16),
    [aux_sym_source_file_repeat1] = STATE(41),
    [sym_when_statement] = STATE(41),
    [sym_for_statement] = STATE(41),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(19),
    [sym_unary_expression] = STATE(19),
    [sym_bool_literal] = STATE(16),
    [anon_sym_RBRACE] = ACTIONS(627),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_fun] = ACTIONS(5),
    [anon_sym_when] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_true] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [aux_sym_number_token1] = ACTIONS(21),
    [anon_sym_for] = ACTIONS(59),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_var] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
  },
  [245] = {
    [sym_map_type] = STATE(226),
    [sym_primitive_type] = STATE(226),
    [sym_list_type] = STATE(226),
    [sym_type_list] = STATE(323),
    [sym__type] = STATE(226),
    [anon_sym_int16] = ACTIONS(332),
    [anon_sym_uint32] = ACTIONS(332),
    [anon_sym_int8] = ACTIONS(332),
    [anon_sym_LBRACK] = ACTIONS(334),
    [anon_sym_int32] = ACTIONS(332),
    [anon_sym_uint64] = ACTIONS(332),
    [anon_sym_float64] = ACTIONS(332),
    [anon_sym_bool] = ACTIONS(332),
    [anon_sym_int64] = ACTIONS(332),
    [anon_sym_float32] = ACTIONS(332),
    [anon_sym_uint16] = ACTIONS(332),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_string] = ACTIONS(332),
    [anon_sym_uint8] = ACTIONS(332),
  },
  [246] = {
    [anon_sym_RBRACE] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(399),
    [anon_sym_fun] = ACTIONS(399),
    [anon_sym_when] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_LBRACE] = ACTIONS(401),
    [anon_sym_true] = ACTIONS(399),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_let] = ACTIONS(399),
    [ts_builtin_sym_end] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(401),
    [aux_sym_number_token1] = ACTIONS(401),
    [anon_sym_for] = ACTIONS(399),
    [aux_sym_identifier_token1] = ACTIONS(399),
    [anon_sym_while] = ACTIONS(399),
    [anon_sym_var] = ACTIONS(399),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_DASH] = ACTIONS(401),
  },
  [247] = {
    [sym_block_statement] = STATE(325),
    [anon_sym_LBRACE] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(629),
  },
  [248] = {
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_RBRACE] = ACTIONS(577),
    [anon_sym_COMMA] = ACTIONS(577),
    [anon_sym_COLON] = ACTIONS(577),
    [anon_sym_PLUS] = ACTIONS(577),
    [anon_sym_as] = ACTIONS(577),
    [anon_sym_STAR] = ACTIONS(577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(577),
    [anon_sym_GT] = ACTIONS(575),
    [anon_sym_in] = ACTIONS(577),
    [anon_sym_RPAREN] = ACTIONS(577),
    [anon_sym_BANG_EQ] = ACTIONS(577),
    [anon_sym_PERCENT] = ACTIONS(577),
    [anon_sym_RBRACK] = ACTIONS(577),
    [anon_sym_LT_EQ] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(577),
    [anon_sym_SLASH] = ACTIONS(577),
    [anon_sym_DOT_DOT_LT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(577),
  },
  [249] = {
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_BANG_EQ] = ACTIONS(581),
    [anon_sym_PERCENT] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(631),
    [anon_sym_LT_EQ] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(583),
    [anon_sym_GT] = ACTIONS(579),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_EQ_EQ] = ACTIONS(581),
    [anon_sym_SLASH] = ACTIONS(583),
    [anon_sym_GT_EQ] = ACTIONS(581),
  },
  [250] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(213),
    [sym_function_call] = STATE(213),
    [sym_multiplication_expression] = STATE(213),
    [sym_cast_expression] = STATE(213),
    [sym_primary] = STATE(213),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(213),
    [sym_comparison_expression] = STATE(213),
    [sym_addition_expression] = STATE(213),
    [sym_identifier] = STATE(90),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(213),
    [sym_unary_expression] = STATE(213),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [251] = {
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(153),
    [anon_sym_COMMA] = ACTIONS(153),
    [anon_sym_COLON] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(153),
    [anon_sym_as] = ACTIONS(153),
    [anon_sym_STAR] = ACTIONS(153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(153),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_in] = ACTIONS(153),
    [anon_sym_RPAREN] = ACTIONS(153),
    [anon_sym_BANG_EQ] = ACTIONS(153),
    [anon_sym_PERCENT] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(153),
    [anon_sym_LT_EQ] = ACTIONS(153),
    [anon_sym_DASH] = ACTIONS(153),
    [anon_sym_EQ_EQ] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(153),
    [anon_sym_DOT_DOT_LT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(153),
  },
  [252] = {
    [sym_function_literal] = STATE(16),
    [sym_variable_declaration] = STATE(15),
    [sym__statement] = STATE(102),
    [sym_return_statement] = STATE(102),
    [sym_map_literal] = STATE(16),
    [sym_assignment] = STATE(19),
    [sym_function_call] = STATE(19),
    [sym_multiplication_expression] = STATE(19),
    [sym_cast_expression] = STATE(19),
    [sym_parenthetical_expression] = STATE(16),
    [sym_primary] = STATE(19),
    [sym__declaration] = STATE(102),
    [sym_function_declaration] = STATE(102),
    [sym_while_statement] = STATE(102),
    [sym_block_statement] = STATE(102),
    [sym_expression_statement] = STATE(102),
    [sym__expression] = STATE(19),
    [sym_comparison_expression] = STATE(19),
    [sym_addition_expression] = STATE(19),
    [sym_list_literal] = STATE(16),
    [aux_sym_source_file_repeat1] = STATE(102),
    [sym_when_statement] = STATE(102),
    [sym_for_statement] = STATE(102),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(19),
    [sym_unary_expression] = STATE(19),
    [sym_bool_literal] = STATE(16),
    [anon_sym_RBRACE] = ACTIONS(635),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_fun] = ACTIONS(5),
    [anon_sym_when] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_true] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [aux_sym_number_token1] = ACTIONS(21),
    [anon_sym_for] = ACTIONS(59),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_var] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
  },
  [253] = {
    [sym_block_statement] = STATE(329),
    [anon_sym_LBRACE] = ACTIONS(304),
  },
  [254] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [aux_sym_clause_list_repeat1] = STATE(77),
    [sym_assignment] = STATE(165),
    [sym_function_call] = STATE(165),
    [sym_multiplication_expression] = STATE(165),
    [sym_cast_expression] = STATE(165),
    [sym_primary] = STATE(165),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(165),
    [sym_comparison_expression] = STATE(165),
    [sym_addition_expression] = STATE(165),
    [sym_identifier] = STATE(31),
    [sym_number] = STATE(29),
    [sym_clause_result] = STATE(77),
    [sym_clause_list] = STATE(330),
    [sym_range_literal] = STATE(165),
    [sym_unary_expression] = STATE(165),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [255] = {
    [sym_map_type] = STATE(226),
    [sym_primitive_type] = STATE(226),
    [sym_list_type] = STATE(226),
    [sym_type_list] = STATE(331),
    [sym__type] = STATE(226),
    [anon_sym_int16] = ACTIONS(332),
    [anon_sym_uint32] = ACTIONS(332),
    [anon_sym_int8] = ACTIONS(332),
    [anon_sym_LBRACK] = ACTIONS(334),
    [anon_sym_int32] = ACTIONS(332),
    [anon_sym_uint64] = ACTIONS(332),
    [anon_sym_float64] = ACTIONS(332),
    [anon_sym_bool] = ACTIONS(332),
    [anon_sym_int64] = ACTIONS(332),
    [anon_sym_float32] = ACTIONS(332),
    [anon_sym_uint16] = ACTIONS(332),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_string] = ACTIONS(332),
    [anon_sym_uint8] = ACTIONS(332),
  },
  [256] = {
    [anon_sym_LT] = ACTIONS(606),
    [anon_sym_RBRACE] = ACTIONS(608),
    [anon_sym_COMMA] = ACTIONS(608),
    [anon_sym_COLON] = ACTIONS(608),
    [anon_sym_PLUS] = ACTIONS(608),
    [anon_sym_as] = ACTIONS(608),
    [anon_sym_STAR] = ACTIONS(608),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(608),
    [anon_sym_GT] = ACTIONS(606),
    [anon_sym_in] = ACTIONS(608),
    [anon_sym_RPAREN] = ACTIONS(608),
    [anon_sym_BANG_EQ] = ACTIONS(608),
    [anon_sym_PERCENT] = ACTIONS(608),
    [anon_sym_RBRACK] = ACTIONS(608),
    [anon_sym_LT_EQ] = ACTIONS(608),
    [anon_sym_DASH] = ACTIONS(608),
    [anon_sym_EQ_EQ] = ACTIONS(608),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_DOT_DOT_LT] = ACTIONS(608),
    [anon_sym_GT_EQ] = ACTIONS(608),
  },
  [257] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(263),
    [sym__statement] = STATE(263),
    [sym_assignment] = STATE(332),
    [sym_function_call] = STATE(332),
    [sym_multiplication_expression] = STATE(332),
    [sym_cast_expression] = STATE(332),
    [sym_primary] = STATE(332),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(263),
    [sym_block_statement] = STATE(263),
    [sym_expression_statement] = STATE(263),
    [sym__expression] = STATE(332),
    [sym_comparison_expression] = STATE(332),
    [sym_addition_expression] = STATE(332),
    [sym_when_statement] = STATE(263),
    [sym_for_statement] = STATE(263),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(332),
    [sym_unary_expression] = STATE(332),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(496),
    [anon_sym_for] = ACTIONS(498),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(500),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(502),
    [anon_sym_return] = ACTIONS(504),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [258] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(165),
    [sym_function_call] = STATE(165),
    [sym_multiplication_expression] = STATE(165),
    [sym_cast_expression] = STATE(165),
    [sym_primary] = STATE(165),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(165),
    [sym_comparison_expression] = STATE(165),
    [sym_addition_expression] = STATE(165),
    [sym_identifier] = STATE(31),
    [sym_number] = STATE(29),
    [sym_clause_result] = STATE(335),
    [sym_range_literal] = STATE(165),
    [sym_unary_expression] = STATE(165),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(639),
    [anon_sym_true] = ACTIONS(37),
  },
  [259] = {
    [anon_sym_LPAREN] = ACTIONS(641),
  },
  [260] = {
    [anon_sym_LPAREN] = ACTIONS(643),
  },
  [261] = {
    [sym_function_literal] = STATE(16),
    [sym_variable_declaration] = STATE(15),
    [sym__statement] = STATE(339),
    [sym_return_statement] = STATE(339),
    [sym_map_literal] = STATE(16),
    [sym_assignment] = STATE(40),
    [sym_function_call] = STATE(40),
    [sym_multiplication_expression] = STATE(40),
    [sym_cast_expression] = STATE(40),
    [sym_parenthetical_expression] = STATE(16),
    [sym_primary] = STATE(40),
    [sym__declaration] = STATE(339),
    [sym_function_declaration] = STATE(339),
    [sym_while_statement] = STATE(339),
    [sym_block_statement] = STATE(339),
    [sym_expression_statement] = STATE(339),
    [sym__expression] = STATE(40),
    [sym_comparison_expression] = STATE(40),
    [sym_addition_expression] = STATE(40),
    [sym_list_literal] = STATE(16),
    [aux_sym_source_file_repeat1] = STATE(339),
    [sym_when_statement] = STATE(339),
    [sym_for_statement] = STATE(339),
    [sym_identifier] = STATE(42),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(40),
    [sym_unary_expression] = STATE(40),
    [sym_bool_literal] = STATE(16),
    [anon_sym_RBRACE] = ACTIONS(645),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_fun] = ACTIONS(5),
    [anon_sym_when] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_true] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [aux_sym_number_token1] = ACTIONS(21),
    [anon_sym_for] = ACTIONS(59),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_var] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
  },
  [262] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_assignment] = STATE(340),
    [sym_function_call] = STATE(340),
    [sym_multiplication_expression] = STATE(340),
    [sym_cast_expression] = STATE(340),
    [sym_primary] = STATE(340),
    [sym_list_literal] = STATE(16),
    [sym__expression] = STATE(340),
    [sym_comparison_expression] = STATE(340),
    [sym_addition_expression] = STATE(340),
    [sym_identifier] = STATE(44),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(340),
    [sym_unary_expression] = STATE(340),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(9),
    [aux_sym_number_token1] = ACTIONS(21),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(3),
  },
  [263] = {
    [anon_sym_RBRACE] = ACTIONS(524),
    [anon_sym_false] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_BANG] = ACTIONS(524),
    [aux_sym_number_token1] = ACTIONS(524),
    [anon_sym_else] = ACTIONS(526),
    [aux_sym_identifier_token1] = ACTIONS(526),
    [anon_sym_LPAREN] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_LBRACE] = ACTIONS(524),
    [anon_sym_true] = ACTIONS(526),
  },
  [264] = {
    [aux_sym_map_literal_repeat1] = STATE(346),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_RBRACE] = ACTIONS(649),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(655),
    [sym_eol] = ACTIONS(657),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(655),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_SLASH] = ACTIONS(655),
    [anon_sym_GT_EQ] = ACTIONS(647),
  },
  [265] = {
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_RBRACE] = ACTIONS(87),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_as] = ACTIONS(87),
    [anon_sym_STAR] = ACTIONS(87),
    [sym_eol] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(87),
    [anon_sym_EQ] = ACTIONS(659),
    [anon_sym_BANG_EQ] = ACTIONS(87),
    [anon_sym_PERCENT] = ACTIONS(87),
    [anon_sym_LT_EQ] = ACTIONS(87),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_GT_EQ] = ACTIONS(87),
  },
  [266] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(280),
    [sym__statement] = STATE(280),
    [sym_assignment] = STATE(19),
    [sym_function_call] = STATE(19),
    [sym_multiplication_expression] = STATE(19),
    [sym_cast_expression] = STATE(19),
    [sym_primary] = STATE(19),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(280),
    [sym_block_statement] = STATE(280),
    [sym_expression_statement] = STATE(280),
    [sym__expression] = STATE(19),
    [sym_comparison_expression] = STATE(19),
    [sym_addition_expression] = STATE(19),
    [sym_when_statement] = STATE(280),
    [sym_for_statement] = STATE(280),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(19),
    [sym_unary_expression] = STATE(19),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(663),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(665),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [267] = {
    [anon_sym_RBRACE] = ACTIONS(669),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_fun] = ACTIONS(671),
    [anon_sym_when] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_return] = ACTIONS(671),
    [anon_sym_let] = ACTIONS(671),
    [ts_builtin_sym_end] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(669),
    [aux_sym_number_token1] = ACTIONS(669),
    [anon_sym_for] = ACTIONS(671),
    [aux_sym_identifier_token1] = ACTIONS(671),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_var] = ACTIONS(671),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(669),
  },
  [268] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(352),
    [sym_function_call] = STATE(352),
    [sym_multiplication_expression] = STATE(352),
    [sym_cast_expression] = STATE(352),
    [sym_primary] = STATE(352),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(352),
    [sym_comparison_expression] = STATE(352),
    [sym_addition_expression] = STATE(352),
    [sym_parameter_list] = STATE(75),
    [sym_parameter] = STATE(56),
    [sym_identifier] = STATE(57),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(352),
    [sym_unary_expression] = STATE(352),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(115),
  },
  [269] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [aux_sym_clause_list_repeat1] = STATE(77),
    [sym_assignment] = STATE(78),
    [sym_function_call] = STATE(78),
    [sym_multiplication_expression] = STATE(78),
    [sym_cast_expression] = STATE(78),
    [sym_primary] = STATE(78),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(78),
    [sym_comparison_expression] = STATE(78),
    [sym_addition_expression] = STATE(78),
    [sym_identifier] = STATE(31),
    [sym_number] = STATE(29),
    [sym_clause_result] = STATE(77),
    [sym_clause_list] = STATE(353),
    [sym_range_literal] = STATE(78),
    [sym_unary_expression] = STATE(78),
    [sym_bool_literal] = STATE(29),
    [anon_sym_RBRACE] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [270] = {
    [sym_else_result] = STATE(354),
    [anon_sym_RBRACE] = ACTIONS(137),
    [anon_sym_false] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_fun] = ACTIONS(135),
    [anon_sym_when] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(137),
    [anon_sym_true] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_let] = ACTIONS(135),
    [ts_builtin_sym_end] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(137),
    [aux_sym_number_token1] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(135),
    [anon_sym_else] = ACTIONS(135),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_var] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [aux_sym_identifier_token1] = ACTIONS(135),
  },
  [271] = {
    [sym_variable_declaration] = STATE(355),
    [anon_sym_var] = ACTIONS(209),
    [anon_sym_let] = ACTIONS(209),
  },
  [272] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(356),
    [sym_function_call] = STATE(356),
    [sym_multiplication_expression] = STATE(356),
    [sym_cast_expression] = STATE(356),
    [sym_primary] = STATE(356),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(356),
    [sym_comparison_expression] = STATE(356),
    [sym_addition_expression] = STATE(356),
    [sym_identifier] = STATE(126),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(356),
    [sym_unary_expression] = STATE(356),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [273] = {
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_false] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(149),
    [sym_eol] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(149),
    [anon_sym_return] = ACTIONS(149),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(147),
    [anon_sym_PERCENT] = ACTIONS(147),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_LT_EQ] = ACTIONS(147),
    [aux_sym_identifier_token1] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(149),
    [anon_sym_fun] = ACTIONS(149),
    [anon_sym_when] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(147),
    [anon_sym_as] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(147),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_true] = ACTIONS(149),
    [ts_builtin_sym_end] = ACTIONS(153),
    [aux_sym_number_token1] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(149),
    [anon_sym_else] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(149),
    [anon_sym_var] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(149),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(147),
    [anon_sym_SLASH] = ACTIONS(147),
    [anon_sym_GT_EQ] = ACTIONS(147),
  },
  [274] = {
    [sym_function_literal] = STATE(16),
    [sym_variable_declaration] = STATE(15),
    [sym__statement] = STATE(102),
    [sym_return_statement] = STATE(102),
    [sym_map_literal] = STATE(16),
    [sym_assignment] = STATE(19),
    [sym_function_call] = STATE(19),
    [sym_multiplication_expression] = STATE(19),
    [sym_cast_expression] = STATE(19),
    [sym_parenthetical_expression] = STATE(16),
    [sym_primary] = STATE(19),
    [sym__declaration] = STATE(102),
    [sym_function_declaration] = STATE(102),
    [sym_while_statement] = STATE(102),
    [sym_block_statement] = STATE(102),
    [sym_expression_statement] = STATE(102),
    [sym__expression] = STATE(19),
    [sym_comparison_expression] = STATE(19),
    [sym_addition_expression] = STATE(19),
    [sym_list_literal] = STATE(16),
    [aux_sym_source_file_repeat1] = STATE(102),
    [sym_when_statement] = STATE(102),
    [sym_for_statement] = STATE(102),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(19),
    [sym_unary_expression] = STATE(19),
    [sym_bool_literal] = STATE(16),
    [anon_sym_RBRACE] = ACTIONS(673),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_fun] = ACTIONS(5),
    [anon_sym_when] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_true] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [aux_sym_number_token1] = ACTIONS(21),
    [anon_sym_for] = ACTIONS(59),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_var] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
  },
  [275] = {
    [aux_sym_return_statement_repeat1] = STATE(359),
    [anon_sym_LT] = ACTIONS(171),
    [anon_sym_BANG_EQ] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(173),
    [anon_sym_PERCENT] = ACTIONS(175),
    [anon_sym_LT_EQ] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(177),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(175),
    [sym_eol] = ACTIONS(675),
    [anon_sym_GT] = ACTIONS(171),
    [anon_sym_DASH] = ACTIONS(177),
    [anon_sym_EQ_EQ] = ACTIONS(171),
    [anon_sym_SLASH] = ACTIONS(175),
    [anon_sym_GT_EQ] = ACTIONS(171),
  },
  [276] = {
    [anon_sym_RBRACE] = ACTIONS(286),
    [anon_sym_false] = ACTIONS(288),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_fun] = ACTIONS(288),
    [anon_sym_when] = ACTIONS(288),
    [anon_sym_LBRACE] = ACTIONS(286),
    [anon_sym_true] = ACTIONS(288),
    [anon_sym_return] = ACTIONS(288),
    [anon_sym_let] = ACTIONS(288),
    [ts_builtin_sym_end] = ACTIONS(286),
    [anon_sym_LBRACK] = ACTIONS(286),
    [aux_sym_number_token1] = ACTIONS(286),
    [anon_sym_for] = ACTIONS(288),
    [anon_sym_else] = ACTIONS(288),
    [anon_sym_while] = ACTIONS(288),
    [anon_sym_var] = ACTIONS(288),
    [anon_sym_LPAREN] = ACTIONS(286),
    [anon_sym_DASH] = ACTIONS(286),
    [aux_sym_identifier_token1] = ACTIONS(288),
  },
  [277] = {
    [anon_sym_RBRACK] = ACTIONS(677),
  },
  [278] = {
    [anon_sym_COLON] = ACTIONS(679),
  },
  [279] = {
    [anon_sym_LT] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(625),
    [anon_sym_COLON] = ACTIONS(625),
    [anon_sym_PLUS] = ACTIONS(625),
    [anon_sym_as] = ACTIONS(625),
    [anon_sym_STAR] = ACTIONS(625),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(623),
    [anon_sym_in] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(625),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_PERCENT] = ACTIONS(625),
    [anon_sym_RBRACK] = ACTIONS(625),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_SLASH] = ACTIONS(625),
    [anon_sym_DOT_DOT_LT] = ACTIONS(625),
    [anon_sym_GT_EQ] = ACTIONS(625),
  },
  [280] = {
    [anon_sym_RBRACE] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(683),
    [anon_sym_fun] = ACTIONS(683),
    [anon_sym_when] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(681),
    [anon_sym_true] = ACTIONS(683),
    [anon_sym_return] = ACTIONS(683),
    [anon_sym_let] = ACTIONS(683),
    [ts_builtin_sym_end] = ACTIONS(681),
    [anon_sym_LBRACK] = ACTIONS(681),
    [aux_sym_number_token1] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [aux_sym_identifier_token1] = ACTIONS(683),
    [anon_sym_while] = ACTIONS(683),
    [anon_sym_var] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
  },
  [281] = {
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_BANG_EQ] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(413),
    [anon_sym_RBRACK] = ACTIONS(413),
    [anon_sym_PERCENT] = ACTIONS(350),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_PLUS] = ACTIONS(352),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(350),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(352),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_SLASH] = ACTIONS(350),
    [anon_sym_GT_EQ] = ACTIONS(413),
  },
  [282] = {
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(350),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(350),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_DASH] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(350),
    [anon_sym_GT_EQ] = ACTIONS(421),
  },
  [283] = {
    [anon_sym_LT] = ACTIONS(346),
    [anon_sym_BANG_EQ] = ACTIONS(348),
    [anon_sym_COMMA] = ACTIONS(431),
    [anon_sym_RBRACK] = ACTIONS(431),
    [anon_sym_PERCENT] = ACTIONS(350),
    [anon_sym_LT_EQ] = ACTIONS(348),
    [anon_sym_PLUS] = ACTIONS(352),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(350),
    [anon_sym_GT] = ACTIONS(346),
    [anon_sym_DASH] = ACTIONS(352),
    [anon_sym_EQ_EQ] = ACTIONS(348),
    [anon_sym_SLASH] = ACTIONS(350),
    [anon_sym_GT_EQ] = ACTIONS(348),
  },
  [284] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(93),
    [sym_function_call] = STATE(93),
    [sym_multiplication_expression] = STATE(93),
    [sym_cast_expression] = STATE(93),
    [sym_primary] = STATE(93),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(93),
    [sym_comparison_expression] = STATE(93),
    [sym_addition_expression] = STATE(93),
    [sym_identifier] = STATE(31),
    [sym_number] = STATE(29),
    [sym_clause_result] = STATE(270),
    [sym_range_literal] = STATE(93),
    [sym_unary_expression] = STATE(93),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(514),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(516),
    [anon_sym_true] = ACTIONS(37),
  },
  [285] = {
    [anon_sym_LPAREN] = ACTIONS(685),
  },
  [286] = {
    [anon_sym_LPAREN] = ACTIONS(687),
  },
  [287] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(280),
    [sym__statement] = STATE(280),
    [sym_assignment] = STATE(19),
    [sym_function_call] = STATE(19),
    [sym_multiplication_expression] = STATE(19),
    [sym_cast_expression] = STATE(19),
    [sym_primary] = STATE(19),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(280),
    [sym_block_statement] = STATE(280),
    [sym_expression_statement] = STATE(280),
    [sym__expression] = STATE(19),
    [sym_comparison_expression] = STATE(19),
    [sym_addition_expression] = STATE(19),
    [sym_when_statement] = STATE(280),
    [sym_for_statement] = STATE(280),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(19),
    [sym_unary_expression] = STATE(19),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [288] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(364),
    [sym_function_call] = STATE(364),
    [sym_multiplication_expression] = STATE(364),
    [sym_cast_expression] = STATE(364),
    [sym_primary] = STATE(364),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(364),
    [sym_comparison_expression] = STATE(364),
    [sym_addition_expression] = STATE(364),
    [sym_identifier] = STATE(126),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(364),
    [sym_unary_expression] = STATE(364),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [289] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(309),
    [sym__statement] = STATE(309),
    [sym_assignment] = STATE(19),
    [sym_function_call] = STATE(19),
    [sym_multiplication_expression] = STATE(19),
    [sym_cast_expression] = STATE(19),
    [sym_primary] = STATE(19),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(309),
    [sym_block_statement] = STATE(309),
    [sym_expression_statement] = STATE(309),
    [sym__expression] = STATE(19),
    [sym_comparison_expression] = STATE(19),
    [sym_addition_expression] = STATE(19),
    [sym_when_statement] = STATE(309),
    [sym_for_statement] = STATE(309),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(19),
    [sym_unary_expression] = STATE(19),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [290] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(365),
    [sym_function_call] = STATE(365),
    [sym_multiplication_expression] = STATE(365),
    [sym_cast_expression] = STATE(365),
    [sym_primary] = STATE(365),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(365),
    [sym_comparison_expression] = STATE(365),
    [sym_addition_expression] = STATE(365),
    [sym_identifier] = STATE(198),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(365),
    [sym_unary_expression] = STATE(365),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [291] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(366),
    [sym_function_call] = STATE(366),
    [sym_multiplication_expression] = STATE(366),
    [sym_cast_expression] = STATE(366),
    [sym_primary] = STATE(366),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(366),
    [sym_comparison_expression] = STATE(366),
    [sym_addition_expression] = STATE(366),
    [sym_identifier] = STATE(31),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(366),
    [sym_unary_expression] = STATE(366),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [292] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(171),
    [sym_function_call] = STATE(171),
    [sym_multiplication_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym_primary] = STATE(171),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(171),
    [sym_comparison_expression] = STATE(171),
    [sym_addition_expression] = STATE(171),
    [sym_identifier] = STATE(198),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(171),
    [sym_unary_expression] = STATE(171),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [293] = {
    [anon_sym_LT] = ACTIONS(689),
    [anon_sym_RBRACE] = ACTIONS(689),
    [anon_sym_COMMA] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(689),
    [anon_sym_as] = ACTIONS(689),
    [anon_sym_STAR] = ACTIONS(689),
    [sym_eol] = ACTIONS(691),
    [anon_sym_GT] = ACTIONS(689),
    [anon_sym_BANG_EQ] = ACTIONS(689),
    [anon_sym_PERCENT] = ACTIONS(689),
    [anon_sym_LT_EQ] = ACTIONS(689),
    [anon_sym_DASH] = ACTIONS(689),
    [anon_sym_EQ_EQ] = ACTIONS(689),
    [anon_sym_SLASH] = ACTIONS(689),
    [anon_sym_GT_EQ] = ACTIONS(689),
  },
  [294] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(367),
    [sym_function_call] = STATE(367),
    [sym_multiplication_expression] = STATE(367),
    [sym_cast_expression] = STATE(367),
    [sym_primary] = STATE(367),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(367),
    [sym_comparison_expression] = STATE(367),
    [sym_addition_expression] = STATE(367),
    [sym_identifier] = STATE(198),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(367),
    [sym_unary_expression] = STATE(367),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [295] = {
    [aux_sym_map_literal_repeat1] = STATE(369),
    [anon_sym_RBRACE] = ACTIONS(693),
    [anon_sym_COMMA] = ACTIONS(548),
  },
  [296] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(370),
    [sym_function_call] = STATE(370),
    [sym_multiplication_expression] = STATE(370),
    [sym_cast_expression] = STATE(370),
    [sym_primary] = STATE(370),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(370),
    [sym_comparison_expression] = STATE(370),
    [sym_addition_expression] = STATE(370),
    [sym_identifier] = STATE(198),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(370),
    [sym_unary_expression] = STATE(370),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [297] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_assignment] = STATE(371),
    [sym_function_call] = STATE(371),
    [sym_multiplication_expression] = STATE(371),
    [sym_cast_expression] = STATE(371),
    [sym_primary] = STATE(371),
    [sym_list_literal] = STATE(16),
    [sym__expression] = STATE(371),
    [sym_comparison_expression] = STATE(371),
    [sym_addition_expression] = STATE(371),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(371),
    [sym_unary_expression] = STATE(371),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(9),
    [aux_sym_number_token1] = ACTIONS(21),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(3),
  },
  [298] = {
    [aux_sym_map_literal_repeat1] = STATE(346),
    [anon_sym_LT] = ACTIONS(544),
    [anon_sym_BANG_EQ] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(548),
    [anon_sym_PERCENT] = ACTIONS(550),
    [anon_sym_RBRACE] = ACTIONS(695),
    [anon_sym_LT_EQ] = ACTIONS(546),
    [anon_sym_PLUS] = ACTIONS(554),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(550),
    [anon_sym_GT] = ACTIONS(544),
    [anon_sym_DASH] = ACTIONS(554),
    [anon_sym_EQ_EQ] = ACTIONS(546),
    [anon_sym_SLASH] = ACTIONS(550),
    [anon_sym_GT_EQ] = ACTIONS(546),
  },
  [299] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(372),
    [sym_function_call] = STATE(372),
    [sym_multiplication_expression] = STATE(372),
    [sym_cast_expression] = STATE(372),
    [sym_primary] = STATE(372),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(372),
    [sym_comparison_expression] = STATE(372),
    [sym_addition_expression] = STATE(372),
    [sym_identifier] = STATE(216),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(372),
    [sym_unary_expression] = STATE(372),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [300] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(171),
    [sym_function_call] = STATE(171),
    [sym_multiplication_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym_primary] = STATE(171),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(171),
    [sym_comparison_expression] = STATE(171),
    [sym_addition_expression] = STATE(171),
    [sym_identifier] = STATE(216),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(171),
    [sym_unary_expression] = STATE(171),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [301] = {
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_RBRACE] = ACTIONS(697),
    [anon_sym_COMMA] = ACTIONS(697),
    [anon_sym_COLON] = ACTIONS(697),
    [anon_sym_PLUS] = ACTIONS(697),
    [anon_sym_as] = ACTIONS(697),
    [anon_sym_STAR] = ACTIONS(697),
    [sym_eol] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_BANG_EQ] = ACTIONS(697),
    [anon_sym_PERCENT] = ACTIONS(697),
    [anon_sym_LT_EQ] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(697),
    [anon_sym_EQ_EQ] = ACTIONS(697),
    [anon_sym_SLASH] = ACTIONS(697),
    [anon_sym_GT_EQ] = ACTIONS(697),
  },
  [302] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(373),
    [sym_function_call] = STATE(373),
    [sym_multiplication_expression] = STATE(373),
    [sym_cast_expression] = STATE(373),
    [sym_primary] = STATE(373),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(373),
    [sym_comparison_expression] = STATE(373),
    [sym_addition_expression] = STATE(373),
    [sym_identifier] = STATE(216),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(373),
    [sym_unary_expression] = STATE(373),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [303] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(374),
    [sym_function_call] = STATE(374),
    [sym_multiplication_expression] = STATE(374),
    [sym_cast_expression] = STATE(374),
    [sym_primary] = STATE(374),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(374),
    [sym_comparison_expression] = STATE(374),
    [sym_addition_expression] = STATE(374),
    [sym_identifier] = STATE(216),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(374),
    [sym_unary_expression] = STATE(374),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [304] = {
    [anon_sym_LT] = ACTIONS(701),
    [anon_sym_RBRACE] = ACTIONS(701),
    [anon_sym_COMMA] = ACTIONS(701),
    [anon_sym_COLON] = ACTIONS(701),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_as] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(701),
    [sym_eol] = ACTIONS(703),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_PERCENT] = ACTIONS(701),
    [anon_sym_LT_EQ] = ACTIONS(701),
    [anon_sym_DASH] = ACTIONS(701),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_SLASH] = ACTIONS(701),
    [anon_sym_GT_EQ] = ACTIONS(701),
  },
  [305] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(213),
    [sym_function_call] = STATE(213),
    [sym_multiplication_expression] = STATE(213),
    [sym_cast_expression] = STATE(213),
    [sym_primary] = STATE(213),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(213),
    [sym_comparison_expression] = STATE(213),
    [sym_addition_expression] = STATE(213),
    [sym_identifier] = STATE(90),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(213),
    [sym_unary_expression] = STATE(213),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [306] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(375),
    [sym_function_call] = STATE(375),
    [sym_multiplication_expression] = STATE(375),
    [sym_cast_expression] = STATE(375),
    [sym_primary] = STATE(375),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(375),
    [sym_comparison_expression] = STATE(375),
    [sym_addition_expression] = STATE(375),
    [sym_identifier] = STATE(376),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(375),
    [sym_unary_expression] = STATE(375),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [307] = {
    [sym_map_type] = STATE(377),
    [sym_primitive_type] = STATE(377),
    [sym_list_type] = STATE(377),
    [sym__type] = STATE(377),
    [anon_sym_int16] = ACTIONS(332),
    [anon_sym_uint32] = ACTIONS(332),
    [anon_sym_int8] = ACTIONS(332),
    [anon_sym_LBRACK] = ACTIONS(334),
    [anon_sym_int32] = ACTIONS(332),
    [anon_sym_uint64] = ACTIONS(332),
    [anon_sym_float64] = ACTIONS(332),
    [anon_sym_bool] = ACTIONS(332),
    [anon_sym_int64] = ACTIONS(332),
    [anon_sym_float32] = ACTIONS(332),
    [anon_sym_uint16] = ACTIONS(332),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_string] = ACTIONS(332),
    [anon_sym_uint8] = ACTIONS(332),
  },
  [308] = {
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(217),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(221),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(221),
    [anon_sym_EQ_EQ] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(705),
  },
  [309] = {
    [anon_sym_RBRACE] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_fun] = ACTIONS(709),
    [anon_sym_when] = ACTIONS(709),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_LBRACE] = ACTIONS(707),
    [anon_sym_true] = ACTIONS(709),
    [anon_sym_return] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(709),
    [ts_builtin_sym_end] = ACTIONS(707),
    [anon_sym_LBRACK] = ACTIONS(707),
    [aux_sym_number_token1] = ACTIONS(707),
    [anon_sym_for] = ACTIONS(709),
    [aux_sym_identifier_token1] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_var] = ACTIONS(709),
    [anon_sym_LPAREN] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(707),
  },
  [310] = {
    [anon_sym_LT] = ACTIONS(364),
    [anon_sym_RBRACE] = ACTIONS(364),
    [anon_sym_COMMA] = ACTIONS(364),
    [anon_sym_COLON] = ACTIONS(364),
    [anon_sym_PLUS] = ACTIONS(364),
    [anon_sym_as] = ACTIONS(364),
    [anon_sym_STAR] = ACTIONS(364),
    [sym_eol] = ACTIONS(362),
    [anon_sym_GT] = ACTIONS(364),
    [anon_sym_BANG_EQ] = ACTIONS(364),
    [anon_sym_PERCENT] = ACTIONS(364),
    [anon_sym_LT_EQ] = ACTIONS(364),
    [anon_sym_DASH] = ACTIONS(364),
    [anon_sym_EQ_EQ] = ACTIONS(364),
    [anon_sym_SLASH] = ACTIONS(364),
    [anon_sym_GT_EQ] = ACTIONS(364),
  },
  [311] = {
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_RBRACE] = ACTIONS(711),
    [anon_sym_COMMA] = ACTIONS(711),
    [anon_sym_COLON] = ACTIONS(711),
    [anon_sym_PLUS] = ACTIONS(711),
    [anon_sym_as] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(711),
    [sym_eol] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_BANG_EQ] = ACTIONS(711),
    [anon_sym_PERCENT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(711),
    [anon_sym_DASH] = ACTIONS(711),
    [anon_sym_EQ_EQ] = ACTIONS(711),
    [anon_sym_SLASH] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(711),
  },
  [312] = {
    [sym_map_type] = STATE(379),
    [sym_primitive_type] = STATE(379),
    [sym_list_type] = STATE(379),
    [sym__type] = STATE(379),
    [anon_sym_int16] = ACTIONS(332),
    [anon_sym_uint32] = ACTIONS(332),
    [anon_sym_int8] = ACTIONS(332),
    [anon_sym_LBRACK] = ACTIONS(334),
    [anon_sym_int32] = ACTIONS(332),
    [anon_sym_uint64] = ACTIONS(332),
    [anon_sym_float64] = ACTIONS(332),
    [anon_sym_bool] = ACTIONS(332),
    [anon_sym_int64] = ACTIONS(332),
    [anon_sym_float32] = ACTIONS(332),
    [anon_sym_uint16] = ACTIONS(332),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_string] = ACTIONS(332),
    [anon_sym_uint8] = ACTIONS(332),
  },
  [313] = {
    [aux_sym_type_list_repeat1] = STATE(380),
    [anon_sym_LBRACE] = ACTIONS(715),
    [anon_sym_COMMA] = ACTIONS(604),
  },
  [314] = {
    [sym_block_statement] = STATE(381),
    [anon_sym_LBRACE] = ACTIONS(211),
  },
  [315] = {
    [anon_sym_LT] = ACTIONS(717),
    [anon_sym_RBRACE] = ACTIONS(717),
    [anon_sym_COMMA] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_as] = ACTIONS(717),
    [anon_sym_STAR] = ACTIONS(717),
    [sym_eol] = ACTIONS(719),
    [anon_sym_GT] = ACTIONS(717),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_BANG_EQ] = ACTIONS(717),
    [anon_sym_PERCENT] = ACTIONS(717),
    [anon_sym_LT_EQ] = ACTIONS(717),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_EQ_EQ] = ACTIONS(717),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_GT_EQ] = ACTIONS(717),
  },
  [316] = {
    [sym_map_type] = STATE(382),
    [sym_primitive_type] = STATE(382),
    [sym_list_type] = STATE(382),
    [sym__type] = STATE(382),
    [anon_sym_int16] = ACTIONS(332),
    [anon_sym_uint32] = ACTIONS(332),
    [anon_sym_int8] = ACTIONS(332),
    [anon_sym_LBRACK] = ACTIONS(334),
    [anon_sym_int32] = ACTIONS(332),
    [anon_sym_uint64] = ACTIONS(332),
    [anon_sym_float64] = ACTIONS(332),
    [anon_sym_bool] = ACTIONS(332),
    [anon_sym_int64] = ACTIONS(332),
    [anon_sym_float32] = ACTIONS(332),
    [anon_sym_uint16] = ACTIONS(332),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_string] = ACTIONS(332),
    [anon_sym_uint8] = ACTIONS(332),
  },
  [317] = {
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_RPAREN] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(413),
    [anon_sym_PERCENT] = ACTIONS(443),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_SLASH] = ACTIONS(443),
    [anon_sym_GT_EQ] = ACTIONS(413),
  },
  [318] = {
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_BANG_EQ] = ACTIONS(439),
    [anon_sym_COMMA] = ACTIONS(562),
    [anon_sym_PERCENT] = ACTIONS(443),
    [anon_sym_GT_EQ] = ACTIONS(439),
    [anon_sym_LT_EQ] = ACTIONS(439),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_GT] = ACTIONS(437),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_EQ_EQ] = ACTIONS(439),
    [anon_sym_SLASH] = ACTIONS(443),
    [anon_sym_RPAREN] = ACTIONS(562),
  },
  [319] = {
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_RPAREN] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(443),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_DASH] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(443),
    [anon_sym_GT_EQ] = ACTIONS(421),
  },
  [320] = {
    [aux_sym_return_statement_repeat1] = STATE(320),
    [anon_sym_COMMA] = ACTIONS(721),
    [anon_sym_RPAREN] = ACTIONS(562),
  },
  [321] = {
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_RPAREN] = ACTIONS(431),
    [anon_sym_COMMA] = ACTIONS(431),
    [anon_sym_BANG_EQ] = ACTIONS(439),
    [anon_sym_PERCENT] = ACTIONS(443),
    [anon_sym_LT_EQ] = ACTIONS(439),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_GT] = ACTIONS(437),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_EQ_EQ] = ACTIONS(439),
    [anon_sym_SLASH] = ACTIONS(443),
    [anon_sym_GT_EQ] = ACTIONS(439),
  },
  [322] = {
    [anon_sym_RBRACE] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(149),
    [anon_sym_fun] = ACTIONS(149),
    [anon_sym_when] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_true] = ACTIONS(149),
    [anon_sym_return] = ACTIONS(149),
    [anon_sym_let] = ACTIONS(149),
    [ts_builtin_sym_end] = ACTIONS(153),
    [anon_sym_LBRACK] = ACTIONS(153),
    [aux_sym_number_token1] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(149),
    [aux_sym_identifier_token1] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(149),
    [anon_sym_var] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(153),
    [anon_sym_DASH] = ACTIONS(153),
  },
  [323] = {
    [sym_block_statement] = STATE(383),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [324] = {
    [sym_map_type] = STATE(226),
    [sym_primitive_type] = STATE(226),
    [sym_list_type] = STATE(226),
    [sym_type_list] = STATE(384),
    [sym__type] = STATE(226),
    [anon_sym_int16] = ACTIONS(332),
    [anon_sym_uint32] = ACTIONS(332),
    [anon_sym_int8] = ACTIONS(332),
    [anon_sym_LBRACK] = ACTIONS(334),
    [anon_sym_int32] = ACTIONS(332),
    [anon_sym_uint64] = ACTIONS(332),
    [anon_sym_float64] = ACTIONS(332),
    [anon_sym_bool] = ACTIONS(332),
    [anon_sym_int64] = ACTIONS(332),
    [anon_sym_float32] = ACTIONS(332),
    [anon_sym_uint16] = ACTIONS(332),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_string] = ACTIONS(332),
    [anon_sym_uint8] = ACTIONS(332),
  },
  [325] = {
    [anon_sym_RBRACE] = ACTIONS(608),
    [anon_sym_false] = ACTIONS(606),
    [anon_sym_fun] = ACTIONS(606),
    [anon_sym_when] = ACTIONS(606),
    [anon_sym_BANG] = ACTIONS(608),
    [anon_sym_LBRACE] = ACTIONS(608),
    [anon_sym_true] = ACTIONS(606),
    [anon_sym_return] = ACTIONS(606),
    [anon_sym_let] = ACTIONS(606),
    [ts_builtin_sym_end] = ACTIONS(608),
    [anon_sym_LBRACK] = ACTIONS(608),
    [aux_sym_number_token1] = ACTIONS(608),
    [anon_sym_for] = ACTIONS(606),
    [aux_sym_identifier_token1] = ACTIONS(606),
    [anon_sym_while] = ACTIONS(606),
    [anon_sym_var] = ACTIONS(606),
    [anon_sym_LPAREN] = ACTIONS(608),
    [anon_sym_DASH] = ACTIONS(608),
  },
  [326] = {
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_RBRACE] = ACTIONS(699),
    [anon_sym_COMMA] = ACTIONS(699),
    [anon_sym_COLON] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(699),
    [anon_sym_STAR] = ACTIONS(699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_in] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(699),
    [anon_sym_BANG_EQ] = ACTIONS(699),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(699),
    [anon_sym_LT_EQ] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(699),
    [anon_sym_EQ_EQ] = ACTIONS(699),
    [anon_sym_SLASH] = ACTIONS(699),
    [anon_sym_DOT_DOT_LT] = ACTIONS(699),
    [anon_sym_GT_EQ] = ACTIONS(699),
  },
  [327] = {
    [anon_sym_LT] = ACTIONS(701),
    [anon_sym_RBRACE] = ACTIONS(703),
    [anon_sym_COMMA] = ACTIONS(703),
    [anon_sym_COLON] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_as] = ACTIONS(703),
    [anon_sym_STAR] = ACTIONS(703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(703),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_in] = ACTIONS(703),
    [anon_sym_RPAREN] = ACTIONS(703),
    [anon_sym_BANG_EQ] = ACTIONS(703),
    [anon_sym_PERCENT] = ACTIONS(703),
    [anon_sym_RBRACK] = ACTIONS(703),
    [anon_sym_LT_EQ] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_EQ_EQ] = ACTIONS(703),
    [anon_sym_SLASH] = ACTIONS(703),
    [anon_sym_DOT_DOT_LT] = ACTIONS(703),
    [anon_sym_GT_EQ] = ACTIONS(703),
  },
  [328] = {
    [anon_sym_LT] = ACTIONS(364),
    [anon_sym_RBRACE] = ACTIONS(362),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_COLON] = ACTIONS(362),
    [anon_sym_PLUS] = ACTIONS(362),
    [anon_sym_as] = ACTIONS(362),
    [anon_sym_STAR] = ACTIONS(362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(362),
    [anon_sym_GT] = ACTIONS(364),
    [anon_sym_in] = ACTIONS(362),
    [anon_sym_RPAREN] = ACTIONS(362),
    [anon_sym_BANG_EQ] = ACTIONS(362),
    [anon_sym_PERCENT] = ACTIONS(362),
    [anon_sym_RBRACK] = ACTIONS(362),
    [anon_sym_LT_EQ] = ACTIONS(362),
    [anon_sym_else] = ACTIONS(362),
    [anon_sym_DASH] = ACTIONS(362),
    [anon_sym_EQ_EQ] = ACTIONS(362),
    [anon_sym_SLASH] = ACTIONS(362),
    [anon_sym_DOT_DOT_LT] = ACTIONS(362),
    [anon_sym_GT_EQ] = ACTIONS(362),
  },
  [329] = {
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_RBRACE] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_COLON] = ACTIONS(713),
    [anon_sym_PLUS] = ACTIONS(713),
    [anon_sym_as] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_in] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_PERCENT] = ACTIONS(713),
    [anon_sym_RBRACK] = ACTIONS(713),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_SLASH] = ACTIONS(713),
    [anon_sym_DOT_DOT_LT] = ACTIONS(713),
    [anon_sym_GT_EQ] = ACTIONS(713),
  },
  [330] = {
    [sym_else_result] = STATE(386),
    [anon_sym_RBRACE] = ACTIONS(724),
    [anon_sym_else] = ACTIONS(320),
  },
  [331] = {
    [sym_block_statement] = STATE(387),
    [anon_sym_LBRACE] = ACTIONS(304),
  },
  [332] = {
    [anon_sym_LT] = ACTIONS(95),
    [anon_sym_BANG_EQ] = ACTIONS(95),
    [anon_sym_PERCENT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(95),
    [anon_sym_PLUS] = ACTIONS(99),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(97),
    [sym_eol] = ACTIONS(657),
    [anon_sym_GT] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(95),
  },
  [333] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(388),
    [sym_function_call] = STATE(388),
    [sym_multiplication_expression] = STATE(388),
    [sym_cast_expression] = STATE(388),
    [sym_primary] = STATE(388),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(388),
    [sym_comparison_expression] = STATE(388),
    [sym_addition_expression] = STATE(388),
    [sym_parameter_list] = STATE(75),
    [sym_parameter] = STATE(56),
    [sym_identifier] = STATE(57),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(388),
    [sym_unary_expression] = STATE(388),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(115),
  },
  [334] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [aux_sym_clause_list_repeat1] = STATE(77),
    [sym_assignment] = STATE(78),
    [sym_function_call] = STATE(78),
    [sym_multiplication_expression] = STATE(78),
    [sym_cast_expression] = STATE(78),
    [sym_primary] = STATE(78),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(78),
    [sym_comparison_expression] = STATE(78),
    [sym_addition_expression] = STATE(78),
    [sym_identifier] = STATE(31),
    [sym_number] = STATE(29),
    [sym_clause_result] = STATE(77),
    [sym_clause_list] = STATE(389),
    [sym_range_literal] = STATE(78),
    [sym_unary_expression] = STATE(78),
    [sym_bool_literal] = STATE(29),
    [anon_sym_RBRACE] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [335] = {
    [sym_else_result] = STATE(390),
    [anon_sym_RBRACE] = ACTIONS(137),
    [anon_sym_false] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(137),
    [anon_sym_BANG] = ACTIONS(137),
    [aux_sym_number_token1] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(135),
    [aux_sym_identifier_token1] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(137),
    [anon_sym_true] = ACTIONS(135),
  },
  [336] = {
    [sym_variable_declaration] = STATE(391),
    [anon_sym_var] = ACTIONS(209),
    [anon_sym_let] = ACTIONS(209),
  },
  [337] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(392),
    [sym_function_call] = STATE(392),
    [sym_multiplication_expression] = STATE(392),
    [sym_cast_expression] = STATE(392),
    [sym_primary] = STATE(392),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(392),
    [sym_comparison_expression] = STATE(392),
    [sym_addition_expression] = STATE(392),
    [sym_identifier] = STATE(126),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(392),
    [sym_unary_expression] = STATE(392),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [338] = {
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_RBRACE] = ACTIONS(149),
    [anon_sym_false] = ACTIONS(149),
    [anon_sym_COMMA] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(147),
    [anon_sym_as] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(147),
    [sym_eol] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(149),
    [anon_sym_true] = ACTIONS(149),
    [anon_sym_BANG_EQ] = ACTIONS(147),
    [anon_sym_PERCENT] = ACTIONS(147),
    [anon_sym_LBRACK] = ACTIONS(149),
    [aux_sym_number_token1] = ACTIONS(149),
    [anon_sym_LT_EQ] = ACTIONS(147),
    [anon_sym_else] = ACTIONS(149),
    [aux_sym_identifier_token1] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(149),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(147),
    [anon_sym_SLASH] = ACTIONS(147),
    [anon_sym_GT_EQ] = ACTIONS(147),
  },
  [339] = {
    [sym_function_literal] = STATE(16),
    [sym_variable_declaration] = STATE(15),
    [sym__statement] = STATE(102),
    [sym_return_statement] = STATE(102),
    [sym_map_literal] = STATE(16),
    [sym_assignment] = STATE(19),
    [sym_function_call] = STATE(19),
    [sym_multiplication_expression] = STATE(19),
    [sym_cast_expression] = STATE(19),
    [sym_parenthetical_expression] = STATE(16),
    [sym_primary] = STATE(19),
    [sym__declaration] = STATE(102),
    [sym_function_declaration] = STATE(102),
    [sym_while_statement] = STATE(102),
    [sym_block_statement] = STATE(102),
    [sym_expression_statement] = STATE(102),
    [sym__expression] = STATE(19),
    [sym_comparison_expression] = STATE(19),
    [sym_addition_expression] = STATE(19),
    [sym_list_literal] = STATE(16),
    [aux_sym_source_file_repeat1] = STATE(102),
    [sym_when_statement] = STATE(102),
    [sym_for_statement] = STATE(102),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(19),
    [sym_unary_expression] = STATE(19),
    [sym_bool_literal] = STATE(16),
    [anon_sym_RBRACE] = ACTIONS(726),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_fun] = ACTIONS(5),
    [anon_sym_when] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_true] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [aux_sym_number_token1] = ACTIONS(21),
    [anon_sym_for] = ACTIONS(59),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_var] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
  },
  [340] = {
    [aux_sym_return_statement_repeat1] = STATE(395),
    [anon_sym_LT] = ACTIONS(171),
    [anon_sym_BANG_EQ] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(173),
    [anon_sym_PERCENT] = ACTIONS(175),
    [anon_sym_LT_EQ] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(177),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(175),
    [sym_eol] = ACTIONS(728),
    [anon_sym_GT] = ACTIONS(171),
    [anon_sym_DASH] = ACTIONS(177),
    [anon_sym_EQ_EQ] = ACTIONS(171),
    [anon_sym_SLASH] = ACTIONS(175),
    [anon_sym_GT_EQ] = ACTIONS(171),
  },
  [341] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_assignment] = STATE(396),
    [sym_function_call] = STATE(396),
    [sym_multiplication_expression] = STATE(396),
    [sym_cast_expression] = STATE(396),
    [sym_primary] = STATE(396),
    [sym_list_literal] = STATE(16),
    [sym__expression] = STATE(396),
    [sym_comparison_expression] = STATE(396),
    [sym_addition_expression] = STATE(396),
    [sym_identifier] = STATE(265),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(396),
    [sym_unary_expression] = STATE(396),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(9),
    [aux_sym_number_token1] = ACTIONS(21),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(3),
  },
  [342] = {
    [anon_sym_LT] = ACTIONS(689),
    [anon_sym_RBRACE] = ACTIONS(691),
    [anon_sym_COMMA] = ACTIONS(691),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_PLUS] = ACTIONS(691),
    [anon_sym_as] = ACTIONS(691),
    [anon_sym_STAR] = ACTIONS(691),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(691),
    [anon_sym_GT] = ACTIONS(689),
    [anon_sym_in] = ACTIONS(691),
    [anon_sym_RPAREN] = ACTIONS(691),
    [anon_sym_BANG_EQ] = ACTIONS(691),
    [anon_sym_PERCENT] = ACTIONS(691),
    [anon_sym_RBRACK] = ACTIONS(691),
    [anon_sym_LT_EQ] = ACTIONS(691),
    [anon_sym_DASH] = ACTIONS(691),
    [anon_sym_EQ_EQ] = ACTIONS(691),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_DOT_DOT_LT] = ACTIONS(691),
    [anon_sym_GT_EQ] = ACTIONS(691),
  },
  [343] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_assignment] = STATE(397),
    [sym_function_call] = STATE(397),
    [sym_multiplication_expression] = STATE(397),
    [sym_cast_expression] = STATE(397),
    [sym_primary] = STATE(397),
    [sym_list_literal] = STATE(16),
    [sym__expression] = STATE(397),
    [sym_comparison_expression] = STATE(397),
    [sym_addition_expression] = STATE(397),
    [sym_identifier] = STATE(265),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(397),
    [sym_unary_expression] = STATE(397),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(9),
    [aux_sym_number_token1] = ACTIONS(21),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(3),
  },
  [344] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_assignment] = STATE(140),
    [sym_function_call] = STATE(140),
    [sym_multiplication_expression] = STATE(140),
    [sym_cast_expression] = STATE(140),
    [sym_primary] = STATE(140),
    [sym_list_literal] = STATE(16),
    [sym__expression] = STATE(140),
    [sym_comparison_expression] = STATE(140),
    [sym_addition_expression] = STATE(140),
    [sym_identifier] = STATE(265),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(140),
    [sym_unary_expression] = STATE(140),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(9),
    [aux_sym_number_token1] = ACTIONS(21),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(3),
  },
  [345] = {
    [anon_sym_RBRACE] = ACTIONS(286),
    [anon_sym_false] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [aux_sym_number_token1] = ACTIONS(286),
    [anon_sym_else] = ACTIONS(288),
    [aux_sym_identifier_token1] = ACTIONS(288),
    [anon_sym_LPAREN] = ACTIONS(286),
    [anon_sym_DASH] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(286),
    [anon_sym_true] = ACTIONS(288),
  },
  [346] = {
    [aux_sym_map_literal_repeat1] = STATE(369),
    [anon_sym_RBRACE] = ACTIONS(730),
    [anon_sym_COMMA] = ACTIONS(548),
  },
  [347] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_assignment] = STATE(399),
    [sym_function_call] = STATE(399),
    [sym_multiplication_expression] = STATE(399),
    [sym_cast_expression] = STATE(399),
    [sym_primary] = STATE(399),
    [sym_list_literal] = STATE(16),
    [sym__expression] = STATE(399),
    [sym_comparison_expression] = STATE(399),
    [sym_addition_expression] = STATE(399),
    [sym_identifier] = STATE(265),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(399),
    [sym_unary_expression] = STATE(399),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(9),
    [aux_sym_number_token1] = ACTIONS(21),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(3),
  },
  [348] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(400),
    [sym_function_call] = STATE(400),
    [sym_multiplication_expression] = STATE(400),
    [sym_cast_expression] = STATE(400),
    [sym_primary] = STATE(400),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(400),
    [sym_comparison_expression] = STATE(400),
    [sym_addition_expression] = STATE(400),
    [sym_identifier] = STATE(31),
    [sym_number] = STATE(29),
    [sym_clause_result] = STATE(401),
    [sym_range_literal] = STATE(400),
    [sym_unary_expression] = STATE(400),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_true] = ACTIONS(37),
  },
  [349] = {
    [anon_sym_LPAREN] = ACTIONS(732),
  },
  [350] = {
    [anon_sym_LPAREN] = ACTIONS(734),
  },
  [351] = {
    [sym_function_literal] = STATE(16),
    [sym_variable_declaration] = STATE(15),
    [sym__statement] = STATE(41),
    [sym_return_statement] = STATE(41),
    [sym_map_literal] = STATE(16),
    [sym_assignment] = STATE(40),
    [sym_function_call] = STATE(40),
    [sym_multiplication_expression] = STATE(40),
    [sym_cast_expression] = STATE(40),
    [sym_parenthetical_expression] = STATE(16),
    [sym_primary] = STATE(40),
    [sym__declaration] = STATE(41),
    [sym_function_declaration] = STATE(41),
    [sym_while_statement] = STATE(41),
    [sym_block_statement] = STATE(41),
    [sym_expression_statement] = STATE(41),
    [sym__expression] = STATE(40),
    [sym_comparison_expression] = STATE(40),
    [sym_addition_expression] = STATE(40),
    [sym_list_literal] = STATE(16),
    [aux_sym_source_file_repeat1] = STATE(41),
    [sym_when_statement] = STATE(41),
    [sym_for_statement] = STATE(41),
    [sym_identifier] = STATE(42),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(40),
    [sym_unary_expression] = STATE(40),
    [sym_bool_literal] = STATE(16),
    [anon_sym_RBRACE] = ACTIONS(736),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_fun] = ACTIONS(5),
    [anon_sym_when] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_true] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [aux_sym_number_token1] = ACTIONS(21),
    [anon_sym_for] = ACTIONS(59),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_var] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
  },
  [352] = {
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(217),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(221),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(221),
    [anon_sym_EQ_EQ] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(738),
  },
  [353] = {
    [sym_else_result] = STATE(407),
    [anon_sym_RBRACE] = ACTIONS(740),
    [anon_sym_else] = ACTIONS(320),
  },
  [354] = {
    [anon_sym_RBRACE] = ACTIONS(342),
    [anon_sym_false] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(342),
    [anon_sym_fun] = ACTIONS(344),
    [anon_sym_when] = ACTIONS(344),
    [anon_sym_LBRACE] = ACTIONS(342),
    [anon_sym_true] = ACTIONS(344),
    [anon_sym_return] = ACTIONS(344),
    [anon_sym_let] = ACTIONS(344),
    [ts_builtin_sym_end] = ACTIONS(342),
    [anon_sym_LBRACK] = ACTIONS(342),
    [aux_sym_number_token1] = ACTIONS(342),
    [anon_sym_for] = ACTIONS(344),
    [anon_sym_else] = ACTIONS(344),
    [anon_sym_while] = ACTIONS(344),
    [anon_sym_var] = ACTIONS(344),
    [anon_sym_LPAREN] = ACTIONS(342),
    [anon_sym_DASH] = ACTIONS(342),
    [aux_sym_identifier_token1] = ACTIONS(344),
  },
  [355] = {
    [anon_sym_in] = ACTIONS(742),
  },
  [356] = {
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(217),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(221),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(221),
    [anon_sym_EQ_EQ] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(744),
  },
  [357] = {
    [anon_sym_RBRACE] = ACTIONS(362),
    [anon_sym_false] = ACTIONS(364),
    [anon_sym_BANG] = ACTIONS(362),
    [anon_sym_fun] = ACTIONS(364),
    [anon_sym_when] = ACTIONS(364),
    [anon_sym_LBRACE] = ACTIONS(362),
    [anon_sym_true] = ACTIONS(364),
    [anon_sym_return] = ACTIONS(364),
    [anon_sym_let] = ACTIONS(364),
    [ts_builtin_sym_end] = ACTIONS(362),
    [anon_sym_LBRACK] = ACTIONS(362),
    [aux_sym_number_token1] = ACTIONS(362),
    [anon_sym_for] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(364),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_var] = ACTIONS(364),
    [anon_sym_LPAREN] = ACTIONS(362),
    [anon_sym_DASH] = ACTIONS(362),
    [aux_sym_identifier_token1] = ACTIONS(364),
  },
  [358] = {
    [anon_sym_RBRACE] = ACTIONS(375),
    [anon_sym_false] = ACTIONS(377),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_fun] = ACTIONS(377),
    [anon_sym_when] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(375),
    [anon_sym_true] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(377),
    [anon_sym_let] = ACTIONS(377),
    [ts_builtin_sym_end] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(375),
    [aux_sym_number_token1] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(377),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_var] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_DASH] = ACTIONS(375),
    [aux_sym_identifier_token1] = ACTIONS(377),
  },
  [359] = {
    [aux_sym_return_statement_repeat1] = STATE(205),
    [sym_eol] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(173),
  },
  [360] = {
    [anon_sym_LT] = ACTIONS(717),
    [anon_sym_RBRACE] = ACTIONS(719),
    [anon_sym_COMMA] = ACTIONS(719),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_as] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [anon_sym_GT] = ACTIONS(717),
    [anon_sym_in] = ACTIONS(719),
    [anon_sym_LBRACE] = ACTIONS(719),
    [anon_sym_RPAREN] = ACTIONS(719),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_BANG_EQ] = ACTIONS(719),
    [anon_sym_PERCENT] = ACTIONS(719),
    [anon_sym_RBRACK] = ACTIONS(719),
    [anon_sym_LT_EQ] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_EQ_EQ] = ACTIONS(719),
    [anon_sym_SLASH] = ACTIONS(719),
    [anon_sym_DOT_DOT_LT] = ACTIONS(719),
    [anon_sym_GT_EQ] = ACTIONS(719),
  },
  [361] = {
    [sym_map_type] = STATE(412),
    [sym_primitive_type] = STATE(412),
    [sym_list_type] = STATE(412),
    [sym__type] = STATE(412),
    [anon_sym_int16] = ACTIONS(332),
    [anon_sym_uint32] = ACTIONS(332),
    [anon_sym_int8] = ACTIONS(332),
    [anon_sym_LBRACK] = ACTIONS(334),
    [anon_sym_int32] = ACTIONS(332),
    [anon_sym_uint64] = ACTIONS(332),
    [anon_sym_float64] = ACTIONS(332),
    [anon_sym_bool] = ACTIONS(332),
    [anon_sym_int64] = ACTIONS(332),
    [anon_sym_float32] = ACTIONS(332),
    [anon_sym_uint16] = ACTIONS(332),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_string] = ACTIONS(332),
    [anon_sym_uint8] = ACTIONS(332),
  },
  [362] = {
    [sym_variable_declaration] = STATE(413),
    [anon_sym_var] = ACTIONS(209),
    [anon_sym_let] = ACTIONS(209),
  },
  [363] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(414),
    [sym_function_call] = STATE(414),
    [sym_multiplication_expression] = STATE(414),
    [sym_cast_expression] = STATE(414),
    [sym_primary] = STATE(414),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(414),
    [sym_comparison_expression] = STATE(414),
    [sym_addition_expression] = STATE(414),
    [sym_identifier] = STATE(126),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(414),
    [sym_unary_expression] = STATE(414),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [364] = {
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(217),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(221),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(221),
    [anon_sym_EQ_EQ] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(748),
  },
  [365] = {
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_RBRACE] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(413),
    [anon_sym_PERCENT] = ACTIONS(550),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_PLUS] = ACTIONS(554),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(550),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(554),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_SLASH] = ACTIONS(550),
    [anon_sym_GT_EQ] = ACTIONS(413),
  },
  [366] = {
    [anon_sym_LT] = ACTIONS(119),
    [anon_sym_BANG_EQ] = ACTIONS(121),
    [anon_sym_PERCENT] = ACTIONS(123),
    [anon_sym_COLON] = ACTIONS(750),
    [anon_sym_LT_EQ] = ACTIONS(121),
    [anon_sym_PLUS] = ACTIONS(127),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_GT] = ACTIONS(119),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_EQ_EQ] = ACTIONS(121),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_GT_EQ] = ACTIONS(121),
  },
  [367] = {
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(550),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(550),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_DASH] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(550),
    [anon_sym_GT_EQ] = ACTIONS(421),
  },
  [368] = {
    [anon_sym_LT] = ACTIONS(752),
    [anon_sym_RBRACE] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(752),
    [anon_sym_COLON] = ACTIONS(752),
    [anon_sym_PLUS] = ACTIONS(752),
    [anon_sym_as] = ACTIONS(752),
    [anon_sym_STAR] = ACTIONS(752),
    [sym_eol] = ACTIONS(754),
    [anon_sym_GT] = ACTIONS(752),
    [anon_sym_BANG_EQ] = ACTIONS(752),
    [anon_sym_PERCENT] = ACTIONS(752),
    [anon_sym_LT_EQ] = ACTIONS(752),
    [anon_sym_DASH] = ACTIONS(752),
    [anon_sym_EQ_EQ] = ACTIONS(752),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_GT_EQ] = ACTIONS(752),
  },
  [369] = {
    [aux_sym_map_literal_repeat1] = STATE(369),
    [anon_sym_RBRACE] = ACTIONS(756),
    [anon_sym_COMMA] = ACTIONS(758),
  },
  [370] = {
    [anon_sym_LT] = ACTIONS(544),
    [anon_sym_RBRACE] = ACTIONS(431),
    [anon_sym_COMMA] = ACTIONS(431),
    [anon_sym_BANG_EQ] = ACTIONS(546),
    [anon_sym_PERCENT] = ACTIONS(550),
    [anon_sym_LT_EQ] = ACTIONS(546),
    [anon_sym_PLUS] = ACTIONS(554),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(550),
    [anon_sym_GT] = ACTIONS(544),
    [anon_sym_DASH] = ACTIONS(554),
    [anon_sym_EQ_EQ] = ACTIONS(546),
    [anon_sym_SLASH] = ACTIONS(550),
    [anon_sym_GT_EQ] = ACTIONS(546),
  },
  [371] = {
    [anon_sym_LT] = ACTIONS(95),
    [anon_sym_BANG_EQ] = ACTIONS(95),
    [anon_sym_PERCENT] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(95),
    [anon_sym_PLUS] = ACTIONS(99),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(97),
    [sym_eol] = ACTIONS(761),
    [anon_sym_GT] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(99),
    [anon_sym_EQ_EQ] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(97),
    [anon_sym_GT_EQ] = ACTIONS(95),
  },
  [372] = {
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_BANG_EQ] = ACTIONS(413),
    [anon_sym_PERCENT] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(413),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(583),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_SLASH] = ACTIONS(583),
    [anon_sym_GT_EQ] = ACTIONS(413),
  },
  [373] = {
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(421),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(583),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_DASH] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(583),
    [anon_sym_GT_EQ] = ACTIONS(421),
  },
  [374] = {
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_BANG_EQ] = ACTIONS(581),
    [anon_sym_PERCENT] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(431),
    [anon_sym_LT_EQ] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(583),
    [anon_sym_GT] = ACTIONS(579),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_EQ_EQ] = ACTIONS(581),
    [anon_sym_SLASH] = ACTIONS(583),
    [anon_sym_GT_EQ] = ACTIONS(581),
  },
  [375] = {
    [anon_sym_LT] = ACTIONS(763),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(763),
    [anon_sym_in] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
  },
  [376] = {
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_as] = ACTIONS(89),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(87),
    [anon_sym_in] = ACTIONS(89),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(89),
    [anon_sym_PERCENT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(89),
    [anon_sym_EQ_EQ] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(89),
    [anon_sym_GT_EQ] = ACTIONS(89),
  },
  [377] = {
    [anon_sym_EQ] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(571),
  },
  [378] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(422),
    [sym__statement] = STATE(422),
    [sym_assignment] = STATE(19),
    [sym_function_call] = STATE(19),
    [sym_multiplication_expression] = STATE(19),
    [sym_cast_expression] = STATE(19),
    [sym_primary] = STATE(19),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(422),
    [sym_block_statement] = STATE(422),
    [sym_expression_statement] = STATE(422),
    [sym__expression] = STATE(19),
    [sym_comparison_expression] = STATE(19),
    [sym_addition_expression] = STATE(19),
    [sym_when_statement] = STATE(422),
    [sym_for_statement] = STATE(422),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(19),
    [sym_unary_expression] = STATE(19),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(23),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [379] = {
    [anon_sym_LBRACE] = ACTIONS(775),
    [anon_sym_COMMA] = ACTIONS(775),
  },
  [380] = {
    [aux_sym_type_list_repeat1] = STATE(380),
    [anon_sym_LBRACE] = ACTIONS(775),
    [anon_sym_COMMA] = ACTIONS(777),
  },
  [381] = {
    [anon_sym_LT] = ACTIONS(780),
    [anon_sym_RBRACE] = ACTIONS(780),
    [anon_sym_COMMA] = ACTIONS(780),
    [anon_sym_COLON] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_STAR] = ACTIONS(780),
    [sym_eol] = ACTIONS(782),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_GT_EQ] = ACTIONS(780),
  },
  [382] = {
    [anon_sym_RBRACE] = ACTIONS(784),
  },
  [383] = {
    [anon_sym_RBRACE] = ACTIONS(713),
    [anon_sym_false] = ACTIONS(711),
    [anon_sym_fun] = ACTIONS(711),
    [anon_sym_when] = ACTIONS(711),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(713),
    [anon_sym_true] = ACTIONS(711),
    [anon_sym_return] = ACTIONS(711),
    [anon_sym_let] = ACTIONS(711),
    [ts_builtin_sym_end] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(713),
    [aux_sym_number_token1] = ACTIONS(713),
    [anon_sym_for] = ACTIONS(711),
    [aux_sym_identifier_token1] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(711),
    [anon_sym_var] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(713),
  },
  [384] = {
    [sym_block_statement] = STATE(424),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [385] = {
    [anon_sym_RBRACE] = ACTIONS(786),
    [anon_sym_false] = ACTIONS(788),
    [anon_sym_fun] = ACTIONS(788),
    [anon_sym_when] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_LBRACE] = ACTIONS(786),
    [anon_sym_true] = ACTIONS(788),
    [anon_sym_return] = ACTIONS(788),
    [anon_sym_let] = ACTIONS(788),
    [ts_builtin_sym_end] = ACTIONS(786),
    [anon_sym_LBRACK] = ACTIONS(786),
    [aux_sym_number_token1] = ACTIONS(786),
    [anon_sym_for] = ACTIONS(788),
    [aux_sym_identifier_token1] = ACTIONS(788),
    [anon_sym_while] = ACTIONS(788),
    [anon_sym_var] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(786),
    [anon_sym_DASH] = ACTIONS(786),
  },
  [386] = {
    [anon_sym_RBRACE] = ACTIONS(790),
  },
  [387] = {
    [anon_sym_LT] = ACTIONS(780),
    [anon_sym_RBRACE] = ACTIONS(782),
    [anon_sym_COMMA] = ACTIONS(782),
    [anon_sym_COLON] = ACTIONS(782),
    [anon_sym_PLUS] = ACTIONS(782),
    [anon_sym_as] = ACTIONS(782),
    [anon_sym_STAR] = ACTIONS(782),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(782),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_in] = ACTIONS(782),
    [anon_sym_RPAREN] = ACTIONS(782),
    [anon_sym_BANG_EQ] = ACTIONS(782),
    [anon_sym_PERCENT] = ACTIONS(782),
    [anon_sym_RBRACK] = ACTIONS(782),
    [anon_sym_LT_EQ] = ACTIONS(782),
    [anon_sym_DASH] = ACTIONS(782),
    [anon_sym_EQ_EQ] = ACTIONS(782),
    [anon_sym_SLASH] = ACTIONS(782),
    [anon_sym_DOT_DOT_LT] = ACTIONS(782),
    [anon_sym_GT_EQ] = ACTIONS(782),
  },
  [388] = {
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(217),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(221),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(221),
    [anon_sym_EQ_EQ] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(792),
  },
  [389] = {
    [sym_else_result] = STATE(428),
    [anon_sym_RBRACE] = ACTIONS(794),
    [anon_sym_else] = ACTIONS(320),
  },
  [390] = {
    [anon_sym_RBRACE] = ACTIONS(342),
    [anon_sym_false] = ACTIONS(344),
    [anon_sym_LBRACK] = ACTIONS(342),
    [anon_sym_BANG] = ACTIONS(342),
    [aux_sym_number_token1] = ACTIONS(342),
    [anon_sym_else] = ACTIONS(344),
    [aux_sym_identifier_token1] = ACTIONS(344),
    [anon_sym_LPAREN] = ACTIONS(342),
    [anon_sym_DASH] = ACTIONS(342),
    [anon_sym_LBRACE] = ACTIONS(342),
    [anon_sym_true] = ACTIONS(344),
  },
  [391] = {
    [anon_sym_in] = ACTIONS(796),
  },
  [392] = {
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(217),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(221),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(221),
    [anon_sym_EQ_EQ] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(798),
  },
  [393] = {
    [anon_sym_RBRACE] = ACTIONS(362),
    [anon_sym_false] = ACTIONS(364),
    [anon_sym_LBRACK] = ACTIONS(362),
    [anon_sym_BANG] = ACTIONS(362),
    [aux_sym_number_token1] = ACTIONS(362),
    [anon_sym_else] = ACTIONS(364),
    [aux_sym_identifier_token1] = ACTIONS(364),
    [anon_sym_LPAREN] = ACTIONS(362),
    [anon_sym_DASH] = ACTIONS(362),
    [anon_sym_LBRACE] = ACTIONS(362),
    [anon_sym_true] = ACTIONS(364),
  },
  [394] = {
    [anon_sym_RBRACE] = ACTIONS(375),
    [anon_sym_false] = ACTIONS(377),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(375),
    [aux_sym_number_token1] = ACTIONS(375),
    [anon_sym_else] = ACTIONS(377),
    [aux_sym_identifier_token1] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(375),
    [anon_sym_true] = ACTIONS(377),
  },
  [395] = {
    [aux_sym_return_statement_repeat1] = STATE(205),
    [sym_eol] = ACTIONS(800),
    [anon_sym_COMMA] = ACTIONS(173),
  },
  [396] = {
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_RBRACE] = ACTIONS(411),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(655),
    [sym_eol] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(655),
    [anon_sym_LT_EQ] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_EQ_EQ] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(655),
    [anon_sym_GT_EQ] = ACTIONS(411),
  },
  [397] = {
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(655),
    [sym_eol] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(655),
    [anon_sym_LT_EQ] = ACTIONS(419),
    [anon_sym_DASH] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(655),
    [anon_sym_GT_EQ] = ACTIONS(419),
  },
  [398] = {
    [anon_sym_LT] = ACTIONS(752),
    [anon_sym_RBRACE] = ACTIONS(754),
    [anon_sym_COMMA] = ACTIONS(754),
    [anon_sym_COLON] = ACTIONS(754),
    [anon_sym_PLUS] = ACTIONS(754),
    [anon_sym_as] = ACTIONS(754),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(754),
    [anon_sym_GT] = ACTIONS(752),
    [anon_sym_in] = ACTIONS(754),
    [anon_sym_RPAREN] = ACTIONS(754),
    [anon_sym_BANG_EQ] = ACTIONS(754),
    [anon_sym_PERCENT] = ACTIONS(754),
    [anon_sym_RBRACK] = ACTIONS(754),
    [anon_sym_LT_EQ] = ACTIONS(754),
    [anon_sym_DASH] = ACTIONS(754),
    [anon_sym_EQ_EQ] = ACTIONS(754),
    [anon_sym_SLASH] = ACTIONS(754),
    [anon_sym_DOT_DOT_LT] = ACTIONS(754),
    [anon_sym_GT_EQ] = ACTIONS(754),
  },
  [399] = {
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_RBRACE] = ACTIONS(558),
    [anon_sym_COMMA] = ACTIONS(558),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_as] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(655),
    [sym_eol] = ACTIONS(431),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(655),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_SLASH] = ACTIONS(655),
    [anon_sym_GT_EQ] = ACTIONS(647),
  },
  [400] = {
    [anon_sym_LT] = ACTIONS(119),
    [anon_sym_BANG_EQ] = ACTIONS(121),
    [anon_sym_PERCENT] = ACTIONS(123),
    [anon_sym_COLON] = ACTIONS(802),
    [anon_sym_LT_EQ] = ACTIONS(121),
    [anon_sym_PLUS] = ACTIONS(127),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_GT] = ACTIONS(119),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_EQ_EQ] = ACTIONS(121),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_GT_EQ] = ACTIONS(121),
  },
  [401] = {
    [sym_else_result] = STATE(88),
    [anon_sym_RBRACE] = ACTIONS(137),
    [anon_sym_else] = ACTIONS(320),
  },
  [402] = {
    [sym_variable_declaration] = STATE(434),
    [anon_sym_var] = ACTIONS(209),
    [anon_sym_let] = ACTIONS(209),
  },
  [403] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(435),
    [sym_function_call] = STATE(435),
    [sym_multiplication_expression] = STATE(435),
    [sym_cast_expression] = STATE(435),
    [sym_primary] = STATE(435),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(435),
    [sym_comparison_expression] = STATE(435),
    [sym_addition_expression] = STATE(435),
    [sym_identifier] = STATE(126),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(435),
    [sym_unary_expression] = STATE(435),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [404] = {
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_RBRACE] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(147),
    [anon_sym_as] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(147),
    [sym_eol] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_BANG_EQ] = ACTIONS(147),
    [anon_sym_PERCENT] = ACTIONS(147),
    [anon_sym_LT_EQ] = ACTIONS(147),
    [anon_sym_else] = ACTIONS(149),
    [anon_sym_DASH] = ACTIONS(147),
    [anon_sym_EQ_EQ] = ACTIONS(147),
    [anon_sym_SLASH] = ACTIONS(147),
    [anon_sym_GT_EQ] = ACTIONS(147),
  },
  [405] = {
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_BANG_EQ] = ACTIONS(405),
    [anon_sym_PERCENT] = ACTIONS(405),
    [anon_sym_COLON] = ACTIONS(405),
    [anon_sym_LT_EQ] = ACTIONS(405),
    [anon_sym_PLUS] = ACTIONS(405),
    [anon_sym_as] = ACTIONS(405),
    [anon_sym_STAR] = ACTIONS(405),
    [anon_sym_GT] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(405),
    [anon_sym_EQ_EQ] = ACTIONS(405),
    [anon_sym_SLASH] = ACTIONS(405),
    [anon_sym_LBRACE] = ACTIONS(804),
    [anon_sym_GT_EQ] = ACTIONS(405),
  },
  [406] = {
    [anon_sym_RBRACE] = ACTIONS(506),
    [anon_sym_false] = ACTIONS(508),
    [anon_sym_BANG] = ACTIONS(506),
    [anon_sym_fun] = ACTIONS(508),
    [anon_sym_when] = ACTIONS(508),
    [anon_sym_LBRACE] = ACTIONS(506),
    [anon_sym_true] = ACTIONS(508),
    [anon_sym_return] = ACTIONS(508),
    [anon_sym_let] = ACTIONS(508),
    [ts_builtin_sym_end] = ACTIONS(506),
    [anon_sym_LBRACK] = ACTIONS(506),
    [aux_sym_number_token1] = ACTIONS(506),
    [anon_sym_for] = ACTIONS(508),
    [anon_sym_else] = ACTIONS(508),
    [anon_sym_while] = ACTIONS(508),
    [anon_sym_var] = ACTIONS(508),
    [anon_sym_LPAREN] = ACTIONS(506),
    [anon_sym_DASH] = ACTIONS(506),
    [aux_sym_identifier_token1] = ACTIONS(508),
  },
  [407] = {
    [anon_sym_RBRACE] = ACTIONS(806),
  },
  [408] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(438),
    [sym__statement] = STATE(438),
    [sym_assignment] = STATE(178),
    [sym_function_call] = STATE(178),
    [sym_multiplication_expression] = STATE(178),
    [sym_cast_expression] = STATE(178),
    [sym_primary] = STATE(178),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(438),
    [sym_block_statement] = STATE(438),
    [sym_expression_statement] = STATE(438),
    [sym__expression] = STATE(178),
    [sym_comparison_expression] = STATE(178),
    [sym_addition_expression] = STATE(178),
    [sym_when_statement] = STATE(438),
    [sym_for_statement] = STATE(438),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(178),
    [sym_unary_expression] = STATE(178),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(322),
    [anon_sym_for] = ACTIONS(324),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(326),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(328),
    [anon_sym_return] = ACTIONS(330),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [409] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(439),
    [sym_function_call] = STATE(439),
    [sym_multiplication_expression] = STATE(439),
    [sym_cast_expression] = STATE(439),
    [sym_primary] = STATE(439),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(439),
    [sym_comparison_expression] = STATE(439),
    [sym_addition_expression] = STATE(439),
    [sym_identifier] = STATE(126),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(439),
    [sym_unary_expression] = STATE(439),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [410] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(440),
    [sym__statement] = STATE(440),
    [sym_assignment] = STATE(178),
    [sym_function_call] = STATE(178),
    [sym_multiplication_expression] = STATE(178),
    [sym_cast_expression] = STATE(178),
    [sym_primary] = STATE(178),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(440),
    [sym_block_statement] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym__expression] = STATE(178),
    [sym_comparison_expression] = STATE(178),
    [sym_addition_expression] = STATE(178),
    [sym_when_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(178),
    [sym_unary_expression] = STATE(178),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(322),
    [anon_sym_for] = ACTIONS(324),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(326),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(328),
    [anon_sym_return] = ACTIONS(330),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [411] = {
    [anon_sym_RBRACE] = ACTIONS(564),
    [anon_sym_false] = ACTIONS(566),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_fun] = ACTIONS(566),
    [anon_sym_when] = ACTIONS(566),
    [anon_sym_LBRACE] = ACTIONS(564),
    [anon_sym_true] = ACTIONS(566),
    [anon_sym_return] = ACTIONS(566),
    [anon_sym_let] = ACTIONS(566),
    [ts_builtin_sym_end] = ACTIONS(564),
    [anon_sym_LBRACK] = ACTIONS(564),
    [aux_sym_number_token1] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_else] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(566),
    [anon_sym_var] = ACTIONS(566),
    [anon_sym_LPAREN] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(564),
    [aux_sym_identifier_token1] = ACTIONS(566),
  },
  [412] = {
    [anon_sym_RBRACE] = ACTIONS(808),
  },
  [413] = {
    [anon_sym_in] = ACTIONS(810),
  },
  [414] = {
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(217),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(221),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(221),
    [anon_sym_EQ_EQ] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(812),
  },
  [415] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(422),
    [sym__statement] = STATE(422),
    [sym_assignment] = STATE(19),
    [sym_function_call] = STATE(19),
    [sym_multiplication_expression] = STATE(19),
    [sym_cast_expression] = STATE(19),
    [sym_primary] = STATE(19),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(422),
    [sym_block_statement] = STATE(422),
    [sym_expression_statement] = STATE(422),
    [sym__expression] = STATE(19),
    [sym_comparison_expression] = STATE(19),
    [sym_addition_expression] = STATE(19),
    [sym_when_statement] = STATE(422),
    [sym_for_statement] = STATE(422),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(19),
    [sym_unary_expression] = STATE(19),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [416] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(445),
    [sym_function_call] = STATE(445),
    [sym_multiplication_expression] = STATE(445),
    [sym_cast_expression] = STATE(445),
    [sym_primary] = STATE(445),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(445),
    [sym_comparison_expression] = STATE(445),
    [sym_addition_expression] = STATE(445),
    [sym_identifier] = STATE(198),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(445),
    [sym_unary_expression] = STATE(445),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [417] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(446),
    [sym_function_call] = STATE(446),
    [sym_multiplication_expression] = STATE(446),
    [sym_cast_expression] = STATE(446),
    [sym_primary] = STATE(446),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(446),
    [sym_comparison_expression] = STATE(446),
    [sym_addition_expression] = STATE(446),
    [sym_identifier] = STATE(376),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(446),
    [sym_unary_expression] = STATE(446),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [418] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(171),
    [sym_function_call] = STATE(171),
    [sym_multiplication_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym_primary] = STATE(171),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(171),
    [sym_comparison_expression] = STATE(171),
    [sym_addition_expression] = STATE(171),
    [sym_identifier] = STATE(376),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(171),
    [sym_unary_expression] = STATE(171),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [419] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(447),
    [sym_function_call] = STATE(447),
    [sym_multiplication_expression] = STATE(447),
    [sym_cast_expression] = STATE(447),
    [sym_primary] = STATE(447),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(447),
    [sym_comparison_expression] = STATE(447),
    [sym_addition_expression] = STATE(447),
    [sym_identifier] = STATE(376),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(447),
    [sym_unary_expression] = STATE(447),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [420] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(448),
    [sym_function_call] = STATE(448),
    [sym_multiplication_expression] = STATE(448),
    [sym_cast_expression] = STATE(448),
    [sym_primary] = STATE(448),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(448),
    [sym_comparison_expression] = STATE(448),
    [sym_addition_expression] = STATE(448),
    [sym_identifier] = STATE(376),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(448),
    [sym_unary_expression] = STATE(448),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [421] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(449),
    [sym_function_call] = STATE(449),
    [sym_multiplication_expression] = STATE(449),
    [sym_cast_expression] = STATE(449),
    [sym_primary] = STATE(449),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(449),
    [sym_comparison_expression] = STATE(449),
    [sym_addition_expression] = STATE(449),
    [sym_identifier] = STATE(376),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(449),
    [sym_unary_expression] = STATE(449),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [422] = {
    [anon_sym_RBRACE] = ACTIONS(814),
    [anon_sym_false] = ACTIONS(816),
    [anon_sym_fun] = ACTIONS(816),
    [anon_sym_when] = ACTIONS(816),
    [anon_sym_BANG] = ACTIONS(814),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_true] = ACTIONS(816),
    [anon_sym_return] = ACTIONS(816),
    [anon_sym_let] = ACTIONS(816),
    [ts_builtin_sym_end] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(814),
    [aux_sym_number_token1] = ACTIONS(814),
    [anon_sym_for] = ACTIONS(816),
    [aux_sym_identifier_token1] = ACTIONS(816),
    [anon_sym_while] = ACTIONS(816),
    [anon_sym_var] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
  },
  [423] = {
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_RBRACE] = ACTIONS(818),
    [anon_sym_COMMA] = ACTIONS(818),
    [anon_sym_COLON] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(818),
    [anon_sym_as] = ACTIONS(818),
    [anon_sym_STAR] = ACTIONS(818),
    [sym_eol] = ACTIONS(820),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_EQ] = ACTIONS(818),
    [anon_sym_BANG_EQ] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(818),
    [anon_sym_LT_EQ] = ACTIONS(818),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_EQ_EQ] = ACTIONS(818),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_GT_EQ] = ACTIONS(818),
  },
  [424] = {
    [anon_sym_RBRACE] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(780),
    [anon_sym_fun] = ACTIONS(780),
    [anon_sym_when] = ACTIONS(780),
    [anon_sym_BANG] = ACTIONS(782),
    [anon_sym_LBRACE] = ACTIONS(782),
    [anon_sym_true] = ACTIONS(780),
    [anon_sym_return] = ACTIONS(780),
    [anon_sym_let] = ACTIONS(780),
    [ts_builtin_sym_end] = ACTIONS(782),
    [anon_sym_LBRACK] = ACTIONS(782),
    [aux_sym_number_token1] = ACTIONS(782),
    [anon_sym_for] = ACTIONS(780),
    [aux_sym_identifier_token1] = ACTIONS(780),
    [anon_sym_while] = ACTIONS(780),
    [anon_sym_var] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(782),
    [anon_sym_DASH] = ACTIONS(782),
  },
  [425] = {
    [anon_sym_RBRACE] = ACTIONS(822),
    [anon_sym_false] = ACTIONS(824),
    [anon_sym_fun] = ACTIONS(824),
    [anon_sym_when] = ACTIONS(824),
    [anon_sym_BANG] = ACTIONS(822),
    [anon_sym_LBRACE] = ACTIONS(822),
    [anon_sym_true] = ACTIONS(824),
    [anon_sym_return] = ACTIONS(824),
    [anon_sym_let] = ACTIONS(824),
    [ts_builtin_sym_end] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(822),
    [aux_sym_number_token1] = ACTIONS(822),
    [anon_sym_for] = ACTIONS(824),
    [aux_sym_identifier_token1] = ACTIONS(824),
    [anon_sym_while] = ACTIONS(824),
    [anon_sym_var] = ACTIONS(824),
    [anon_sym_LPAREN] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
  },
  [426] = {
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_BANG_EQ] = ACTIONS(405),
    [anon_sym_PERCENT] = ACTIONS(405),
    [anon_sym_COLON] = ACTIONS(405),
    [anon_sym_LT_EQ] = ACTIONS(405),
    [anon_sym_PLUS] = ACTIONS(405),
    [anon_sym_as] = ACTIONS(405),
    [anon_sym_STAR] = ACTIONS(405),
    [anon_sym_GT] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(405),
    [anon_sym_EQ_EQ] = ACTIONS(405),
    [anon_sym_SLASH] = ACTIONS(405),
    [anon_sym_LBRACE] = ACTIONS(826),
    [anon_sym_GT_EQ] = ACTIONS(405),
  },
  [427] = {
    [anon_sym_RBRACE] = ACTIONS(506),
    [anon_sym_false] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(506),
    [anon_sym_BANG] = ACTIONS(506),
    [aux_sym_number_token1] = ACTIONS(506),
    [anon_sym_else] = ACTIONS(508),
    [aux_sym_identifier_token1] = ACTIONS(508),
    [anon_sym_LPAREN] = ACTIONS(506),
    [anon_sym_DASH] = ACTIONS(506),
    [anon_sym_LBRACE] = ACTIONS(506),
    [anon_sym_true] = ACTIONS(508),
  },
  [428] = {
    [anon_sym_RBRACE] = ACTIONS(828),
  },
  [429] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(452),
    [sym__statement] = STATE(452),
    [sym_assignment] = STATE(332),
    [sym_function_call] = STATE(332),
    [sym_multiplication_expression] = STATE(332),
    [sym_cast_expression] = STATE(332),
    [sym_primary] = STATE(332),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(452),
    [sym_block_statement] = STATE(452),
    [sym_expression_statement] = STATE(452),
    [sym__expression] = STATE(332),
    [sym_comparison_expression] = STATE(332),
    [sym_addition_expression] = STATE(332),
    [sym_when_statement] = STATE(452),
    [sym_for_statement] = STATE(452),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(332),
    [sym_unary_expression] = STATE(332),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(496),
    [anon_sym_for] = ACTIONS(498),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(500),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(502),
    [anon_sym_return] = ACTIONS(504),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [430] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(453),
    [sym_function_call] = STATE(453),
    [sym_multiplication_expression] = STATE(453),
    [sym_cast_expression] = STATE(453),
    [sym_primary] = STATE(453),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(453),
    [sym_comparison_expression] = STATE(453),
    [sym_addition_expression] = STATE(453),
    [sym_identifier] = STATE(126),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(453),
    [sym_unary_expression] = STATE(453),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [431] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(454),
    [sym__statement] = STATE(454),
    [sym_assignment] = STATE(332),
    [sym_function_call] = STATE(332),
    [sym_multiplication_expression] = STATE(332),
    [sym_cast_expression] = STATE(332),
    [sym_primary] = STATE(332),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(454),
    [sym_block_statement] = STATE(454),
    [sym_expression_statement] = STATE(454),
    [sym__expression] = STATE(332),
    [sym_comparison_expression] = STATE(332),
    [sym_addition_expression] = STATE(332),
    [sym_when_statement] = STATE(454),
    [sym_for_statement] = STATE(454),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(332),
    [sym_unary_expression] = STATE(332),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(496),
    [anon_sym_for] = ACTIONS(498),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(500),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(502),
    [anon_sym_return] = ACTIONS(504),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [432] = {
    [anon_sym_RBRACE] = ACTIONS(564),
    [anon_sym_false] = ACTIONS(566),
    [anon_sym_LBRACK] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [aux_sym_number_token1] = ACTIONS(564),
    [anon_sym_else] = ACTIONS(566),
    [aux_sym_identifier_token1] = ACTIONS(566),
    [anon_sym_LPAREN] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_LBRACE] = ACTIONS(564),
    [anon_sym_true] = ACTIONS(566),
  },
  [433] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(177),
    [sym__statement] = STATE(177),
    [sym_assignment] = STATE(178),
    [sym_function_call] = STATE(178),
    [sym_multiplication_expression] = STATE(178),
    [sym_cast_expression] = STATE(178),
    [sym_primary] = STATE(178),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(177),
    [sym_block_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym__expression] = STATE(178),
    [sym_comparison_expression] = STATE(178),
    [sym_addition_expression] = STATE(178),
    [sym_when_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(178),
    [sym_unary_expression] = STATE(178),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(830),
    [anon_sym_for] = ACTIONS(832),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(836),
    [anon_sym_return] = ACTIONS(330),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [434] = {
    [anon_sym_in] = ACTIONS(838),
  },
  [435] = {
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(217),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(221),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(221),
    [anon_sym_EQ_EQ] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(840),
  },
  [436] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [aux_sym_clause_list_repeat1] = STATE(77),
    [sym_assignment] = STATE(165),
    [sym_function_call] = STATE(165),
    [sym_multiplication_expression] = STATE(165),
    [sym_cast_expression] = STATE(165),
    [sym_primary] = STATE(165),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(165),
    [sym_comparison_expression] = STATE(165),
    [sym_addition_expression] = STATE(165),
    [sym_identifier] = STATE(31),
    [sym_number] = STATE(29),
    [sym_clause_result] = STATE(77),
    [sym_clause_list] = STATE(461),
    [sym_range_literal] = STATE(165),
    [sym_unary_expression] = STATE(165),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [437] = {
    [anon_sym_RBRACE] = ACTIONS(669),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_fun] = ACTIONS(671),
    [anon_sym_when] = ACTIONS(671),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_return] = ACTIONS(671),
    [anon_sym_let] = ACTIONS(671),
    [ts_builtin_sym_end] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(669),
    [aux_sym_number_token1] = ACTIONS(669),
    [anon_sym_for] = ACTIONS(671),
    [anon_sym_else] = ACTIONS(671),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_var] = ACTIONS(671),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(669),
    [aux_sym_identifier_token1] = ACTIONS(671),
  },
  [438] = {
    [anon_sym_RBRACE] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(681),
    [anon_sym_fun] = ACTIONS(683),
    [anon_sym_when] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(681),
    [anon_sym_true] = ACTIONS(683),
    [anon_sym_return] = ACTIONS(683),
    [anon_sym_let] = ACTIONS(683),
    [ts_builtin_sym_end] = ACTIONS(681),
    [anon_sym_LBRACK] = ACTIONS(681),
    [aux_sym_number_token1] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_else] = ACTIONS(683),
    [anon_sym_while] = ACTIONS(683),
    [anon_sym_var] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [aux_sym_identifier_token1] = ACTIONS(683),
  },
  [439] = {
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(217),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(221),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(221),
    [anon_sym_EQ_EQ] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(842),
  },
  [440] = {
    [anon_sym_RBRACE] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_fun] = ACTIONS(709),
    [anon_sym_when] = ACTIONS(709),
    [anon_sym_LBRACE] = ACTIONS(707),
    [anon_sym_true] = ACTIONS(709),
    [anon_sym_return] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(709),
    [ts_builtin_sym_end] = ACTIONS(707),
    [anon_sym_LBRACK] = ACTIONS(707),
    [aux_sym_number_token1] = ACTIONS(707),
    [anon_sym_for] = ACTIONS(709),
    [anon_sym_else] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_var] = ACTIONS(709),
    [anon_sym_LPAREN] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(707),
    [aux_sym_identifier_token1] = ACTIONS(709),
  },
  [441] = {
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_RBRACE] = ACTIONS(820),
    [anon_sym_COMMA] = ACTIONS(820),
    [anon_sym_COLON] = ACTIONS(820),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_as] = ACTIONS(820),
    [anon_sym_STAR] = ACTIONS(820),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(820),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_in] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(820),
    [anon_sym_RPAREN] = ACTIONS(820),
    [anon_sym_EQ] = ACTIONS(818),
    [anon_sym_BANG_EQ] = ACTIONS(820),
    [anon_sym_PERCENT] = ACTIONS(820),
    [anon_sym_RBRACK] = ACTIONS(820),
    [anon_sym_LT_EQ] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_EQ_EQ] = ACTIONS(820),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_DOT_DOT_LT] = ACTIONS(820),
    [anon_sym_GT_EQ] = ACTIONS(820),
  },
  [442] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(438),
    [sym__statement] = STATE(438),
    [sym_assignment] = STATE(178),
    [sym_function_call] = STATE(178),
    [sym_multiplication_expression] = STATE(178),
    [sym_cast_expression] = STATE(178),
    [sym_primary] = STATE(178),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(438),
    [sym_block_statement] = STATE(438),
    [sym_expression_statement] = STATE(438),
    [sym__expression] = STATE(178),
    [sym_comparison_expression] = STATE(178),
    [sym_addition_expression] = STATE(178),
    [sym_when_statement] = STATE(438),
    [sym_for_statement] = STATE(438),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(178),
    [sym_unary_expression] = STATE(178),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(536),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(328),
    [anon_sym_return] = ACTIONS(330),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [443] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(463),
    [sym_function_call] = STATE(463),
    [sym_multiplication_expression] = STATE(463),
    [sym_cast_expression] = STATE(463),
    [sym_primary] = STATE(463),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(463),
    [sym_comparison_expression] = STATE(463),
    [sym_addition_expression] = STATE(463),
    [sym_identifier] = STATE(126),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(463),
    [sym_unary_expression] = STATE(463),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [444] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(440),
    [sym__statement] = STATE(440),
    [sym_assignment] = STATE(178),
    [sym_function_call] = STATE(178),
    [sym_multiplication_expression] = STATE(178),
    [sym_cast_expression] = STATE(178),
    [sym_primary] = STATE(178),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(440),
    [sym_block_statement] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym__expression] = STATE(178),
    [sym_comparison_expression] = STATE(178),
    [sym_addition_expression] = STATE(178),
    [sym_when_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(178),
    [sym_unary_expression] = STATE(178),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(536),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(328),
    [anon_sym_return] = ACTIONS(330),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [445] = {
    [anon_sym_LT] = ACTIONS(544),
    [anon_sym_RBRACE] = ACTIONS(844),
    [anon_sym_COMMA] = ACTIONS(844),
    [anon_sym_BANG_EQ] = ACTIONS(546),
    [anon_sym_PERCENT] = ACTIONS(550),
    [anon_sym_LT_EQ] = ACTIONS(546),
    [anon_sym_PLUS] = ACTIONS(554),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(550),
    [anon_sym_GT] = ACTIONS(544),
    [anon_sym_DASH] = ACTIONS(554),
    [anon_sym_EQ_EQ] = ACTIONS(546),
    [anon_sym_SLASH] = ACTIONS(550),
    [anon_sym_GT_EQ] = ACTIONS(546),
  },
  [446] = {
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_BANG_EQ] = ACTIONS(413),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(413),
  },
  [447] = {
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_DASH] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(421),
  },
  [448] = {
    [anon_sym_LT] = ACTIONS(763),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(763),
    [anon_sym_in] = ACTIONS(431),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
  },
  [449] = {
    [anon_sym_LT] = ACTIONS(763),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(763),
    [anon_sym_in] = ACTIONS(761),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(765),
  },
  [450] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [aux_sym_clause_list_repeat1] = STATE(77),
    [sym_assignment] = STATE(165),
    [sym_function_call] = STATE(165),
    [sym_multiplication_expression] = STATE(165),
    [sym_cast_expression] = STATE(165),
    [sym_primary] = STATE(165),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(165),
    [sym_comparison_expression] = STATE(165),
    [sym_addition_expression] = STATE(165),
    [sym_identifier] = STATE(31),
    [sym_number] = STATE(29),
    [sym_clause_result] = STATE(77),
    [sym_clause_list] = STATE(464),
    [sym_range_literal] = STATE(165),
    [sym_unary_expression] = STATE(165),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [451] = {
    [anon_sym_RBRACE] = ACTIONS(669),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_BANG] = ACTIONS(669),
    [aux_sym_number_token1] = ACTIONS(669),
    [anon_sym_else] = ACTIONS(671),
    [aux_sym_identifier_token1] = ACTIONS(671),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
  },
  [452] = {
    [anon_sym_RBRACE] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(683),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(681),
    [aux_sym_number_token1] = ACTIONS(681),
    [anon_sym_else] = ACTIONS(683),
    [aux_sym_identifier_token1] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(681),
    [anon_sym_true] = ACTIONS(683),
  },
  [453] = {
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(217),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(221),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(221),
    [anon_sym_EQ_EQ] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(846),
  },
  [454] = {
    [anon_sym_RBRACE] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [aux_sym_number_token1] = ACTIONS(707),
    [anon_sym_else] = ACTIONS(709),
    [aux_sym_identifier_token1] = ACTIONS(709),
    [anon_sym_LPAREN] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(707),
    [anon_sym_LBRACE] = ACTIONS(707),
    [anon_sym_true] = ACTIONS(709),
  },
  [455] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(400),
    [sym_function_call] = STATE(400),
    [sym_multiplication_expression] = STATE(400),
    [sym_cast_expression] = STATE(400),
    [sym_primary] = STATE(400),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(400),
    [sym_comparison_expression] = STATE(400),
    [sym_addition_expression] = STATE(400),
    [sym_identifier] = STATE(31),
    [sym_number] = STATE(29),
    [sym_clause_result] = STATE(270),
    [sym_range_literal] = STATE(400),
    [sym_unary_expression] = STATE(400),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(514),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(516),
    [anon_sym_true] = ACTIONS(37),
  },
  [456] = {
    [anon_sym_LPAREN] = ACTIONS(848),
  },
  [457] = {
    [anon_sym_LPAREN] = ACTIONS(850),
  },
  [458] = {
    [sym_function_literal] = STATE(16),
    [sym_variable_declaration] = STATE(15),
    [sym__statement] = STATE(252),
    [sym_return_statement] = STATE(252),
    [sym_map_literal] = STATE(16),
    [sym_assignment] = STATE(40),
    [sym_function_call] = STATE(40),
    [sym_multiplication_expression] = STATE(40),
    [sym_cast_expression] = STATE(40),
    [sym_parenthetical_expression] = STATE(16),
    [sym_primary] = STATE(40),
    [sym__declaration] = STATE(252),
    [sym_function_declaration] = STATE(252),
    [sym_while_statement] = STATE(252),
    [sym_block_statement] = STATE(252),
    [sym_expression_statement] = STATE(252),
    [sym__expression] = STATE(40),
    [sym_comparison_expression] = STATE(40),
    [sym_addition_expression] = STATE(40),
    [sym_list_literal] = STATE(16),
    [aux_sym_source_file_repeat1] = STATE(252),
    [sym_when_statement] = STATE(252),
    [sym_for_statement] = STATE(252),
    [sym_identifier] = STATE(42),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(40),
    [sym_unary_expression] = STATE(40),
    [sym_bool_literal] = STATE(16),
    [anon_sym_RBRACE] = ACTIONS(736),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_fun] = ACTIONS(5),
    [anon_sym_when] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_true] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [aux_sym_number_token1] = ACTIONS(21),
    [anon_sym_for] = ACTIONS(59),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_var] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
  },
  [459] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(468),
    [sym_function_call] = STATE(468),
    [sym_multiplication_expression] = STATE(468),
    [sym_cast_expression] = STATE(468),
    [sym_primary] = STATE(468),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(468),
    [sym_comparison_expression] = STATE(468),
    [sym_addition_expression] = STATE(468),
    [sym_identifier] = STATE(126),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(468),
    [sym_unary_expression] = STATE(468),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [460] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(309),
    [sym__statement] = STATE(309),
    [sym_assignment] = STATE(19),
    [sym_function_call] = STATE(19),
    [sym_multiplication_expression] = STATE(19),
    [sym_cast_expression] = STATE(19),
    [sym_primary] = STATE(19),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(309),
    [sym_block_statement] = STATE(309),
    [sym_expression_statement] = STATE(309),
    [sym__expression] = STATE(19),
    [sym_comparison_expression] = STATE(19),
    [sym_addition_expression] = STATE(19),
    [sym_when_statement] = STATE(309),
    [sym_for_statement] = STATE(309),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(19),
    [sym_unary_expression] = STATE(19),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(663),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(665),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [461] = {
    [sym_else_result] = STATE(470),
    [anon_sym_RBRACE] = ACTIONS(852),
    [anon_sym_else] = ACTIONS(320),
  },
  [462] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(471),
    [sym__statement] = STATE(471),
    [sym_assignment] = STATE(178),
    [sym_function_call] = STATE(178),
    [sym_multiplication_expression] = STATE(178),
    [sym_cast_expression] = STATE(178),
    [sym_primary] = STATE(178),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(471),
    [sym_block_statement] = STATE(471),
    [sym_expression_statement] = STATE(471),
    [sym__expression] = STATE(178),
    [sym_comparison_expression] = STATE(178),
    [sym_addition_expression] = STATE(178),
    [sym_when_statement] = STATE(471),
    [sym_for_statement] = STATE(471),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(178),
    [sym_unary_expression] = STATE(178),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(322),
    [anon_sym_for] = ACTIONS(324),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(326),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(328),
    [anon_sym_return] = ACTIONS(330),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [463] = {
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(217),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(221),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(221),
    [anon_sym_EQ_EQ] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(854),
  },
  [464] = {
    [sym_else_result] = STATE(474),
    [anon_sym_RBRACE] = ACTIONS(856),
    [anon_sym_else] = ACTIONS(320),
  },
  [465] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(475),
    [sym__statement] = STATE(475),
    [sym_assignment] = STATE(332),
    [sym_function_call] = STATE(332),
    [sym_multiplication_expression] = STATE(332),
    [sym_cast_expression] = STATE(332),
    [sym_primary] = STATE(332),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(475),
    [sym_block_statement] = STATE(475),
    [sym_expression_statement] = STATE(475),
    [sym__expression] = STATE(332),
    [sym_comparison_expression] = STATE(332),
    [sym_addition_expression] = STATE(332),
    [sym_when_statement] = STATE(475),
    [sym_for_statement] = STATE(475),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(332),
    [sym_unary_expression] = STATE(332),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(496),
    [anon_sym_for] = ACTIONS(498),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(500),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(502),
    [anon_sym_return] = ACTIONS(504),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [466] = {
    [sym_variable_declaration] = STATE(476),
    [anon_sym_var] = ACTIONS(209),
    [anon_sym_let] = ACTIONS(209),
  },
  [467] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(477),
    [sym_function_call] = STATE(477),
    [sym_multiplication_expression] = STATE(477),
    [sym_cast_expression] = STATE(477),
    [sym_primary] = STATE(477),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(477),
    [sym_comparison_expression] = STATE(477),
    [sym_addition_expression] = STATE(477),
    [sym_identifier] = STATE(126),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(477),
    [sym_unary_expression] = STATE(477),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [468] = {
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(217),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(221),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(221),
    [anon_sym_EQ_EQ] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(858),
  },
  [469] = {
    [anon_sym_RBRACE] = ACTIONS(786),
    [anon_sym_false] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_fun] = ACTIONS(788),
    [anon_sym_when] = ACTIONS(788),
    [anon_sym_LBRACE] = ACTIONS(786),
    [anon_sym_true] = ACTIONS(788),
    [anon_sym_return] = ACTIONS(788),
    [anon_sym_let] = ACTIONS(788),
    [ts_builtin_sym_end] = ACTIONS(786),
    [anon_sym_LBRACK] = ACTIONS(786),
    [aux_sym_number_token1] = ACTIONS(786),
    [anon_sym_for] = ACTIONS(788),
    [anon_sym_else] = ACTIONS(788),
    [anon_sym_while] = ACTIONS(788),
    [anon_sym_var] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(786),
    [anon_sym_DASH] = ACTIONS(786),
    [aux_sym_identifier_token1] = ACTIONS(788),
  },
  [470] = {
    [anon_sym_RBRACE] = ACTIONS(860),
  },
  [471] = {
    [anon_sym_RBRACE] = ACTIONS(814),
    [anon_sym_false] = ACTIONS(816),
    [anon_sym_BANG] = ACTIONS(814),
    [anon_sym_fun] = ACTIONS(816),
    [anon_sym_when] = ACTIONS(816),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_true] = ACTIONS(816),
    [anon_sym_return] = ACTIONS(816),
    [anon_sym_let] = ACTIONS(816),
    [ts_builtin_sym_end] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(814),
    [aux_sym_number_token1] = ACTIONS(814),
    [anon_sym_for] = ACTIONS(816),
    [anon_sym_else] = ACTIONS(816),
    [anon_sym_while] = ACTIONS(816),
    [anon_sym_var] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [aux_sym_identifier_token1] = ACTIONS(816),
  },
  [472] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(471),
    [sym__statement] = STATE(471),
    [sym_assignment] = STATE(178),
    [sym_function_call] = STATE(178),
    [sym_multiplication_expression] = STATE(178),
    [sym_cast_expression] = STATE(178),
    [sym_primary] = STATE(178),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(471),
    [sym_block_statement] = STATE(471),
    [sym_expression_statement] = STATE(471),
    [sym__expression] = STATE(178),
    [sym_comparison_expression] = STATE(178),
    [sym_addition_expression] = STATE(178),
    [sym_when_statement] = STATE(471),
    [sym_for_statement] = STATE(471),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(178),
    [sym_unary_expression] = STATE(178),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(536),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(328),
    [anon_sym_return] = ACTIONS(330),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [473] = {
    [anon_sym_RBRACE] = ACTIONS(786),
    [anon_sym_false] = ACTIONS(788),
    [anon_sym_LBRACK] = ACTIONS(786),
    [anon_sym_BANG] = ACTIONS(786),
    [aux_sym_number_token1] = ACTIONS(786),
    [anon_sym_else] = ACTIONS(788),
    [aux_sym_identifier_token1] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(786),
    [anon_sym_DASH] = ACTIONS(786),
    [anon_sym_LBRACE] = ACTIONS(786),
    [anon_sym_true] = ACTIONS(788),
  },
  [474] = {
    [anon_sym_RBRACE] = ACTIONS(862),
  },
  [475] = {
    [anon_sym_RBRACE] = ACTIONS(814),
    [anon_sym_false] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(814),
    [aux_sym_number_token1] = ACTIONS(814),
    [anon_sym_else] = ACTIONS(816),
    [aux_sym_identifier_token1] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_true] = ACTIONS(816),
  },
  [476] = {
    [anon_sym_in] = ACTIONS(864),
  },
  [477] = {
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(217),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(221),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(221),
    [anon_sym_EQ_EQ] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(866),
  },
  [478] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(422),
    [sym__statement] = STATE(422),
    [sym_assignment] = STATE(19),
    [sym_function_call] = STATE(19),
    [sym_multiplication_expression] = STATE(19),
    [sym_cast_expression] = STATE(19),
    [sym_primary] = STATE(19),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(422),
    [sym_block_statement] = STATE(422),
    [sym_expression_statement] = STATE(422),
    [sym__expression] = STATE(19),
    [sym_comparison_expression] = STATE(19),
    [sym_addition_expression] = STATE(19),
    [sym_when_statement] = STATE(422),
    [sym_for_statement] = STATE(422),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(19),
    [sym_unary_expression] = STATE(19),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(663),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(665),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [479] = {
    [anon_sym_RBRACE] = ACTIONS(822),
    [anon_sym_false] = ACTIONS(824),
    [anon_sym_BANG] = ACTIONS(822),
    [anon_sym_fun] = ACTIONS(824),
    [anon_sym_when] = ACTIONS(824),
    [anon_sym_LBRACE] = ACTIONS(822),
    [anon_sym_true] = ACTIONS(824),
    [anon_sym_return] = ACTIONS(824),
    [anon_sym_let] = ACTIONS(824),
    [ts_builtin_sym_end] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(822),
    [aux_sym_number_token1] = ACTIONS(822),
    [anon_sym_for] = ACTIONS(824),
    [anon_sym_else] = ACTIONS(824),
    [anon_sym_while] = ACTIONS(824),
    [anon_sym_var] = ACTIONS(824),
    [anon_sym_LPAREN] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [aux_sym_identifier_token1] = ACTIONS(824),
  },
  [480] = {
    [anon_sym_RBRACE] = ACTIONS(822),
    [anon_sym_false] = ACTIONS(824),
    [anon_sym_LBRACK] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(822),
    [aux_sym_number_token1] = ACTIONS(822),
    [anon_sym_else] = ACTIONS(824),
    [aux_sym_identifier_token1] = ACTIONS(824),
    [anon_sym_LPAREN] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_LBRACE] = ACTIONS(822),
    [anon_sym_true] = ACTIONS(824),
  },
  [481] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(438),
    [sym__statement] = STATE(438),
    [sym_assignment] = STATE(178),
    [sym_function_call] = STATE(178),
    [sym_multiplication_expression] = STATE(178),
    [sym_cast_expression] = STATE(178),
    [sym_primary] = STATE(178),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(438),
    [sym_block_statement] = STATE(438),
    [sym_expression_statement] = STATE(438),
    [sym__expression] = STATE(178),
    [sym_comparison_expression] = STATE(178),
    [sym_addition_expression] = STATE(178),
    [sym_when_statement] = STATE(438),
    [sym_for_statement] = STATE(438),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(178),
    [sym_unary_expression] = STATE(178),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(830),
    [anon_sym_for] = ACTIONS(832),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(836),
    [anon_sym_return] = ACTIONS(330),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [482] = {
    [sym_function_literal] = STATE(29),
    [sym_map_literal] = STATE(29),
    [sym_parenthetical_expression] = STATE(29),
    [sym_assignment] = STATE(484),
    [sym_function_call] = STATE(484),
    [sym_multiplication_expression] = STATE(484),
    [sym_cast_expression] = STATE(484),
    [sym_primary] = STATE(484),
    [sym_list_literal] = STATE(29),
    [sym__expression] = STATE(484),
    [sym_comparison_expression] = STATE(484),
    [sym_addition_expression] = STATE(484),
    [sym_identifier] = STATE(126),
    [sym_number] = STATE(29),
    [sym_range_literal] = STATE(484),
    [sym_unary_expression] = STATE(484),
    [sym_bool_literal] = STATE(29),
    [anon_sym_false] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_identifier_token1] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(37),
  },
  [483] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(440),
    [sym__statement] = STATE(440),
    [sym_assignment] = STATE(178),
    [sym_function_call] = STATE(178),
    [sym_multiplication_expression] = STATE(178),
    [sym_cast_expression] = STATE(178),
    [sym_primary] = STATE(178),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(440),
    [sym_block_statement] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym__expression] = STATE(178),
    [sym_comparison_expression] = STATE(178),
    [sym_addition_expression] = STATE(178),
    [sym_when_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(178),
    [sym_unary_expression] = STATE(178),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(830),
    [anon_sym_for] = ACTIONS(832),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(836),
    [anon_sym_return] = ACTIONS(330),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
  [484] = {
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(217),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(221),
    [anon_sym_as] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(221),
    [anon_sym_EQ_EQ] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(868),
  },
  [485] = {
    [sym_function_literal] = STATE(16),
    [sym_map_literal] = STATE(16),
    [sym_parenthetical_expression] = STATE(16),
    [sym_return_statement] = STATE(471),
    [sym__statement] = STATE(471),
    [sym_assignment] = STATE(178),
    [sym_function_call] = STATE(178),
    [sym_multiplication_expression] = STATE(178),
    [sym_cast_expression] = STATE(178),
    [sym_primary] = STATE(178),
    [sym_list_literal] = STATE(16),
    [sym_while_statement] = STATE(471),
    [sym_block_statement] = STATE(471),
    [sym_expression_statement] = STATE(471),
    [sym__expression] = STATE(178),
    [sym_comparison_expression] = STATE(178),
    [sym_addition_expression] = STATE(178),
    [sym_when_statement] = STATE(471),
    [sym_for_statement] = STATE(471),
    [sym_identifier] = STATE(20),
    [sym_number] = STATE(16),
    [sym_range_literal] = STATE(178),
    [sym_unary_expression] = STATE(178),
    [sym_bool_literal] = STATE(16),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_when] = ACTIONS(830),
    [anon_sym_for] = ACTIONS(832),
    [aux_sym_identifier_token1] = ACTIONS(25),
    [anon_sym_while] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_DASH] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(836),
    [anon_sym_return] = ACTIONS(330),
    [anon_sym_true] = ACTIONS(3),
    [aux_sym_number_token1] = ACTIONS(21),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, SHIFT(2),
  [5] = {.count = 1, .reusable = false}, SHIFT(3),
  [7] = {.count = 1, .reusable = false}, SHIFT(4),
  [9] = {.count = 1, .reusable = true}, SHIFT(5),
  [11] = {.count = 1, .reusable = true}, SHIFT(6),
  [13] = {.count = 1, .reusable = false}, SHIFT(7),
  [15] = {.count = 1, .reusable = false}, SHIFT(8),
  [17] = {.count = 1, .reusable = true}, REDUCE(sym_source_file, 0),
  [19] = {.count = 1, .reusable = true}, SHIFT(9),
  [21] = {.count = 1, .reusable = true}, SHIFT(10),
  [23] = {.count = 1, .reusable = false}, SHIFT(11),
  [25] = {.count = 1, .reusable = false}, SHIFT(12),
  [27] = {.count = 1, .reusable = false}, SHIFT(13),
  [29] = {.count = 1, .reusable = true}, SHIFT(14),
  [31] = {.count = 1, .reusable = false}, REDUCE(sym_bool_literal, 1),
  [33] = {.count = 1, .reusable = true}, REDUCE(sym_bool_literal, 1),
  [35] = {.count = 1, .reusable = true}, SHIFT(21),
  [37] = {.count = 1, .reusable = false}, SHIFT(23),
  [39] = {.count = 1, .reusable = true}, SHIFT(24),
  [41] = {.count = 1, .reusable = true}, SHIFT(25),
  [43] = {.count = 1, .reusable = true}, SHIFT(26),
  [45] = {.count = 1, .reusable = false}, SHIFT(21),
  [47] = {.count = 1, .reusable = true}, SHIFT(27),
  [49] = {.count = 1, .reusable = true}, SHIFT(28),
  [51] = {.count = 1, .reusable = true}, SHIFT(33),
  [53] = {.count = 1, .reusable = true}, SHIFT(34),
  [55] = {.count = 1, .reusable = true}, SHIFT(36),
  [57] = {.count = 1, .reusable = false}, SHIFT(37),
  [59] = {.count = 1, .reusable = false}, SHIFT(38),
  [61] = {.count = 1, .reusable = false}, SHIFT(39),
  [63] = {.count = 1, .reusable = true}, SHIFT(12),
  [65] = {.count = 1, .reusable = true}, SHIFT(46),
  [67] = {.count = 1, .reusable = true}, SHIFT(47),
  [69] = {.count = 1, .reusable = true}, SHIFT(48),
  [71] = {.count = 1, .reusable = false}, REDUCE(sym_number, 1),
  [73] = {.count = 1, .reusable = true}, REDUCE(sym_number, 1),
  [75] = {.count = 1, .reusable = true}, SHIFT(51),
  [77] = {.count = 1, .reusable = false}, REDUCE(sym_identifier, 1),
  [79] = {.count = 1, .reusable = true}, REDUCE(sym_identifier, 1),
  [81] = {.count = 1, .reusable = true}, SHIFT(52),
  [83] = {.count = 1, .reusable = true}, SHIFT(53),
  [85] = {.count = 1, .reusable = true}, SHIFT(58),
  [87] = {.count = 1, .reusable = false}, REDUCE(sym_primary, 1),
  [89] = {.count = 1, .reusable = true}, REDUCE(sym_primary, 1),
  [91] = {.count = 1, .reusable = true}, REDUCE(sym_source_file, 1),
  [93] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [95] = {.count = 1, .reusable = false}, SHIFT(60),
  [97] = {.count = 1, .reusable = false}, SHIFT(61),
  [99] = {.count = 1, .reusable = false}, SHIFT(62),
  [101] = {.count = 1, .reusable = false}, SHIFT(63),
  [103] = {.count = 1, .reusable = true}, SHIFT(64),
  [105] = {.count = 1, .reusable = false}, SHIFT(65),
  [107] = {.count = 1, .reusable = false}, SHIFT(66),
  [109] = {.count = 1, .reusable = true}, SHIFT(67),
  [111] = {.count = 1, .reusable = true}, SHIFT(69),
  [113] = {.count = 1, .reusable = true}, SHIFT(71),
  [115] = {.count = 1, .reusable = true}, SHIFT(73),
  [117] = {.count = 1, .reusable = true}, SHIFT(76),
  [119] = {.count = 1, .reusable = false}, SHIFT(80),
  [121] = {.count = 1, .reusable = true}, SHIFT(80),
  [123] = {.count = 1, .reusable = true}, SHIFT(81),
  [125] = {.count = 1, .reusable = true}, SHIFT(82),
  [127] = {.count = 1, .reusable = true}, SHIFT(83),
  [129] = {.count = 1, .reusable = true}, SHIFT(84),
  [131] = {.count = 1, .reusable = false}, SHIFT(85),
  [133] = {.count = 1, .reusable = true}, SHIFT(86),
  [135] = {.count = 1, .reusable = false}, REDUCE(sym_when_statement, 2),
  [137] = {.count = 1, .reusable = true}, REDUCE(sym_when_statement, 2),
  [139] = {.count = 1, .reusable = false}, SHIFT(87),
  [141] = {.count = 1, .reusable = true}, SHIFT(91),
  [143] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2),
  [145] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2),
  [147] = {.count = 1, .reusable = false}, REDUCE(sym_map_literal, 2),
  [149] = {.count = 1, .reusable = false}, REDUCE(sym_block_statement, 2),
  [151] = {.count = 1, .reusable = true}, REDUCE(sym_map_literal, 2),
  [153] = {.count = 1, .reusable = true}, REDUCE(sym_block_statement, 2),
  [155] = {.count = 1, .reusable = true}, SHIFT(95),
  [157] = {.count = 1, .reusable = true}, SHIFT(96),
  [159] = {.count = 1, .reusable = false}, SHIFT(97),
  [161] = {.count = 1, .reusable = false}, SHIFT(98),
  [163] = {.count = 1, .reusable = false}, SHIFT(99),
  [165] = {.count = 1, .reusable = false}, SHIFT(100),
  [167] = {.count = 1, .reusable = true}, SHIFT(101),
  [169] = {.count = 1, .reusable = false}, SHIFT(103),
  [171] = {.count = 1, .reusable = false}, SHIFT(104),
  [173] = {.count = 1, .reusable = false}, SHIFT(105),
  [175] = {.count = 1, .reusable = false}, SHIFT(106),
  [177] = {.count = 1, .reusable = false}, SHIFT(107),
  [179] = {.count = 1, .reusable = true}, SHIFT(108),
  [181] = {.count = 1, .reusable = false}, SHIFT(110),
  [183] = {.count = 1, .reusable = false}, SHIFT(111),
  [185] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 2),
  [187] = {.count = 1, .reusable = false}, SHIFT(112),
  [189] = {.count = 1, .reusable = false}, REDUCE(sym_list_literal, 2),
  [191] = {.count = 1, .reusable = true}, REDUCE(sym_list_literal, 2),
  [193] = {.count = 1, .reusable = false}, SHIFT(115),
  [195] = {.count = 1, .reusable = true}, SHIFT(116),
  [197] = {.count = 1, .reusable = true}, SHIFT(117),
  [199] = {.count = 1, .reusable = true}, SHIFT(118),
  [201] = {.count = 1, .reusable = true}, SHIFT(119),
  [203] = {.count = 1, .reusable = true}, SHIFT(115),
  [205] = {.count = 1, .reusable = true}, SHIFT(120),
  [207] = {.count = 1, .reusable = false}, SHIFT(122),
  [209] = {.count = 1, .reusable = true}, SHIFT(123),
  [211] = {.count = 1, .reusable = true}, SHIFT(127),
  [213] = {.count = 1, .reusable = true}, SHIFT(128),
  [215] = {.count = 1, .reusable = false}, SHIFT(130),
  [217] = {.count = 1, .reusable = true}, SHIFT(130),
  [219] = {.count = 1, .reusable = true}, SHIFT(131),
  [221] = {.count = 1, .reusable = true}, SHIFT(133),
  [223] = {.count = 1, .reusable = true}, SHIFT(132),
  [225] = {.count = 1, .reusable = true}, SHIFT(134),
  [227] = {.count = 1, .reusable = true}, SHIFT(135),
  [229] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_list, 1),
  [231] = {.count = 1, .reusable = true}, SHIFT(138),
  [233] = {.count = 1, .reusable = false}, SHIFT(137),
  [235] = {.count = 1, .reusable = true}, REDUCE(sym__declaration, 2),
  [237] = {.count = 1, .reusable = false}, REDUCE(sym__declaration, 2),
  [239] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2),
  [242] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(3),
  [245] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4),
  [248] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5),
  [251] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(6),
  [254] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(7),
  [257] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(8),
  [260] = {.count = 1, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2),
  [262] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(9),
  [265] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(10),
  [268] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(11),
  [271] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(12),
  [274] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(13),
  [277] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(14),
  [280] = {.count = 1, .reusable = true}, SHIFT(142),
  [282] = {.count = 1, .reusable = true}, SHIFT(143),
  [284] = {.count = 1, .reusable = true}, SHIFT(144),
  [286] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [288] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 2),
  [290] = {.count = 1, .reusable = true}, SHIFT(147),
  [292] = {.count = 1, .reusable = true}, SHIFT(151),
  [294] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 3),
  [296] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 3),
  [298] = {.count = 1, .reusable = true}, SHIFT(154),
  [300] = {.count = 1, .reusable = true}, SHIFT(155),
  [302] = {.count = 1, .reusable = true}, SHIFT(156),
  [304] = {.count = 1, .reusable = true}, SHIFT(159),
  [306] = {.count = 1, .reusable = true}, SHIFT(160),
  [308] = {.count = 1, .reusable = true}, SHIFT(162),
  [310] = {.count = 1, .reusable = true}, SHIFT(163),
  [312] = {.count = 1, .reusable = true}, REDUCE(sym_clause_list, 1),
  [314] = {.count = 1, .reusable = false}, REDUCE(sym_clause_list, 1),
  [316] = {.count = 1, .reusable = true}, SHIFT(166),
  [318] = {.count = 1, .reusable = true}, SHIFT(167),
  [320] = {.count = 1, .reusable = true}, SHIFT(168),
  [322] = {.count = 1, .reusable = false}, SHIFT(172),
  [324] = {.count = 1, .reusable = false}, SHIFT(173),
  [326] = {.count = 1, .reusable = false}, SHIFT(174),
  [328] = {.count = 1, .reusable = true}, SHIFT(175),
  [330] = {.count = 1, .reusable = false}, SHIFT(176),
  [332] = {.count = 1, .reusable = true}, SHIFT(180),
  [334] = {.count = 1, .reusable = true}, SHIFT(181),
  [336] = {.count = 1, .reusable = true}, SHIFT(182),
  [338] = {.count = 1, .reusable = true}, SHIFT(185),
  [340] = {.count = 1, .reusable = true}, SHIFT(187),
  [342] = {.count = 1, .reusable = true}, REDUCE(sym_when_statement, 3),
  [344] = {.count = 1, .reusable = false}, REDUCE(sym_when_statement, 3),
  [346] = {.count = 1, .reusable = false}, SHIFT(188),
  [348] = {.count = 1, .reusable = true}, SHIFT(188),
  [350] = {.count = 1, .reusable = true}, SHIFT(189),
  [352] = {.count = 1, .reusable = true}, SHIFT(190),
  [354] = {.count = 1, .reusable = false}, SHIFT(191),
  [356] = {.count = 1, .reusable = true}, SHIFT(99),
  [358] = {.count = 1, .reusable = true}, SHIFT(192),
  [360] = {.count = 1, .reusable = false}, SHIFT(193),
  [362] = {.count = 1, .reusable = true}, REDUCE(sym_block_statement, 3),
  [364] = {.count = 1, .reusable = false}, REDUCE(sym_block_statement, 3),
  [366] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(37),
  [369] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(38),
  [372] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(39),
  [375] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 3),
  [377] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 3),
  [379] = {.count = 1, .reusable = true}, SHIFT(204),
  [381] = {.count = 1, .reusable = true}, SHIFT(209),
  [383] = {.count = 1, .reusable = true}, SHIFT(210),
  [385] = {.count = 1, .reusable = true}, SHIFT(212),
  [387] = {.count = 1, .reusable = false}, REDUCE(sym_list_literal, 3),
  [389] = {.count = 1, .reusable = true}, REDUCE(sym_list_literal, 3),
  [391] = {.count = 1, .reusable = true}, SHIFT(217),
  [393] = {.count = 1, .reusable = true}, SHIFT(221),
  [395] = {.count = 1, .reusable = true}, SHIFT(222),
  [397] = {.count = 1, .reusable = true}, SHIFT(223),
  [399] = {.count = 1, .reusable = false}, REDUCE(sym_function_literal, 3),
  [401] = {.count = 1, .reusable = true}, REDUCE(sym_function_literal, 3),
  [403] = {.count = 1, .reusable = false}, REDUCE(sym_parenthetical_expression, 3),
  [405] = {.count = 1, .reusable = true}, REDUCE(sym_parenthetical_expression, 3),
  [407] = {.count = 1, .reusable = true}, SHIFT(229),
  [409] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_list, 2),
  [411] = {.count = 1, .reusable = false}, REDUCE(sym_comparison_expression, 3),
  [413] = {.count = 1, .reusable = true}, REDUCE(sym_comparison_expression, 3),
  [415] = {.count = 1, .reusable = false}, REDUCE(sym_multiplication_expression, 3),
  [417] = {.count = 1, .reusable = true}, REDUCE(sym_multiplication_expression, 3),
  [419] = {.count = 1, .reusable = false}, REDUCE(sym_addition_expression, 3),
  [421] = {.count = 1, .reusable = true}, REDUCE(sym_addition_expression, 3),
  [423] = {.count = 1, .reusable = false}, REDUCE(sym_primitive_type, 1),
  [425] = {.count = 1, .reusable = true}, REDUCE(sym_primitive_type, 1),
  [427] = {.count = 1, .reusable = false}, REDUCE(sym_cast_expression, 3),
  [429] = {.count = 1, .reusable = true}, REDUCE(sym_cast_expression, 3),
  [431] = {.count = 1, .reusable = true}, REDUCE(sym_assignment, 3),
  [433] = {.count = 1, .reusable = false}, REDUCE(sym_function_call, 3),
  [435] = {.count = 1, .reusable = true}, REDUCE(sym_function_call, 3),
  [437] = {.count = 1, .reusable = false}, SHIFT(237),
  [439] = {.count = 1, .reusable = true}, SHIFT(237),
  [441] = {.count = 1, .reusable = true}, SHIFT(238),
  [443] = {.count = 1, .reusable = true}, SHIFT(239),
  [445] = {.count = 1, .reusable = true}, SHIFT(240),
  [447] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 1),
  [449] = {.count = 1, .reusable = false}, SHIFT(242),
  [451] = {.count = 1, .reusable = true}, SHIFT(243),
  [453] = {.count = 1, .reusable = true}, SHIFT(244),
  [455] = {.count = 1, .reusable = true}, SHIFT(245),
  [457] = {.count = 1, .reusable = true}, SHIFT(247),
  [459] = {.count = 1, .reusable = true}, SHIFT(248),
  [461] = {.count = 1, .reusable = true}, SHIFT(250),
  [463] = {.count = 1, .reusable = true}, SHIFT(251),
  [465] = {.count = 1, .reusable = true}, SHIFT(254),
  [467] = {.count = 1, .reusable = true}, SHIFT(255),
  [469] = {.count = 1, .reusable = true}, REDUCE(aux_sym_clause_list_repeat1, 2),
  [471] = {.count = 2, .reusable = false}, REDUCE(aux_sym_clause_list_repeat1, 2), SHIFT_REPEAT(23),
  [474] = {.count = 2, .reusable = true}, REDUCE(aux_sym_clause_list_repeat1, 2), SHIFT_REPEAT(24),
  [477] = {.count = 2, .reusable = true}, REDUCE(aux_sym_clause_list_repeat1, 2), SHIFT_REPEAT(25),
  [480] = {.count = 2, .reusable = true}, REDUCE(aux_sym_clause_list_repeat1, 2), SHIFT_REPEAT(26),
  [483] = {.count = 1, .reusable = false}, REDUCE(aux_sym_clause_list_repeat1, 2),
  [485] = {.count = 2, .reusable = false}, REDUCE(aux_sym_clause_list_repeat1, 2), SHIFT_REPEAT(21),
  [488] = {.count = 2, .reusable = true}, REDUCE(aux_sym_clause_list_repeat1, 2), SHIFT_REPEAT(47),
  [491] = {.count = 2, .reusable = true}, REDUCE(aux_sym_clause_list_repeat1, 2), SHIFT_REPEAT(48),
  [494] = {.count = 1, .reusable = true}, SHIFT(257),
  [496] = {.count = 1, .reusable = false}, SHIFT(258),
  [498] = {.count = 1, .reusable = false}, SHIFT(259),
  [500] = {.count = 1, .reusable = false}, SHIFT(260),
  [502] = {.count = 1, .reusable = true}, SHIFT(261),
  [504] = {.count = 1, .reusable = false}, SHIFT(262),
  [506] = {.count = 1, .reusable = true}, REDUCE(sym_when_statement, 4),
  [508] = {.count = 1, .reusable = false}, REDUCE(sym_when_statement, 4),
  [510] = {.count = 1, .reusable = true}, SHIFT(266),
  [512] = {.count = 1, .reusable = true}, SHIFT(267),
  [514] = {.count = 1, .reusable = true}, SHIFT(268),
  [516] = {.count = 1, .reusable = true}, SHIFT(269),
  [518] = {.count = 1, .reusable = true}, SHIFT(271),
  [520] = {.count = 1, .reusable = true}, SHIFT(272),
  [522] = {.count = 1, .reusable = true}, SHIFT(273),
  [524] = {.count = 1, .reusable = true}, REDUCE(sym_clause_result, 3),
  [526] = {.count = 1, .reusable = false}, REDUCE(sym_clause_result, 3),
  [528] = {.count = 1, .reusable = true}, SHIFT(276),
  [530] = {.count = 1, .reusable = true}, SHIFT(279),
  [532] = {.count = 1, .reusable = false}, SHIFT(284),
  [534] = {.count = 1, .reusable = false}, SHIFT(285),
  [536] = {.count = 1, .reusable = false}, SHIFT(286),
  [538] = {.count = 1, .reusable = true}, SHIFT(287),
  [540] = {.count = 1, .reusable = true}, SHIFT(288),
  [542] = {.count = 1, .reusable = true}, SHIFT(289),
  [544] = {.count = 1, .reusable = false}, SHIFT(290),
  [546] = {.count = 1, .reusable = true}, SHIFT(290),
  [548] = {.count = 1, .reusable = true}, SHIFT(291),
  [550] = {.count = 1, .reusable = true}, SHIFT(292),
  [552] = {.count = 1, .reusable = true}, SHIFT(293),
  [554] = {.count = 1, .reusable = true}, SHIFT(294),
  [556] = {.count = 1, .reusable = false}, SHIFT(296),
  [558] = {.count = 1, .reusable = false}, REDUCE(sym_assignment, 3),
  [560] = {.count = 1, .reusable = false}, REDUCE(aux_sym_return_statement_repeat1, 2),
  [562] = {.count = 1, .reusable = true}, REDUCE(aux_sym_return_statement_repeat1, 2),
  [564] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 4),
  [566] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 4),
  [568] = {.count = 2, .reusable = false}, REDUCE(aux_sym_return_statement_repeat1, 2), SHIFT_REPEAT(105),
  [571] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 4),
  [573] = {.count = 1, .reusable = false}, SHIFT(297),
  [575] = {.count = 1, .reusable = false}, REDUCE(sym_list_literal, 4),
  [577] = {.count = 1, .reusable = true}, REDUCE(sym_list_literal, 4),
  [579] = {.count = 1, .reusable = false}, SHIFT(299),
  [581] = {.count = 1, .reusable = true}, SHIFT(299),
  [583] = {.count = 1, .reusable = true}, SHIFT(300),
  [585] = {.count = 1, .reusable = true}, SHIFT(301),
  [587] = {.count = 1, .reusable = true}, SHIFT(302),
  [589] = {.count = 1, .reusable = false}, SHIFT(303),
  [591] = {.count = 1, .reusable = true}, SHIFT(304),
  [593] = {.count = 2, .reusable = true}, REDUCE(aux_sym_return_statement_repeat1, 2), SHIFT_REPEAT(305),
  [596] = {.count = 1, .reusable = true}, SHIFT(306),
  [598] = {.count = 1, .reusable = true}, SHIFT(307),
  [600] = {.count = 1, .reusable = true}, SHIFT(310),
  [602] = {.count = 1, .reusable = true}, REDUCE(sym_type_list, 1),
  [604] = {.count = 1, .reusable = true}, SHIFT(312),
  [606] = {.count = 1, .reusable = false}, REDUCE(sym_function_literal, 4),
  [608] = {.count = 1, .reusable = true}, REDUCE(sym_function_literal, 4),
  [610] = {.count = 1, .reusable = true}, REDUCE(aux_sym_parameter_list_repeat1, 2),
  [612] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameter_list_repeat1, 2), SHIFT_REPEAT(135),
  [615] = {.count = 1, .reusable = true}, REDUCE(sym_parameter, 3),
  [617] = {.count = 1, .reusable = true}, SHIFT(315),
  [619] = {.count = 1, .reusable = true}, SHIFT(316),
  [621] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 2),
  [623] = {.count = 1, .reusable = false}, REDUCE(sym_function_call, 4),
  [625] = {.count = 1, .reusable = true}, REDUCE(sym_function_call, 4),
  [627] = {.count = 1, .reusable = true}, SHIFT(322),
  [629] = {.count = 1, .reusable = true}, SHIFT(324),
  [631] = {.count = 1, .reusable = true}, SHIFT(326),
  [633] = {.count = 1, .reusable = true}, SHIFT(327),
  [635] = {.count = 1, .reusable = true}, SHIFT(328),
  [637] = {.count = 1, .reusable = true}, SHIFT(333),
  [639] = {.count = 1, .reusable = true}, SHIFT(334),
  [641] = {.count = 1, .reusable = true}, SHIFT(336),
  [643] = {.count = 1, .reusable = true}, SHIFT(337),
  [645] = {.count = 1, .reusable = true}, SHIFT(338),
  [647] = {.count = 1, .reusable = false}, SHIFT(341),
  [649] = {.count = 1, .reusable = false}, SHIFT(342),
  [651] = {.count = 1, .reusable = false}, SHIFT(291),
  [653] = {.count = 1, .reusable = false}, SHIFT(343),
  [655] = {.count = 1, .reusable = false}, SHIFT(344),
  [657] = {.count = 1, .reusable = true}, SHIFT(345),
  [659] = {.count = 1, .reusable = false}, SHIFT(347),
  [661] = {.count = 1, .reusable = false}, SHIFT(348),
  [663] = {.count = 1, .reusable = false}, SHIFT(349),
  [665] = {.count = 1, .reusable = false}, SHIFT(350),
  [667] = {.count = 1, .reusable = true}, SHIFT(351),
  [669] = {.count = 1, .reusable = true}, REDUCE(sym_when_statement, 5),
  [671] = {.count = 1, .reusable = false}, REDUCE(sym_when_statement, 5),
  [673] = {.count = 1, .reusable = true}, SHIFT(357),
  [675] = {.count = 1, .reusable = true}, SHIFT(358),
  [677] = {.count = 1, .reusable = true}, SHIFT(360),
  [679] = {.count = 1, .reusable = true}, SHIFT(361),
  [681] = {.count = 1, .reusable = true}, REDUCE(sym_else_result, 3),
  [683] = {.count = 1, .reusable = false}, REDUCE(sym_else_result, 3),
  [685] = {.count = 1, .reusable = true}, SHIFT(362),
  [687] = {.count = 1, .reusable = true}, SHIFT(363),
  [689] = {.count = 1, .reusable = false}, REDUCE(sym_map_literal, 5),
  [691] = {.count = 1, .reusable = true}, REDUCE(sym_map_literal, 5),
  [693] = {.count = 1, .reusable = true}, SHIFT(368),
  [695] = {.count = 1, .reusable = true}, SHIFT(342),
  [697] = {.count = 1, .reusable = false}, REDUCE(sym_range_literal, 5),
  [699] = {.count = 1, .reusable = true}, REDUCE(sym_range_literal, 5),
  [701] = {.count = 1, .reusable = false}, REDUCE(sym_list_literal, 5),
  [703] = {.count = 1, .reusable = true}, REDUCE(sym_list_literal, 5),
  [705] = {.count = 1, .reusable = true}, SHIFT(378),
  [707] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 5),
  [709] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 5),
  [711] = {.count = 1, .reusable = false}, REDUCE(sym_function_literal, 5),
  [713] = {.count = 1, .reusable = true}, REDUCE(sym_function_literal, 5),
  [715] = {.count = 1, .reusable = true}, REDUCE(sym_type_list, 2),
  [717] = {.count = 1, .reusable = false}, REDUCE(sym_list_type, 3),
  [719] = {.count = 1, .reusable = true}, REDUCE(sym_list_type, 3),
  [721] = {.count = 2, .reusable = true}, REDUCE(aux_sym_return_statement_repeat1, 2), SHIFT_REPEAT(238),
  [724] = {.count = 1, .reusable = true}, SHIFT(385),
  [726] = {.count = 1, .reusable = true}, SHIFT(393),
  [728] = {.count = 1, .reusable = true}, SHIFT(394),
  [730] = {.count = 1, .reusable = true}, SHIFT(398),
  [732] = {.count = 1, .reusable = true}, SHIFT(402),
  [734] = {.count = 1, .reusable = true}, SHIFT(403),
  [736] = {.count = 1, .reusable = true}, SHIFT(404),
  [738] = {.count = 1, .reusable = true}, SHIFT(405),
  [740] = {.count = 1, .reusable = true}, SHIFT(406),
  [742] = {.count = 1, .reusable = true}, SHIFT(409),
  [744] = {.count = 1, .reusable = true}, SHIFT(410),
  [746] = {.count = 1, .reusable = true}, SHIFT(411),
  [748] = {.count = 1, .reusable = true}, SHIFT(415),
  [750] = {.count = 1, .reusable = true}, SHIFT(416),
  [752] = {.count = 1, .reusable = false}, REDUCE(sym_map_literal, 6),
  [754] = {.count = 1, .reusable = true}, REDUCE(sym_map_literal, 6),
  [756] = {.count = 1, .reusable = true}, REDUCE(aux_sym_map_literal_repeat1, 2),
  [758] = {.count = 2, .reusable = true}, REDUCE(aux_sym_map_literal_repeat1, 2), SHIFT_REPEAT(291),
  [761] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 6),
  [763] = {.count = 1, .reusable = false}, SHIFT(417),
  [765] = {.count = 1, .reusable = true}, SHIFT(417),
  [767] = {.count = 1, .reusable = true}, SHIFT(418),
  [769] = {.count = 1, .reusable = true}, SHIFT(419),
  [771] = {.count = 1, .reusable = false}, SHIFT(420),
  [773] = {.count = 1, .reusable = true}, SHIFT(421),
  [775] = {.count = 1, .reusable = true}, REDUCE(aux_sym_type_list_repeat1, 2),
  [777] = {.count = 2, .reusable = true}, REDUCE(aux_sym_type_list_repeat1, 2), SHIFT_REPEAT(312),
  [780] = {.count = 1, .reusable = false}, REDUCE(sym_function_literal, 6),
  [782] = {.count = 1, .reusable = true}, REDUCE(sym_function_literal, 6),
  [784] = {.count = 1, .reusable = true}, SHIFT(423),
  [786] = {.count = 1, .reusable = true}, REDUCE(sym_when_statement, 7),
  [788] = {.count = 1, .reusable = false}, REDUCE(sym_when_statement, 7),
  [790] = {.count = 1, .reusable = true}, SHIFT(425),
  [792] = {.count = 1, .reusable = true}, SHIFT(426),
  [794] = {.count = 1, .reusable = true}, SHIFT(427),
  [796] = {.count = 1, .reusable = true}, SHIFT(430),
  [798] = {.count = 1, .reusable = true}, SHIFT(431),
  [800] = {.count = 1, .reusable = true}, SHIFT(432),
  [802] = {.count = 1, .reusable = true}, SHIFT(433),
  [804] = {.count = 1, .reusable = true}, SHIFT(436),
  [806] = {.count = 1, .reusable = true}, SHIFT(437),
  [808] = {.count = 1, .reusable = true}, SHIFT(441),
  [810] = {.count = 1, .reusable = true}, SHIFT(443),
  [812] = {.count = 1, .reusable = true}, SHIFT(444),
  [814] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7),
  [816] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7),
  [818] = {.count = 1, .reusable = false}, REDUCE(sym_map_type, 5),
  [820] = {.count = 1, .reusable = true}, REDUCE(sym_map_type, 5),
  [822] = {.count = 1, .reusable = true}, REDUCE(sym_when_statement, 8),
  [824] = {.count = 1, .reusable = false}, REDUCE(sym_when_statement, 8),
  [826] = {.count = 1, .reusable = true}, SHIFT(450),
  [828] = {.count = 1, .reusable = true}, SHIFT(451),
  [830] = {.count = 1, .reusable = false}, SHIFT(455),
  [832] = {.count = 1, .reusable = false}, SHIFT(456),
  [834] = {.count = 1, .reusable = false}, SHIFT(457),
  [836] = {.count = 1, .reusable = true}, SHIFT(458),
  [838] = {.count = 1, .reusable = true}, SHIFT(459),
  [840] = {.count = 1, .reusable = true}, SHIFT(460),
  [842] = {.count = 1, .reusable = true}, SHIFT(462),
  [844] = {.count = 1, .reusable = true}, REDUCE(aux_sym_map_literal_repeat1, 4),
  [846] = {.count = 1, .reusable = true}, SHIFT(465),
  [848] = {.count = 1, .reusable = true}, SHIFT(466),
  [850] = {.count = 1, .reusable = true}, SHIFT(467),
  [852] = {.count = 1, .reusable = true}, SHIFT(469),
  [854] = {.count = 1, .reusable = true}, SHIFT(472),
  [856] = {.count = 1, .reusable = true}, SHIFT(473),
  [858] = {.count = 1, .reusable = true}, SHIFT(478),
  [860] = {.count = 1, .reusable = true}, SHIFT(479),
  [862] = {.count = 1, .reusable = true}, SHIFT(480),
  [864] = {.count = 1, .reusable = true}, SHIFT(482),
  [866] = {.count = 1, .reusable = true}, SHIFT(483),
  [868] = {.count = 1, .reusable = true}, SHIFT(485),
};

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_MooLang() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
  };
  return &language;
}
